AC_DEFUN([WITH_MYSQL], [ 
  AC_MSG_CHECKING(for mysql_config executable)

  AC_ARG_WITH(mysql, [  --with-mysql=PATH path to mysql_config binary or mysql prefix dir], [
  if test -x $withval -a -f $withval
    then
      MYSQL_CONFIG=$withval
    elif test -x $withval/bin/mysql_config -a -f $withval/bin/mysql_config
    then 
     MYSQL_CONFIG=$withval/bin/mysql_config
    elif test -x /usr/local/bin/mysql_config -a -f /usr/local/bin/mysql_config
    then 
     MYSQL_CONFIG=/usr/local/bin/mysql_config
    fi

    if test "x$MYSQL_CONFIG" = "x"
    then
      AC_MSG_RESULT(not found)
      exit 3
    fi
  ], [
    AC_MSG_RESULT(not enabled)
    MYSQL_CFLAGS=
    MYSQL_LDFLAGS=
  ])

  if test "x$MYSQL_CONFIG" = "x"
  then
    AC_MSG_RESULT(not enabled)
    MYSQL_CFLAGS=
    MYSQL_LDFLAGS=
  else
    AC_PROG_CC
    AC_PROG_CXX
 
    # add regular MySQL C flags
    MYSQL_CFLAGS=`$MYSQL_CONFIG --cflags` 

    MYSQL_LDFLAGS="$LDFLAGS "`$MYSQL_CONFIG --libs`" -lmystrings -lmysys"
    MYSQL_LDFLAGS="$LDFLAGS "`$MYSQL_CONFIG --libs`" -lmystrings"
    
    SAVE_CFLAGS=$CFLAGS
    SAVE_LDFLAGS=$LDFLAGS

    CFLAGS=$MYSQL_CFLAGS
    LDFLAGS=$MYSQL_LDFLAGS

    AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#include "mysql.h"]], [[mysql_init(0);]])], [mysql_compile_ok=yes], [mysql_compile_ok=no])

    CFLAGS=$SAVE_CFLAGS
    LDFLAGS=$SAVE_LDFLAGS

    if test "x$mysql_compile_ok" = "xno"; then
      AC_MSG_RESULT(Faild to build using MySQL.  See config.log for details.)
      AC_MSG_RESULT(Make sure the path specified using --with-mysql is correct.)
      exit 3
    fi

    AC_SUBST(MYSQL_CFLAGS)
    AC_SUBST(MYSQL_LDFLAGS)

    AC_MSG_RESULT($MYSQL_CONFIG)
  fi  
])
