#ifndef _GAFUNC_CLASSIC_H
#define _GAFUNC_CLASSIC_H

#define PI 3.1415926535897932384626433832795029L

#ifdef __cplusplus
extern "C" {
#endif
extern double rastrigin(const double *x, int dim);
extern double rosenbrock(const double *x, int dim);
extern double simple_rosenbrock(const double *x, int dim);
extern double griewank(const double *x, int dim);
extern double ridge(const double *x, int dim);
extern double schwefel(const double *x, int dim);
extern double sphere(const double *x, int dim);
extern double weighted_sphere(const double *x, int dim);
extern double step(const double *x, int dim);
extern double quartic(const double *x, int dim);
extern double ackley(const double *x, int dim);
extern double bohachevsky(const double *x, int dim);
extern double rotated_rastrigin(const double *x, int dim);
extern double rotated_schwefel(const double *x, int dim);
extern double rotated_ackley(const double *x, int dim);
extern double rotated_bohachevsky(const double *x, int dim);

extern double *rotate_variable(const double *x, int dim, double arg);
extern double gaussian(double m, double s);
#ifdef __cplusplus
}
#endif

#endif /* !_GAFUNC_CLASSIC_H */
