// Persistence Of Vision raytracer version 3.5 sample file.
// File by Dieter Bayer.
// updated for compatibility with POV-Ray v3.5 by Ken Tyler on 08-26-01

global_settings { assumed_gamma 2.2 }

  #include "colors.inc"
  #include "skies.inc"
  #include "textures.inc"
  #include "shapes.inc"
  #include "golds.inc"
  #include "metals.inc"

  camera {
   location  <0, 40, -170>
   direction <0,  0,    0.7>
   up        <0,  1,    0>
   right   <4/3,  0,    0>
  }

  light_source {<100, 120, -100> colour White}

  sky_sphere { S_Cloud5 }

  plane {
    y,-35
    texture {
      pigment { SeaGreen }
      finish { reflection .35 specular 1 }
      normal { ripples 0.35 turbulence .5 scale 25 }
    }
    rotate <3,0,0>
  }

  union {
    torus{ 0.5, 0.1
      texture{ T_Gold_2A }
      scale     <60.5, 60.5, 60.5>
      translate <0.1, 0.4, 0> }
    torus{ 0.5, 0.12
      texture{ T_Silver_5A }
      scale     <55, 55, 55>
      rotate    <20, 0, 90>
      translate <0.1, 0.4, 0.1> }
  }

  text {
    ttf "timrom.ttf" "UT" 0.3, 0
    pigment { BrightGold }
    finish { reflection .25 specular 1 }
    translate <-2.5,-0.3,0>
    scale     <55, 55, 55>
  }

  text {
    ttf "timrom.ttf" "ICL" 0.3, 0
    pigment { Silver }
    finish { reflection .25 specular 1 }
    translate <1.1,-0.3,0>
    scale     <55, 55, 55>
  }

// declare rainbow's colours

#declare r_violet1 = colour red 1.0 green 0.5 blue 1.0 filter 1.0;
#declare r_violet2 = colour red 1.0 green 0.5 blue 1.0 filter 0.8;
#declare r_indigo  = colour red 0.5 green 0.5 blue 1.0 filter 0.8;
#declare r_blue    = colour red 0.2 green 0.2 blue 1.0 filter 0.8;
#declare r_cyan    = colour red 0.2 green 1.0 blue 1.0 filter 0.8;
#declare r_green   = colour red 0.2 green 1.0 blue 0.2 filter 0.8;
#declare r_yellow  = colour red 1.0 green 1.0 blue 0.2 filter 0.8;
#declare r_orange  = colour red 1.0 green 0.5 blue 0.2 filter 0.8;
#declare r_red1    = colour red 1.0 green 0.2 blue 0.2 filter 0.8;
#declare r_red2    = colour red 1.0 green 0.2 blue 0.2 filter 1.0;

// create the rainbow

rainbow {
  angle 42.5
  width 5
  distance 1.0e7
  direction <-0.2, -0.2, 1>
  jitter 0.01
  colour_map {
    [0.000  colour r_violet1]
    [0.100  colour r_violet2]
    [0.214  colour r_indigo]
    [0.328  colour r_blue]
    [0.442  colour r_cyan]
    [0.556  colour r_green]
    [0.670  colour r_yellow]
    [0.784  colour r_orange]
    [0.900  colour r_red1]
  }
}

rainbow {
  angle 37
  width 5
  distance 1.0e7
  direction <-0.2, -0.2, 1>
  jitter 0.01
  colour_map {
    [0.000  colour r_violet1]
    [0.100  colour r_violet2]
    [0.214  colour r_indigo]
    [0.328  colour r_blue]
    [0.442  colour r_cyan]
    [0.556  colour r_green]
    [0.670  colour r_yellow]
    [0.784  colour r_orange]
    [0.900  colour r_red1]
  }
}
