  #include "colors.inc"
  #include "skies.inc"
  #include "textures.inc"
  #include "shapes.inc"
  #include "golds.inc"
  #include "metals.inc"

  camera {
    location <0,2.2,-10>
    look_at <.3,1,1>
    angle 35
  }

  light_source { <300, 500, -500> color White }
  light_source { <-300, 500, -500> color Violet }

  plane {
    y,-0.2
    texture {
      pigment { SeaGreen }
      finish { reflection .35 specular 1 }
      normal { ripples .35 turbulence .5 scale .5 }
    }
    rotate <3,1.5,0>
  }

  union {
    torus{ 0.5, 0.1
      texture{ T_Gold_2A }
      scale     <1.1, 1.1, 1.1>
      translate <0.1, 0.4, 0> }
    torus{ 0.5, 0.12
      texture{ T_Silver_5A }
      scale     <1, 1, 1>
      rotate    <20, 0, 90>
      translate <0.1, 0.4, 0.1> }
  }

  fog{
    color Gray70
    fog_type 2
    fog_alt 0.12
    fog_offset 0
    distance 1.5
    turbulence <15, 15, 15>
    omega 0.35
    lambda 1.25
    octaves 5
    rotate <7,0,0>
  }

  text {
    ttf "timrom.ttf" "UT" 1, 0
    pigment { BrightGold }
    finish { reflection .25 specular 1 }
    translate -2.5*x
  }

  text {
    ttf "timrom.ttf" "ICL" 1, 0
    pigment { Silver }
    finish { reflection .25 specular 1 }
    translate 1.5*x
  }

  sky_sphere { S_Cloud5 }
