import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;

public class GSpovrayImageFrame extends JFrame {

  public Container content;
  JPanel imagePanel;
  int resX, resY, numX, numY;

  static final long serialVersionUID = 42L;

  public GSpovrayImageFrame(int rX, int rY, int nX, int nY) {
    super("Rendered Image");

    resX = rX;
    resY = rY;

    numX = nX;
    numY = nY;

    createUI();

    setVisible(true);
  }

  protected void createUI() {
    setSize(resX+(numX-1), resY+(numY-1));
    setVisible(true);
    Dimension size = getSize();
    Insets insets = getInsets();
    int insetwidth = insets.left + insets.right;
    int insetheight = insets.top + insets.bottom;
    setSize((int)size.getWidth() + insetwidth,(int)size.getHeight() + insetheight); 

    content = getContentPane();
    content.setLayout(new BorderLayout(10, 10));

    imagePanel = new JPanel();
    imagePanel.setLayout(new GraphPaperLayout(new Dimension(numX,numY)));

    content.add(imagePanel, BorderLayout.CENTER);
  }

  public void addImage(String fname, int x, int y) {
    ImageIcon image1 = GSpovrayImageFrame.createImageIcon(fname, "desc");
    JLabel label1 = new JLabel(image1, JLabel.CENTER);
    imagePanel.add(label1, new Rectangle(x,y,1,1));
    validate();
    imagePanel.paintImmediately(0, 0, resX, resY);
  }

  protected static ImageIcon createImageIcon(String path, String description) {
    java.net.URL imgURL = GSpovrayImageFrame.class.getResource(path);
    if (imgURL != null) {
      return new ImageIcon(imgURL, description);
    } else {
      System.err.println("Couldn't find file: " + path);
      return null;
    }
  }

  public void saveImage(String fname) throws IOException {
    ScreenImage.createImage(imagePanel, fname);
  }
}
