import java.lang.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.nio.channels.*;

import javax.swing.*;
import javax.swing.event.*;

public class ProgressDialog extends JFrame {
  private JLabel infoLabel;
  private JButton cancelButton;
  private JPanel mainPanel, buttonPanel;
  private Container content;
  private JProgressBar progressBar;
  private boolean cancelled = false;

  static final long serialVersionUID = 42L;

  public ProgressDialog(String labelText) {
    super("Progress");

    createUI(labelText);

    setVisible(true);
  }

  protected void createUI(String labelText) {
    setSize(300, 140);
    content = getContentPane();
    content.setLayout(new BorderLayout(10, 10));

    mainPanel = new JPanel();
    mainPanel.setLayout(new BorderLayout(10,10));

    buttonPanel = new JPanel();
    buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER));

    infoLabel = new JLabel(labelText);

    progressBar = new JProgressBar(0, 100);
    progressBar.setValue(0);
    progressBar.setStringPainted(true);
    
    cancelButton = new JButton();
    cancelButton.setText("Cancel");
    cancelButton.addActionListener(new ButtonListener());
    buttonPanel.add(cancelButton);

    mainPanel.add(infoLabel, BorderLayout.NORTH);
    mainPanel.add(progressBar, BorderLayout.CENTER);
    mainPanel.add(buttonPanel, BorderLayout.SOUTH);

    content.add(mainPanel, BorderLayout.CENTER);
  }

  public boolean isCancelled() {
    return cancelled;
  }

  public void setValue(int val) {
    progressBar.setValue(val);
    validate();
    Dimension d = getSize();
    mainPanel.paintImmediately(0, 0, d.width, d.height);
  }

  class ButtonListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
      JButton source = (JButton) event.getSource();

      if(source == cancelButton) {
        infoLabel.setText("Cancelling...");
        cancelled = true;
      }
    }
  }
}
