#define POVRAY_BINARY "/home/seymour/stuff/povray/bin/povray"
#define POVRAY_INC_DIR "/home/seymour/stuff/povray/share/povray-3.6/include/"
#define CONVERT_BINARY "/usr/local/bin/convert"

//#define POVRAY_BINARY "/home/cfabiane/povray-3.50c/src/povray"
//#define POVRAY_INC_DIR "/home/cfabiane/povray-3.50c/include/"

// cygwin
//#define POVRAY_BINARY "/cygdrive/c/Download/GridSolve/examples/C/povray/povray"
//#define POVRAY_INC_DIR "\"C:\\\\Programme\\\\POV-Ray\ for\ Windows\ v3.6\\\\include\\\\\""

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int parse_coords(char *, int *, int *, int *, int *);

int 
povray(char *cmdstr, int len, char *inifile, char *incfile, char *outfile)
{
  char cmd[1024];

  sprintf(cmd, "mv %s file.tar",incfile);
  //fprintf(stderr, "1: %s\n", cmd);
  system(cmd);

  sprintf(cmd, "tar xf file.tar");
  //fprintf(stderr, "2: %s\n", cmd);
  system(cmd);

  sprintf(cmd, "%s %s %s +L%s +O%s.tga -GA",
    POVRAY_BINARY, cmdstr, inifile, POVRAY_INC_DIR, outfile);
  fprintf(stderr, "3: %s\n", cmd);
  if(system(cmd) != 0) {
    fprintf(stdout, "Error: executable '%s' not found!\n", POVRAY_BINARY);
    exit(-1);
  }

  sprintf(cmd, "tar cf %s *.tga", outfile);
  //fprintf(stderr, "4: %s\n", cmd);
  system(cmd);

  return 0;
}

int 
povray_single_image(char *cmdstr, int len, char *inifile, 
  char *incfile, char *outfile)
{
  int sc, ec, sr, er;
  char cmd[1024];

  if(parse_coords(cmdstr, &sc, &ec, &sr, &er) < 0) {
    fprintf(stdout, "Error: failed to parse cmd line!\n");
    exit(-1);
  }

  sprintf(cmd, "%s %s %s +L%s +Oout.tga -GA",
    POVRAY_BINARY, cmdstr, inifile, POVRAY_INC_DIR);
  fprintf(stderr, "1: %s\n", cmd);
  if(system(cmd) != 0) {
    fprintf(stdout, "Error: executable '%s' not found!\n", POVRAY_BINARY);
    exit(-1);
  }

  sprintf(cmd, "%s out.tga -crop %dx%d+%d+0 out.png", CONVERT_BINARY,
     ec-sc+1, er-sr+1, sc-1);
  fprintf(stderr, "2: %s\n", cmd);
  if(system(cmd) != 0)
    fprintf(stdout, "Warning: command '%s' failed!\n");

  sprintf(cmd, "mv out.png %s", outfile);
  fprintf(stderr, "3: %s\n", cmd);
  system(cmd);

  return 0;
}

int
get_coord_val(char *cmd, char *spec, int *val)
{
  char find[8];
  char *copy, *p = NULL, *e = NULL;

  copy = strdup(cmd);

  if(!copy) {
    fprintf(stderr, "strdup failed\n");
    return -1;
  }

  strcpy(find, "+");
  strcat(find, spec);

  p = strstr(copy, find);

  if(!p) {
    strcpy(find, "-");
    strcat(find, spec);

    p = strstr(copy, find);

    if(!p)
      return -1;
  }

  p += strlen(spec) + 1;

  e = p;

  while((*e != 0) && (*e != '-') && (*e != '+'))
    e++;

  *e = 0;

  *val = atoi(p);

  free(copy);

  return 0;
}

int
parse_coords(char *cmd, int *sc, int *ec, int *sr, int *er)
{
  int val;

  if(get_coord_val(cmd, "SC", &val) < 0) {
    fprintf(stderr, "failed to get start column\n");
    return -1;
  }

  *sc = val;

  if(get_coord_val(cmd, "EC", &val) < 0) {
    fprintf(stderr, "failed to get end column\n");
    return -1;
  }

  *ec = val;

  if(get_coord_val(cmd, "SR", &val) < 0) {
    fprintf(stderr, "failed to get start row\n");
    return -1;
  }

  *sr = val;

  if(get_coord_val(cmd, "ER", &val) < 0) {
    fprintf(stderr, "failed to get end row\n");
    return -1;
  }

  *er = val;

  return 0;
}
