/**
 * @file
 *
 * Header file containing various client call definitions both C and Fortran.
 *
 */
/* $Id: cfortranclient.h,v 1.11 2005/03/02 22:14:24 seymour Exp $ */
/* $UTK_Copyright: $ */

#ifndef __NS_CFORTRANCLIENT_H
#define __NS_CFORTRANCLIENT_H

#include <stdarg.h>
#include "grpc.h"

typedef grpc_profile_t NS_profile;

int 
  netslX(char *, va_list, int, int, int),
  netslmajor(char *);

#ifndef WIN32 /*UNIX*/

int 
  netslinit(char *),
  netsl(char *, ...),
  netslnb(char *, ...),
  netslwt(int),
  netslpr(int),
  netslkill(int),
  * netsl_farm(char *, ...),
  netsl_assignment(char *, ...),
  netslnb_assignment(char *, ...),
  netsl_profile(NS_profile *),
  netslset_criteria(char *),
  netslset_criteria_file(char *);

void 
  netslerr(int);

typedef grpc_iterator_t NS_Iterator;

NS_Iterator*  ns_int(char *);
NS_Iterator*  ns_int_array(int *, char *);
NS_Iterator*  ns_ptr_array(void **,char *);

#if defined(F2CADD_) || defined(F2CADD__)
#define fnetsl fnetsl_
#define fnetslerr fnetslerr_
#define fnetslmajor fnetslmajor_
#define fnetslnb fnetslnb_
#define fnetslpr fnetslpr_
#define fnetslwt fnetslwt_
#endif

#ifdef F2CUPCASE
#define fnetsl FNETSL
#define fnetslerr FNETSLERR
#define fnetslmajor FNETSLMAJOR
#define fnetslnb FNETSLNB
#define fnetslpr FNETSLPR
#define fnetslwt FNETSLWT
#endif

void 
  fnetsl(char *, ...),
  fnetslerr(int *),
  fnetslmajor(char *),
  fnetslnb(char *, ...),
  fnetslpr(int *, int *),
  fnetslwt(int *, int *);

#else                           /* WIN32 */

#ifdef WIN32DLL                 /* Glue for Win32 Dynamic Link Library calls */
HINSTANCE gNetsolveDLL = NULL;
typedef int (*NETSL) (char *, ...);
NETSL netsl;
typedef int (*NETSLNB) (char *, ...);
NETSLNB netslnb;
typedef int (*NETSLWT) (int);
NETSLWT netslwt;
typedef int (*NETSLPR) (int);
NETSLPR netslpr;
typedef int (*NETSLERR) (int);
NETSLERR netslerr;
typedef int (*NETSL_FARM) (char *, ...);
NETSL_FARM netsl_farm;

#else                         /* Otherwise just declare function prototypes */

int 
  netslinit(char *),
  netsl(char *, ...),
  netslnb(char *, ...),
  netslwt(int),
  netslpr(int),
  *netsl_farm(char *, ...);

void netslerr(int);

#endif                          /* WIN32DLL */

#endif                          /* WIN32 */

#endif                          /* __NS_CFORTRANCLIENT_H */
