/**
 * @file
 *
 * Header file for the basic GridSolve comm routines.
 *
 */
/* $Id: comm_basics.h,v 1.25 2006/01/30 17:41:43 yarkhan Exp $ */
/* $UTK_Copyright: $ */

#ifndef COMM_BASICS_H
#define COMM_BASICS_H

#include "proxylib.h"

/** Number of ports greater than the requested port to try */
#define GS_NUM_PORTS_TO_TRY 0

/*** Function prototypes ***/

ssize_t gs_twrite(SOCKET, const void *, size_t);
ssize_t gs_writen(SOCKET, const void *, size_t);

int gs_tread(SOCKET, char *, int);
SOCKET gs_establish_socket(in_port_t *, int);
SOCKET gs_bind_to_first_available_port(in_port_t, in_port_t *);
int gs_listen_on_socket(SOCKET);
int gs_accept_connection(SOCKET);
int gs_close_socket(SOCKET);
SOCKET gs_connect_direct(char *, int);
SOCKET gs_connect_to_host(char *ID, ipaddr_t, int, ipaddr_t, int);
ssize_t gs_readline(int, void *, size_t);

#endif /* COMM_BASICS_H */
