/**
 * @file
 *
 * Header file for encode/decode routines. 
 *
 */
/* $Id: comm_encode.h,v 1.33 2008/08/22 00:35:16 tbrady Exp $ */
/* $UTK_Copyright: $ */

#ifndef COMM_ENCODE_H
#define COMM_ENCODE_H

#include <string.h>
#include "server.h"

#include "dsi.h"

#ifdef GS_SMART_GRIDSOLVE
#include "gs_smart_task_graph.h"
#endif

int 
  gs_encode_cancel_notification(char **, char *, char *, int),
  gs_decode_cancel_notification(char *, char **, char **, int *),
  gs_encode_failure_notification(char **, char *, char *, int),
  gs_decode_failure_notification(char *, char **, char **, int *),
  gs_encode_problem_complete_notification(char **, char *, char *, int, double),
  gs_decode_problem_complete_notification(char *, char **, char **, int *, double *),
  gs_encode_problem_solve_notification(char **,
     char *, double, char *, char *, char *, char *, char *, int, double),
  gs_decode_problem_solve_notification(char *, char **, double *,
     char **, char **, char **, char **, char **, int *, double *),
  gs_encode_problem_solve_request(char **, char *, 
     char *, char *, char *, char *, int, int, double),
  gs_decode_problem_solve_request(char *, char **, 
     char **, char **, char **, int *, int *, double *),
  gs_encode_problem_submit_request(char **, char *, int, char *),
  gs_decode_problem_submit_request(char *, char **, int *, char **),
  gs_encode_problem_submit_response(char **, char **, int),
  gs_decode_problem_submit_response(char *, char ***, int *),
  gs_encode_model_update(char **, char *, char *),
  gs_decode_model_update(char *, char **, char **),
  gs_encode_server(char **, gs_server_t *),
  gs_decode_server(char *, gs_server_t *),
  gs_encode_smart_info(char **, gs_server_t *, gs_server_t **, double *, int),
  gs_encode_workload_report(char **, int, int, char *),
  gs_decode_workload_report(char *, int *, int *, char *),
  gs_encode_problem(char **, gs_problem_t *),
  gs_decode_problem(char *, gs_problem_t *),
  gs_encode_infolist(char **, gs_info_t *),
  gs_decode_infolist(char *, gs_info_t **),
  gs_encode_availability_request(char **, gs_server_t *),
  gs_decode_availability_request(char *, gs_server_t *),
#ifdef GS_SMART_GRIDSOLVE
  gs_smart_encode_tg_rem_task_node(char **, gs_smart_tg_task_node * ),  
  gs_smart_decode_tg_rem_task_node(char *, gs_smart_tg *, gs_smart_tg_task_node * ),
  gs_smart_encode_tg_client_node(char **,  gs_smart_tg_task_node * ),
  gs_smart_decode_tg_client_node(char *, gs_smart_tg * , gs_smart_tg_task_node * ),
  gs_smart_encode_app_pm(char **, gs_smart_app_pm *),
  gs_smart_decode_app_pm(char *, gs_smart_app_pm * ),
  gs_smart_decode_arg_map_info(char *, gs_argument_t * ),
  gs_smart_encode_arg_map_info(char **,  gs_argument_t * ),
  gs_smart_encode_ping_info(char **, gs_server_t *, gs_server_t **, double *, int ),
  gs_smart_decode_ping_info(char *, gs_server_pings_t ***, int *),
#endif
  gs_encode_dsi_object(char **, DSI_OBJECT *),
  gs_decode_dsi_object(char *, DSI_OBJECT *);

#endif /* COMM_ENCODE_H */
