/**
 * @file
 *
 * Header file for DSI structures, etc. 
 *
 */
/* $Id: dsi.h,v 1.7 2007/07/24 20:13:00 yarkhan Exp $ */
/* $UTK_Copyright: $ */


#ifndef __DSI_H
#define __DSI_H

#include <sys/types.h>

#include "portability.h"

#ifdef DSI_IBP
#include "ibp.h"
#endif

#define GS_DSI_LOCAL 0
#define GS_DSI_IBP   1
#define GS_DSI_GASS  2

typedef int dsi_type;

typedef struct {
  int flag;
  int perm;
  uid_t uid;
  dsi_type storage_system;
#if defined(DSI)
  union {
#ifdef DSI_IBP
    struct{
      IBP_depot depot;
      IBP_set_of_caps cap;
    } ibp;
#endif
  } dsi_specifics;
#endif
  int written_count;
} DSI_FILE;

typedef struct {
  char *name;
  DSI_FILE *dsi_file;
  int offset;
} DSI_OBJECT;

int
  grpc_dsi_store(DSI_FILE *, char *, int),
  gs_insert_dsi_object(DSI_OBJECT *),
  gs_remove_dsi_object(DSI_OBJECT *),
  gs_is_dsi_object(void *);

#endif
