
#include "comm_basics.h"
#include "server.h"

#define TASK_ID_LEN 128

typedef struct gs_htm_task_ {
  char id[TASK_ID_LEN];
  struct gs_htm_task_ *next;
  double start;
  double duration;
  double remaining;
  double end;
  int active;
  int finished;
  int agent_taskid;
} gs_htm_task;

typedef struct gs_htm_server_ {
  char id[CID_LEN];
  gs_htm_task *first;
  gs_htm_task *last;
  gs_htm_task *current;
  int running;                  /* Number of running task */
  double metric;
  double agent_assigned_score;
  gs_server_t *sptr;
} gs_htm_server;

#define min(a,b) ((a)<(b)?(a):(b))

/*
 * type of event 
 */
#define NEW_TASK 1
#define END_TASK 2
#define FINISH_TASK 3

/*
 * Function prototypes.
 */

void
  gs_htm_display_server(gs_htm_server *),
  gs_htm_simulate_server(gs_htm_server *),
  gs_htm_add_task(gs_htm_server *, gs_htm_task *),
  gs_htm_add_task_last(gs_htm_server *, gs_htm_task *),
  gs_htm_raz_simulation(gs_htm_server *),
  gs_htm_remove_task(gs_htm_server *, char *);

double
  gs_htm_first_event(gs_htm_server *),
  gs_htm_next_event(gs_htm_server *, double),
  gs_htm_perturbation(gs_htm_server *),
  gs_htm_makespan(gs_htm_server *),
  gs_htm_flow(gs_htm_server *),
  gs_htm_length(gs_htm_server *, double);

gs_htm_task
  *gs_htm_new_task(char *, double, double),
  *gs_htm_finished_task(char *, double, double),
  *gs_htm_clone_task(gs_htm_task *);

gs_htm_server
  *gs_htm_new_empty_server(char *, gs_server_t *),
  *gs_htm_clone_server(gs_htm_server *);

int
  gs_htm_ML(gs_htm_server **, int, gs_htm_task *),
  gs_htm_MSF(gs_htm_server **, int, gs_htm_task *),
  gs_htm_HMCT(gs_htm_server **, int, gs_htm_task *),
  gs_htm_MP(gs_htm_server **, int, gs_htm_task *);
