/**
 * @file
 *
 * File provides functions for storing/accessing handles of the group of 
 * tasks being mapped and for generating the application performance model
 * from these handles.
 * 
 */

#include "config.h"
#ifdef GS_SMART_GRIDSOLVE
#ifndef GS_SMART_APP_PM_BUILDER_H
#define GS_SMART_APP_PM_BUILDER_H
#include "gs_smart_app_pm.h"
#include "grpc.h"

int 
  gs_smart_generate_app_pm(grpc_function_handle_t ** , int ** , int , 
                                                      gs_smart_app_pm * ),
  gs_smart_store_handle(grpc_function_handle_t *,   grpc_sessionid_t * , 
                                        gs_va_list *, int, int, char, int),
  gs_smart_get_handle_list(grpc_function_handle_t ***, grpc_sessionid_t *** ,
                                                        int *** , int * ),
 
  gs_smart_mg_embed_mapping(grpc_function_handle_t *, int),
  gs_smart_get_nb_auto_tasks_left_to_build(),
  gs_smart_adjust_handle_array_sizes();
#endif 
#endif
