/**
 * @file
 *
 * This file contains the structure which stores the mapping solution 
 * for a group of tasks. This mapping solution is generated by one of the mapping heuristics .
 * This mapping solution will be embedded into the handles 
 * during the second iteration through the group.
 * Once embedded, the handles will be subsequently mapped according to the mapping solution.
 *
 */

#include "config.h"
#ifdef GS_SMART_GRIDSOLVE
#ifndef GS_SMART_MAPPING_SOLUTION
#define GS_SMART_MAPPING_SOLUTION
#include "gs_smart_mapping_graph.h"


static gs_smart_mg * best_mg;

#endif 
#endif
