/**
 * @file
 *
 * File provides the structures and attributes for the stored 
 * group of tasks. These structures are initialised during
 * the first cycle through the group of tasks when the
 * task graph is being built.  These structures and attributes
 * are used to generate the application performance model which
 * is subsequently used to generate the task graph.
 *  
 *
 */

#include "config.h"
#ifdef GS_SMART_GRIDSOLVE
#ifndef GS_SMART_STORED_GROUP_HANDLES_H
#define GS_SMART_STORED_GROUP_HANDLES_H
#include "gs_smart_app_pm.h"

/*
 * Stored handles for the mapped group of tasks
 */
static grpc_function_handle_t ** handles_array;

/*
 * Stored session ids for the mapped group of tasks
 */
static  grpc_sessionid_t ** session_ids;

/*
 * This array indicates which tasks are blocking
 * and non-blocking in the stored handle array.
 */
static int * blocking_array;

/*
 * These variables are used when initialising
 * the handles_array structure. They keep track of 
 * the current size of the handle array.
 */
static int handle_array_size=0;   
static int handle_array_pos=0;

#endif 
#endif
