/**
 * @file
 *
 * Header file for icl_hash routines. 
 *
 */
/* $Id: icl_hash.h,v 1.4 2005/08/31 21:01:34 seymour Exp $ */
/* $UTK_Copyright: $ */

#ifndef icl_hash_h
#define icl_hash_h

#include "icl_list.h"

typedef struct icl_entry_s {
  char *key;
  void *data;
  struct icl_entry_s* next;
} icl_entry_t;

typedef struct icl_hash_s {
  int nbuckets;
  int nentries;
  icl_entry_t **buckets;
  long (*hash_function)(char*);
} icl_hash_t;

icl_hash_t
  * icl_hash_create(int, long (*)(char*));

void
  * icl_hash_find(icl_hash_t *, char *);

icl_entry_t
  * icl_hash_insert(icl_hash_t *, char *, void *),
  * icl_hash_update_insert(icl_hash_t *, char *, void *, void **);

int 
  icl_hash_destroy(icl_hash_t *, void (*)(void*), void (*)(void*)),
  icl_hash_dump(FILE *, icl_hash_t *);

#define icl_hash_foreach(ht, tmpint, tmpent, kp, dp) \
  for (tmpint=0;tmpint<ht->nbuckets; tmpint++) \
     for (tmpent=ht->buckets[tmpint]; \
          tmpent!=NULL&&((kp=tmpent->key)!=NULL)&&((dp=tmpent->data)!=NULL); \
          tmpent=tmpent->next)


#endif /* icl_hash_h */
