/**
 * @file
 *
 * Header file for mfork routines. 
 *
 */
/* $Id: mfork.h,v 1.8 2005/11/05 20:41:53 seymour Exp $ */
/* $UTK_Copyright: $ */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <errno.h>

#include "utility.h"
#include "icl_list.h"

typedef void (*mfork_func_t)(void **);

typedef struct {
  pid_t pid;
  int update_freq;
  int num_restarts;
  mfork_func_t func;
  mfork_func_t pre_func;
  mfork_func_t post_func;
  mfork_func_t exit_func;
  void **args;
} mfork_data_t;

void 
  mfork_sigchld_handler(int);

pid_t 
  mfork(mfork_func_t, int, void **, 
        mfork_func_t, mfork_func_t, mfork_func_t, int);

int 
  mfork_set_secondary_sigchld_handler(Sigfunc *),
  mfork_finalize(),
  mfork_check_parent();
