/**
 * @file
 *
 * Header file for NetSolve client code.  This should be included
 * by all NetSolve client programs.
 *
 */
/* $Id: netsolve.h,v 1.8 2005/11/21 21:55:05 seymour Exp $ */
/* $UTK_Copyright: $ */


#ifndef __NS_NETSOLVE_H
#define __NS_NETSOLVE_H

#include "netsolveerror.h"
#include "netsolveclient.h"

int 
  netslmajor(char *),
  netsl(char *, ...),
  netslnb(char *, ...),
  netslwt(int),
  netslpr(int),
  netslpr_assignment(int),
  netslwt_assignment(int, int *),
  netsl_assignment(char *, ...),
  netslnb_assignment(char *, ...),
  netslset_criteria(char *),
  netslset_criteria_file(char *);

int *netsl_farm(char *, ...);
void 
  netslerr(int);

/* 
 * Uncomment these prototypes later when we have implemented these features.
 *
 * int ns_storehandle(DSI_OBJECT*, char*); DSI_OBJECT* ns_gethandle(char*); 
 * int *netsl_farm(char*,...);
 * int netsl_sequence_status(); 
 * void netsl_sequence_begin(); int netsl_sequence_end(void*,...); 
 */

extern int ns_errno;

#define ns_perror(x) \
  fprintf(stderr, "%s: %s\n", x, netsolveErrorMessage(ns_errno));

#endif
