/**
 * @file
 *
 * This file originally written by Henri Casanova for NetSolve.
 * It contains NetSolve macro definitions for NetSolve errors
 *
 */
/* $Id: netsolveerror.h,v 1.4 2004/08/24 20:42:15 seymour Exp $ */
/* $UTK_Copyright: $ */


#ifndef __NS_NETSOLVEERROR_H
#define __NS_NETSOLVEERROR_H

extern int grpc_error_mapping[];

/*** MACRO DEFINITIONS ***/

#define NetSolveOK                       0
#define NetSolveNotReady                -1
#define NetSolveSetNetSolveAgent        -2
#define NetSolveSetNetSolveRoot         -3
#define NetSolveSetNetSolveArch         -4
#define NetSolveInternalError           -5
#define NetSolveUnknownHost             -6
#define NetSolveNetworkError            -7
#define NetSolveUnknownProblem          -8
#define NetSolveProtocolError           -9
#define NetSolveNoServer                -10
#define NetSolveBadProblemSpecification -11
#define NetSolveNotAllowed              -12
#define NetSolveBadValues               -13
#define NetSolveDimensionMismatch       -14
#define NetSolveNoSolution              -15
#define NetSolveUnknownError            -16
#define NetSolveInvalidRequestID        -17
#define NetSolveBadProblemName          -18
#define NetSolveInvalidMajor            -19
#define NetSolveTooManyPendingRequests  -20
#define NetSolveFileError               -21
#define NetSolveUnknownDataFormat       -22
#define NetSolveInvalidUPFFilename      -23
#define NetSolveMismatch                -24
#define NetSolveSystemError             -25
#define NetSolveConnectionRefused       -26
#define NetSolveCannotBind              -27
#define NetSolveUPFError                -28
#define NetSolveUPFUnsafe               -29
#define NetSolveServerError             -30
#define NetSolveBadIterationRange       -31
#define NetSolveFarmingError            -32
#define NetSolveCannotStartProxy	    -33
#define NetSolveUnknownServer		    -34
#define NetSolveProxyError		        -35
#define NetSolveCondorError		        -36
#define NetSolveCannotContactAgent	    -37
#define NetSolveTimedOut	            -38
#define NetSolveAuthenticationError     -39     /* kerberos/auth. */
#define NetSolveUnknownHandle		    -40
#define NetSolveUnknownDsiFile		    -41
#define NetSolveIBPAllocateError		    -42
#define NetSolveIBPManageError		    -43
#define NetSolveIBPLoadError		    -44
#define NetSolveIBPStoreError		    -45
#define NetSolveDsiEACCESS		    -46
#define NetSolveDsiDisabled		    -47

/*** FUNCTION PROTOTYPES ***/

char *netsolveErrorMessage(int);

#endif
