/**
 * @file
 *
 * This file contains structures and function prototypes for the
 * GridSolve/NetSolve Distributed Storage Infrastructure client API.
 *
 */
/* $Id: nsdsi.h,v 1.3 2007/07/24 20:13:00 yarkhan Exp $ */
/* $UTK_Copyright: $ */

#ifndef __NSDSI_H
#define __NSDSI_H

#include "grpc.h"
#include "netsolveerror.h"
#include "portability.h"

extern int ns_errno;

int 
  ns_dsi_close(DSI_FILE *),
  ns_dsi_read_vector(DSI_OBJECT *, void *, int, enum datatype),
  ns_dsi_read_matrix(DSI_OBJECT *, void *, int, int, enum datatype);

DSI_FILE
  *ns_dsi_open(char*, int, int, int, dsi_type);

DSI_OBJECT
  *ns_dsi_write_vector(DSI_FILE *, void *, int, enum datatype),
  *ns_dsi_write_matrix(DSI_FILE *, void *, int, int, enum datatype);

#endif
