/**
 * @file
 *
 * This file contains structures and function prototypes for
 * the queue implementation.
 *
 */
/* $Id: queue.h,v 1.2 2004/07/23 18:26:01 seymour Exp $ */
/* $UTK_Copyright: $ */

#ifndef _QUEUE_H
#define _QUEUE_H

#include <stdlib.h>
#include "pthread.h"

/** This structure defines a queue item. */
typedef struct _q_item {
  void *val;
  struct _q_item *prev, *next;
} Q_ITEM;

/** This structure defines the queue. */
typedef struct {
  Q_ITEM *head;
  Q_ITEM *tail;
  pthread_mutex_t *mutex;
  pthread_cond_t *notFull, *notEmpty;
} QUEUE;

#define is_empty(q) (q->tail == NULL)

/*** Function Prototypes ***/

QUEUE 
  * new_queue();

int
  destroy_queue(),
  enqueue(QUEUE *, void *);

void
  * dequeue(QUEUE *);

#endif
