/**
 * @file
 *
 * Header file for the symbol table routines.
 *
 */
/* $Id: symtab.h,v 1.3 2005/04/27 22:44:11 seymour Exp $ */
/* $UTK_Copyright: $ */

#ifndef _SYMTAB_H
#define _SYMTAB_H

#include<string.h>

/*****************************************************************************
 * Structure of a hash table node.                                           *
 *****************************************************************************/
typedef struct hash_node
{
  void *item;
  char *tag;
  struct hash_node *next;
} HASHNODE;

/*****************************************************************************
 * Structure of the symbol table.                                            *
 *****************************************************************************/
typedef struct sym_table
{
  int num_entries,               /* Number of entries in this hash table     */
      num_items;                 /* Number of items stored in hash table     */

  HASHNODE **entry;              /* Pointer to the entries                   */
} SYMTABLE;

/*****************************************************************************
 * Function prototypes to keep the compiler from complaining.                *
 *****************************************************************************/

HASHNODE 
  * search_hashlist(HASHNODE *, char *),
  * hash_delete(SYMTABLE *, char *),
  * hash_lookup(SYMTABLE *, char *);

SYMTABLE 
  * new_symtable (unsigned int);

int 
  hash_insert (SYMTABLE *, void *, char *);

void
  hash_dump(SYMTABLE *, void (*dump_function)(char *, void*));

#endif
