/**
 * @file
 *
 * Header file for xnprintf().  See xnprintf.c for original copyright.
 *
 * 6/23/04 - Updated by Asim YarKhan to configure configure.in style
 * HAVE_function macros from config.h to allow conditional usage of
 * the functions.
 */
/* $Id: xnprintf.h,v 1.8 2007/09/11 15:28:29 yarkhan Exp $ */

/*###########################################################################
#                                                                           #
#                       Header file for xnprintf()                          #
#                                                                           #
#                     public domain (this file only)                        #
#                                                                           #
###########################################################################*/

/*
Revision history:

december 15th 2002 David TAILLANDIER  asnprintf and vasnprintf added
                                      asprintf and vasprintf modified

february 16th 2002 David TAILLANDIER  Initial release

*/

#ifndef _XPRINTF_H
#define _XPRINTF_H

#include <stdarg.h>
#include <stdio.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

int     _xn_nprintf(                     int maxlen, const char * format_string, ... );
int    _xn_vnprintf(                     int maxlen, const char * format_string, va_list vargs );
int    _xn_snprintf( char * dest_string, int maxlen, const char * format_string, ... );
int   _xn_vsnprintf( char * dest_string, int maxlen, const char * format_string, va_list vargs );
int    _xn_fnprintf( FILE * file,        int maxlen, const char * format_string, ... );
int   _xn_vfnprintf( FILE * file,        int maxlen, const char * format_string, va_list vargs );
int    _xn_asprintf( char ** ptr,                    const char * format_string, ... );
int   _xn_vasprintf( char ** ptr,                    const char * format_string, va_list vargs );
int   _xn_asnprintf( char ** ptr,        int maxlen, const char * format_string, ... );
int  _xn_vasnprintf( char ** ptr,        int maxlen, const char * format_string, va_list vargs );

#ifndef HAVE_NPRINTF
#define    nprintf       _xn_nprintf
#endif

#ifndef HAVE_VNPRINTF
#define   vnprintf      _xn_vnprintf
#endif

#ifndef HAVE_SNPRINTF
#define   snprintf      _xn_snprintf
#endif

#ifndef HAVE_VSNPRINTF
#define  vsnprintf     _xn_vsnprintf
#endif

#ifndef HAVE_FNPRINTF
#define   fnprintf      _xn_fnprintf
#endif

#ifndef HAVE_VFNPRINTF
#define  vfnprintf     _xn_vfnprintf
#endif

#ifndef HAVE_VASPRINTF
#define  vasprintf     _xn_vasprintf
#endif

#ifndef HAVE_ASNPRINTF
#define  asnprintf     _xn_asnprintf
#endif

#ifndef HAVE_VASNPRINTF
#define vasnprintf    _xn_vasnprintf
#endif

#ifndef HAVE_ASPRINTF
#define   asprintf      _xn_asprintf
#endif

#endif    /* ifndef _XPRINTF_H_ */


/*############################# END OF FILE ###############################*/

