void
mandel(int max, double xa, double xd, double xb, double ya, double yd, double yb,  int m, int n,
       int *output)
{
  double ceil(double);
  int i,j,k;
  int n1,n2;
  double x,y;

  n1 = (int)(ceil((xb-xa)/xd))+1;
  n2 = (int)(ceil((yb-ya)/yd))+1;

  x = xa;
  y = ya;
  for (i=0;i<n1;i++)
  {
    for (j=0;j<n2;j++)
    {
      double a=0.0;
      double b=0.0;
      for (k=0;k<=max;k++)
      {
        double a1,b1;
        a1 = a*a - b*b + x;
        b1 = 2.0*a*b + y;
        a = a1;
        b = b1;
        if (a*a + b*b > 4.0)
          break; 
      }
      output[i*n2+j] = k;
      y = y + yd;
    }
    y = ya;
    x = x +xd;
  }
}


void
mandel_orig(int max, double xa, double xd, double xb, double ya, double yd, double yb, int *output)
{
  double ceil(double);
  int i,j,k;
  int n1,n2;
  double x,y;

  n1 = (int)(ceil((xb-xa)/xd))+1;
  n2 = (int)(ceil((yb-ya)/yd))+1;

  x = xa;
  y = ya;
  for (i=0;i<n1;i++)
  {
    for (j=0;j<n2;j++)
    {
      double a=0.0;
      double b=0.0;
      for (k=0;k<=max;k++)
      {
        double a1,b1;
        a1 = a*a - b*b + x;
        b1 = 2.0*a*b + y;
        a = a1;
        b = b1;
        if (a*a + b*b > 4.0)
          break; 
      }
      output[i*n2+j] = k;
      y = y + yd;
    }
    y = ya;
    x = x +xd;
  }
}
