#include <stdlib.h>

#include "problem.h"

int
int_compare(const void *i1, const void *i2)
{
  int num1, num2;

  num1 = *((int *)i1);
  num2 = *((int *)i2);

  if(num1 < num2) return -1;
  if(num1 > num2) return 1;
  return 0;
}

int
double_compare(const void *i1, const void *i2)
{
  double num1, num2;

  num1 = *((double *)i1);
  num2 = *((double *)i2);

  if(num1 < num2) return -1;
  if(num1 > num2) return 1;
  return 0;
}

void
iqsort(int *x, int n)
{
  qsort(x, n, sizeof(*x), int_compare);
  return;
}

void
dqsort(double *x, int n)
{
  qsort(x, n, sizeof(*x), double_compare);
  return;
}

void
batch_test_int(int *x, int n, int delay)
{
  sleep(delay);
  qsort(x, n, sizeof(*x), int_compare);
  return;
}

void
batch_test_double(double *x, int n, int delay)
{
  sleep(delay);
  qsort(x, n, sizeof(*x), double_compare);
  return;
}
