#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>

#include "problem.h"

void
ctotal(int int_in, int *int_inout, int *int_out, 
  int int_work,
  float float_in, float *float_inout, float *float_out, 
  float float_work,
  double double_in, double *double_inout, double *double_out, 
  double double_work,
  gs_scomplex scmp_in, gs_scomplex *scmp_inout, gs_scomplex *scmp_out, 
  gs_scomplex scmp_work,
  gs_dcomplex dcmp_in, gs_dcomplex *dcmp_inout, gs_dcomplex *dcmp_out, 
  gs_dcomplex dcmp_work,
  char char_in, char *char_inout, char *char_out,
  char char_work,
  int *ivec_in, int *ivec_inout, int *ivec_out, 
  int *ivec_work, int ivec_len,
  float *fvec_in, float *fvec_inout, float *fvec_out, 
  float *fvec_work, int fvec_len,
  double *dvec_in, double *dvec_inout, double *dvec_out, 
  double *dvec_work, int dvec_len,
  gs_scomplex *scmp_vec_in, gs_scomplex *scmp_vec_inout, 
  gs_scomplex *scmp_vec_out, gs_scomplex *scmp_vec_work, int scmp_vec_len,
  gs_dcomplex *dcmp_vec_in, gs_dcomplex *dcmp_vec_inout, 
  gs_dcomplex *dcmp_vec_out, gs_dcomplex *dcmp_vec_work, int dcmp_vec_len,
  char *cvec_in, char *cvec_inout, char *cvec_out, 
  char *cvec_work, int cvec_len,
  int *imat_in, int *imat_inout, int *imat_out, 
  int *imat_work, int imat_m, int imat_n,
  float *fmat_in, float *fmat_inout, float *fmat_out, 
  float *fmat_work, int fmat_m, int fmat_n,
  double *dmat_in, double *dmat_inout, double *dmat_out, 
  double *dmat_work, int dmat_m, int dmat_n,
  gs_scomplex *scmp_mat_in, gs_scomplex *scmp_mat_inout, 
  gs_scomplex *scmp_mat_out, gs_scomplex *scmp_mat_work, 
  int scmp_mat_m, int scmp_mat_n,
  gs_dcomplex *dcmp_mat_in, gs_dcomplex *dcmp_mat_inout, 
  gs_dcomplex *dcmp_mat_out, gs_dcomplex *dcmp_mat_work, 
  int dcmp_mat_m, int dcmp_mat_n,
  char *cmat_in, char *cmat_inout, char *cmat_out, 
  char *cmat_work, int cmat_m, int cmat_n
)
{
  int i,j;

  *int_inout = *int_inout + 1;
  *int_out = int_in + 1;
  int_work = 1;

  *float_inout = *float_inout + (float) 1.0;
  *float_out = float_in + (float) 1.0;
  float_work = (float)1.0;

  *double_inout = *double_inout + 1.0;
  *double_out = double_in + 1.0;
  double_work = 1.0;

  scmp_inout->r = scmp_inout->r + (float) 1.0;
  scmp_inout->i = scmp_inout->i + (float) 1.0;
  scmp_out->r = scmp_in.r + (float) 1.0;
  scmp_out->i = scmp_in.i + (float) 1.0;
  scmp_work.r = (float)1.0;
  scmp_work.i = (float)9.0;

  dcmp_inout->r = dcmp_inout->r + 1.0;
  dcmp_inout->i = dcmp_inout->i + 1.0;
  dcmp_out->r = dcmp_in.r + 1.0;
  dcmp_out->i = dcmp_in.i + 1.0;
  dcmp_work.r = 1.0;
  dcmp_work.i = 9.0;

  *char_inout = *char_inout + 1;
  *char_out = char_in + 1;
  char_work = 1;

  for(i=0;i<ivec_len;i++) {
    ivec_inout[i] = ivec_inout[i] + 1;
    ivec_out[i] = ivec_in[i] + 1;
    ivec_work[i] = ivec_work[i] + 1;
  }

  for(i=0;i<fvec_len;i++) {
    fvec_inout[i] = fvec_inout[i] + (float)1.0;
    fvec_out[i] = fvec_in[i] + (float)1.0;
    fvec_work[i] = fvec_work[i] + (float)1.0;
  }

  for(i=0;i<dvec_len;i++) {
    dvec_inout[i] = dvec_inout[i] + 1.0;
    dvec_out[i] = dvec_in[i] + 1.0;
    dvec_work[i] = dvec_work[i] + 1.0;
  }

  for(i=0;i<cvec_len;i++) {
    cvec_inout[i] = cvec_inout[i] + 1;
    cvec_out[i] = cvec_in[i] + 1;
    cvec_work[i] = cvec_work[i] + 1;
  }

  for(i=0;i<scmp_vec_len;i++) {
    scmp_vec_inout[i].r = scmp_vec_inout[i].r + (float)1.0;
    scmp_vec_inout[i].i = scmp_vec_inout[i].i + (float)1.0;

    scmp_vec_out[i].r = scmp_vec_in[i].r + (float)1.0;
    scmp_vec_out[i].i = scmp_vec_in[i].i + (float)1.0;

    scmp_vec_work[i].r = scmp_vec_work[i].r + (float)1.0;
    scmp_vec_work[i].i = scmp_vec_work[i].i + (float)1.0;
  }

  for(i=0;i<dcmp_vec_len;i++) {
    dcmp_vec_inout[i].r = dcmp_vec_inout[i].r + 1.0;
    dcmp_vec_inout[i].i = dcmp_vec_inout[i].i + 1.0;

    dcmp_vec_out[i].r = dcmp_vec_in[i].r + 1.0;
    dcmp_vec_out[i].i = dcmp_vec_in[i].i + 1.0;

    dcmp_vec_work[i].r = dcmp_vec_work[i].r + 1.0;
    dcmp_vec_work[i].i = dcmp_vec_work[i].i + 1.0;
  }

  for(i=0;i<imat_m;i++) {
    for(j=0;j<imat_n;j++) {
      imat_inout[i*imat_n+j] = imat_inout[i*imat_n+j] + 1;
      imat_out[i*imat_n+j] = imat_in[i*imat_n+j] + 1;
      imat_work[i*imat_n+j] = imat_work[i*imat_n+j] + 1;
    }
  }

  for(i=0;i<fmat_m;i++) {
    for(j=0;j<fmat_n;j++) {
      fmat_inout[i*fmat_n+j] = fmat_inout[i*fmat_n+j] + (float)1.0;
      fmat_out[i*fmat_n+j] = fmat_in[i*fmat_n+j] + (float)1.0;
      fmat_work[i*fmat_n+j] = fmat_work[i*fmat_n+j] + (float)1.0;
    }
  }

  for(i=0;i<dmat_m;i++) {
    for(j=0;j<dmat_n;j++) {
      dmat_inout[i*dmat_n+j] = dmat_inout[i*dmat_n+j] + 1.0;
      dmat_out[i*dmat_n+j] = dmat_in[i*dmat_n+j] + 1.0;
      dmat_work[i*dmat_n+j] = dmat_work[i*dmat_n+j] + 1.0;
    }
  }

  for(i=0;i<scmp_mat_m;i++) {
    for(j=0;j<scmp_mat_n;j++) {
      scmp_mat_inout[i*scmp_mat_n+j].r = scmp_mat_inout[i*scmp_mat_n+j].r + 1.0;
      scmp_mat_inout[i*scmp_mat_n+j].i = scmp_mat_inout[i*scmp_mat_n+j].i + 1.0;

      scmp_mat_out[i*scmp_mat_n+j].r = scmp_mat_in[i*scmp_mat_n+j].r + 1.0;
      scmp_mat_out[i*scmp_mat_n+j].i = scmp_mat_in[i*scmp_mat_n+j].i + 1.0;

      scmp_mat_work[i*scmp_mat_n+j].r = scmp_mat_work[i*scmp_mat_n+j].r + 1.0;
      scmp_mat_work[i*scmp_mat_n+j].i = scmp_mat_work[i*scmp_mat_n+j].i + 1.0;
    }
  }

  for(i=0;i<dcmp_mat_m;i++) {
    for(j=0;j<dcmp_mat_n;j++) {
      dcmp_mat_inout[i*dcmp_mat_n+j].r = dcmp_mat_inout[i*dcmp_mat_n+j].r + 1.0;
      dcmp_mat_inout[i*dcmp_mat_n+j].i = dcmp_mat_inout[i*dcmp_mat_n+j].i + 1.0;

      dcmp_mat_out[i*dcmp_mat_n+j].r = dcmp_mat_in[i*dcmp_mat_n+j].r + 1.0;
      dcmp_mat_out[i*dcmp_mat_n+j].i = dcmp_mat_in[i*dcmp_mat_n+j].i + 1.0;

      dcmp_mat_work[i*dcmp_mat_n+j].r = dcmp_mat_work[i*dcmp_mat_n+j].r + 1.0;
      dcmp_mat_work[i*dcmp_mat_n+j].i = dcmp_mat_work[i*dcmp_mat_n+j].i + 1.0;
    }
  }


  for(i=0;i<cmat_m;i++) {
    for(j=0;j<cmat_n;j++) {
      cmat_inout[i*cmat_n+j] = cmat_inout[i*cmat_n+j] + 1;
      cmat_out[i*cmat_n+j] = cmat_in[i*cmat_n+j] + 1;
      cmat_work[i*cmat_n+j] = cmat_work[i*cmat_n+j] + 1;
    }
  }
}

int
sleeptest(int duration)
{
  sleep(duration);
  return 0;
}

int
gs_abort(int *exitval)
{
  exit(*exitval);
  return -1;
}

int return_int_scalar(int x) {
  return x+1;
}

float return_float_scalar(float x) {
  return x+(float)1.0;
}

double return_double_scalar(double x) {
  return x+1.0;
}

gs_scomplex return_scomplex_scalar(gs_scomplex x) {
  gs_scomplex rv;
  rv.r = x.r + 1.0;
  rv.i = x.i + 1.0;
  return rv;
}

gs_dcomplex return_dcomplex_scalar(gs_dcomplex x) {
  gs_dcomplex rv;
  rv.r = x.r + 1.0;
  rv.i = x.i + 1.0;
  return rv;
}

char return_char_scalar(char x) {
  return x+1;
}

int *return_int_vector(int *vec, int n) {
  int i,*rv;
  rv = (int*)malloc(n*sizeof(int));
  for(i=0;i<n;i++)
    rv[i] = vec[i] + 1;
  return rv;
}

float *return_float_vector(float *vec, int n) {
  int i;
  float *rv;

  rv = (float*)malloc(n*sizeof(float));
  for(i=0;i<n;i++)
    rv[i] = vec[i] + (float)1.0;
  return rv;
}

double *return_double_vector(double *vec, int n) {
  int i;
  double *rv;

  rv = (double*)malloc(n*sizeof(double));
  for(i=0;i<n;i++)
    rv[i] = vec[i] + 1.0;
  return rv;
}

gs_scomplex *return_scomplex_vector(gs_scomplex *vec, int n) {
  int i;
  gs_scomplex *rv;

  rv = (gs_scomplex*)malloc(n*sizeof(gs_scomplex));
  for(i=0;i<n;i++) {
    rv[i].r = vec[i].r + 1.0;
    rv[i].i = vec[i].i + 1.0;
  }
  return rv;
}

gs_dcomplex *return_dcomplex_vector(gs_dcomplex *vec, int n) {
  int i;
  gs_dcomplex *rv;

  rv = (gs_dcomplex*)malloc(n*sizeof(gs_dcomplex));
  for(i=0;i<n;i++) {
    rv[i].r = vec[i].r + 1.0;
    rv[i].i = vec[i].i + 1.0;
  }
  return rv;
}



char *return_char_vector(char *vec, int n) {
  int i;
  char *rv;

  rv = (char*)malloc(n*sizeof(char));
  for(i=0;i<n;i++)
    rv[i] = vec[i] + 1;
  return rv;
}

int *return_int_matrix(int *vec, int m, int n) {
  int i,*rv;
  rv = (int*)malloc(m*n*sizeof(int));
  for(i=0;i<m*n;i++)
    rv[i] = vec[i] + 1;
  return rv;
}

float *return_float_matrix(float *vec, int m, int n) {
  int i;
  float *rv;

  rv = (float*)malloc(m*n*sizeof(float));
  for(i=0;i<m*n;i++)
    rv[i] = vec[i] + (float)1.0;
  return rv;
}

double *return_double_matrix(double *vec, int m, int n) {
  int i;
  double *rv;

  rv = (double*)malloc(m*n*sizeof(double));
  for(i=0;i<m*n;i++)
    rv[i] = vec[i] + 1.0;
  return rv;
}

gs_scomplex *return_scomplex_matrix(gs_scomplex *vec, int m, int n) {
  int i;
  gs_scomplex *rv;

  rv = (gs_scomplex*)malloc(m*n*sizeof(gs_scomplex));
  for(i=0;i<m*n;i++) {
    rv[i].r = vec[i].r + 1.0;
    rv[i].i = vec[i].i + 1.0;
  }
  return rv;
}

gs_dcomplex *return_dcomplex_matrix(gs_dcomplex *vec, int m, int n) {
  int i;
  gs_dcomplex *rv;

  rv = (gs_dcomplex*)malloc(m*n*sizeof(gs_dcomplex));
  for(i=0;i<m*n;i++) {
    rv[i].r = vec[i].r + 1.0;
    rv[i].i = vec[i].i + 1.0;
  }
  return rv;
}

char *return_char_matrix(char *vec, int m, int n) {
  int i;
  char *rv;

  rv = (char*)malloc(m*n*sizeof(char));
  for(i=0;i<m*n;i++)
    rv[i] = vec[i] + 1;
  return rv;
}

int
do_file_stuff(int infd, int inoutfd, int outfd) 
{
#define FILETEST_BUFSZ 4096
  char buf[FILETEST_BUFSZ];
  int i, n;

  while((n=read(infd, buf, FILETEST_BUFSZ)) > 0) {
    for(i=0;i<n;i++)
      if(isalpha(buf[i]))
        buf[i] = buf[i] + 1;

    if(write(outfd, buf, n) != n) {
      printf("write error to outfile\n");
      return -1;
    }
  }

  if(n < 0) {
    printf("read error on infile\n");
    return -1;
  }

  if(read(inoutfd, buf, 1) < 0) {
    printf("read error on inoutfile\n");
    return -1;
  }

  if(lseek(inoutfd, 0, SEEK_SET) < 0) {
    printf("couldn't lseek() in inoutfile\n");
    return -1;
  }

  if(isalpha(buf[0])) {
    if(isupper(buf[0]))
      buf[0] = tolower(buf[0]);
    else
      buf[0] = toupper(buf[0]);
  }
  else
    buf[0] = 'a';

  if(write(inoutfd, buf, 1) < 0) {
    printf("write error on inoutfile\n");
    return -1;
  }

  return 0;
}

void
filetest(char *infile, char *inoutfile, char *outfile, 
  char **packed_in, char **packed_inout, char **packed_out, int n)
{
  int i, infd, inoutfd, outfd;
  int *packed_infd, *packed_inoutfd, *packed_outfd;

  packed_infd = (int *)malloc(n * sizeof(int));
  if(!packed_infd) {
    printf("malloc error\n");
    exit(-1);
  }

  packed_inoutfd = (int *)malloc(n * sizeof(int));
  if(!packed_inoutfd) {
    printf("malloc error\n");
    exit(-1);
  }

  packed_outfd = (int *)malloc(n * sizeof(int));
  if(!packed_outfd) {
    printf("malloc error\n");
    exit(-1);
  }

  infd = open(infile, O_RDONLY, 0600);
  if(infd < 0) {
    printf("error opening '%s'\n", infile);
    exit(-1);
  }

  inoutfd = open(inoutfile, O_RDWR, 0600);
  if(inoutfd < 0) {
    printf("error opening '%s'\n", inoutfile);
    exit(-1);
  }

  outfd = open(outfile, O_WRONLY | O_TRUNC | O_CREAT, 0600);
  if(outfd < 0) {
    printf("error opening '%s'\n", outfile);
    exit(-1);
  }

  for(i = 0; i < n; i++) {
    packed_infd[i] = open(packed_in[i], O_RDONLY, 0600);
    if(packed_infd[i] < 0) {
      printf("error opening '%s'\n", packed_in[i]);
      exit(-1);
    }

    packed_inoutfd[i] = open(packed_inout[i], O_RDWR, 0600);
    if(packed_inoutfd[i] < 0) {
      printf("error opening '%s'\n", packed_inout[i]);
      exit(-1);
    }

    packed_outfd[i] = open(packed_out[i], O_WRONLY | O_TRUNC | O_CREAT, 0600);
    if(packed_outfd[i] < 0) {
      printf("error opening '%s'\n", packed_out[i]);
      exit(-1);
    }
  }

  if(do_file_stuff(infd, inoutfd, outfd) < 0) {
    printf("GS_FILE test failed.\n");
    exit(-1);
  }

  for(i = 0; i < n; i++) {
    if(do_file_stuff(packed_infd[i], packed_inoutfd[i], packed_outfd[i]) < 0) {
      printf("GS_PACKEDFILE test failed.\n");
      exit(-1);
    }
  }

  close(infd);
  close(inoutfd);
  close(outfd);

  for(i = 0; i < n; i++) {
    close(packed_infd[i]);
    close(packed_inoutfd[i]);
    close(packed_outfd[i]);
  }

  free(packed_infd);
  free(packed_inoutfd);
  free(packed_outfd);

  return;
}

void
sparsetest(int dnnzi, int *dindi, int *dptri,
  double *dmat_i,
  int dnnzio, int *dindio, int *dptrio,
  double *dmat_io,  
  int dnnzo, int *dindo, int *dptro,
  double *dmat_o,  

  int fnnzi, int *findi, int *fptri,
  float *fmat_i,
  int fnnzio, int *findio, int *fptrio,
  float *fmat_io,
  int fnnzo, int *findo, int *fptro,
  float *fmat_o,

  int innzi, int *iindi, int *iptri,
  int *imat_i,
  int innzio, int *iindio, int *iptrio,
  int *imat_io,
  int innzo, int *iindo, int *iptro,
  int *imat_o,

  int cnnzi, int *cindi, int *cptri,
  char *cmat_i,
  int cnnzio, int *cindio, int *cptrio,
  char *cmat_io,
  int cnnzo, int *cindo, int *cptro,
  char *cmat_o,

  int k, int l)
{
  int i;

  for(i=0;i<dnnzio;i++)
    dmat_io[i] = dmat_io[i] + 1.0;

  for(i=0;i<MIN(dnnzo, dnnzi);i++)
    dmat_o[i] = dmat_i[i] + 1.0;
  for(i=0;i<dnnzo;i++) dindo[i] = dindi[i];
  for(i=0;i<k+1;i++) dptro[i] = dptri[i];

  for(i=0;i<fnnzio;i++)
    fmat_io[i] = fmat_io[i] + 1.0;

  for(i=0;i<MIN(fnnzo, fnnzi);i++)
    fmat_o[i] = fmat_i[i] + 1.0;
  for(i=0;i<fnnzo;i++) findo[i] = findi[i];
  for(i=0;i<k+1;i++) fptro[i] = fptri[i];

  for(i=0;i<innzio;i++)
    imat_io[i] = imat_io[i] + 1;

  for(i=0;i<MIN(innzo, innzi);i++)
    imat_o[i] = imat_i[i] + 1;
  for(i=0;i<innzo;i++) iindo[i] = iindi[i];
  for(i=0;i<k+1;i++) iptro[i] = iptri[i];

  for(i=0;i<cnnzio;i++)
    cmat_io[i] = cmat_io[i] + 1;

  for(i=0;i<MIN(cnnzo, cnnzi);i++)
    cmat_o[i] = cmat_i[i] + 1;
  for(i=0;i<cnnzo;i++) cindo[i] = cindi[i];
  for(i=0;i<k+1;i++) cptro[i] = cptri[i];

  return;
}

void 
sparse_double_matrix_test(
  int dnnzi, int *dindi, int *dptri, double *dmat_i,
  int dnnzo, int *dindo, int *dptro, double *dmat_o,
  int k, int l )
{
  int i;
  for(i=0;i<MIN(dnnzo, dnnzi);i++) dmat_o[i] = dmat_i[i] + 1.0;
  for(i=0;i<dnnzo;i++) dindo[i] = dindi[i];
  for(i=0;i<k+1;i++) dptro[i] = dptri[i];

  return;
}

void
simple_workspace_test(double *dvec, int n, double *work, double *outvec)
{
  int i;

  for(i=0;i<n;i++) {
    /* just reference all elements of work to make sure the array is allocated */
    work[i] = dvec[i] + 1.0;
    outvec[i] = work[i];
  }

  return;
}
