      SUBROUTINE FTOTAL(
     $   int_in, int_inout, int_out, int_work,
     $   float_in, float_inout, float_out, float_work,
     $   double_in, double_inout, double_out, double_work,
     $   scmp_in, scmp_inout, scmp_out, scmp_work,
     $   dcmp_in, dcmp_inout, dcmp_out, dcmp_work,
     $   char_in, char_inout, char_out, char_work,
     $   ivec_in, ivec_inout, ivec_out, ivec_work, ivec_len,
     $   fvec_in, fvec_inout, fvec_out, fvec_work, fvec_len,
     $   dvec_in, dvec_inout, dvec_out, dvec_work, dvec_len,
     $   scmp_vec_in, scmp_vec_inout, scmp_vec_out, 
     $     scmp_vec_work, scmp_vec_len,
     $   dcmp_vec_in, dcmp_vec_inout, dcmp_vec_out, 
     $     dcmp_vec_work, dcmp_vec_len,
     $   cvec_in, cvec_inout, cvec_out, cvec_work, cvec_len,
     $   imat_in, imat_inout, imat_out, imat_work, imat_m, imat_n,
     $   fmat_in, fmat_inout, fmat_out, fmat_work, fmat_m, fmat_n,
     $   dmat_in, dmat_inout, dmat_out, dmat_work, dmat_m, dmat_n,
     $   scmp_mat_in, scmp_mat_inout, scmp_mat_out, scmp_mat_work, 
     $     scmp_mat_m, scmp_mat_n,
     $   dcmp_mat_in, dcmp_mat_inout, dcmp_mat_out, dcmp_mat_work, 
     $     dcmp_mat_m, dcmp_mat_n,
     $   cmat_in, cmat_inout, cmat_out, cmat_work, cmat_m, cmat_n)
C
      integer int_in, int_inout, int_out, int_work
      real*4 float_in, float_inout, float_out, float_work
      double precision double_in, double_inout, double_out, double_work
      complex scmp_in, scmp_inout, scmp_out, scmp_work
      double complex dcmp_in, dcmp_inout, dcmp_out, dcmp_work
      character char_in, char_inout, char_out, char_work
C
      integer ivec_len, fvec_len, dvec_len, cvec_len, scmp_vec_len,
     $   dcmp_vec_len
C
      integer ivec_in(ivec_len),ivec_inout(ivec_len),
     $   ivec_out(ivec_len), ivec_work(ivec_len)
      real*4 fvec_in(fvec_len), fvec_inout(fvec_len), 
     $   fvec_out(fvec_len), fvec_work(fvec_len)
      double precision dvec_in(dvec_len), dvec_inout(dvec_len), 
     $   dvec_out(dvec_len), dvec_work(dvec_len)
      complex scmp_vec_in(scmp_vec_len), scmp_vec_inout(scmp_vec_len), 
     $   scmp_vec_out(scmp_vec_len), scmp_vec_work(scmp_vec_len)
      double complex dcmp_vec_in(dcmp_vec_len), 
     $   dcmp_vec_inout(dcmp_vec_len), dcmp_vec_out(dcmp_vec_len), 
     $   dcmp_vec_work(dcmp_vec_len)
      character cvec_in(cvec_len), cvec_inout(cvec_len), 
     $   cvec_out(cvec_len), cvec_work(cvec_len)
C
      integer imat_m, imat_n, fmat_m, fmat_n,
     $   dmat_m, dmat_n, cmat_m, cmat_n,
     $   scmp_mat_m, scmp_mat_n, dcmp_mat_m, dcmp_mat_n
C
      integer imat_in(imat_m, imat_n), imat_inout(imat_m, imat_n), 
     $   imat_out(imat_m, imat_n), imat_work(imat_m, imat_n)
      real*4 fmat_in(fmat_m, fmat_n), fmat_inout(fmat_m, fmat_n), 
     $   fmat_out(fmat_m, fmat_n), fmat_work(fmat_m, fmat_n)
      double precision dmat_in(dmat_m, dmat_n),
     $   dmat_inout(dmat_m, dmat_n), dmat_out(dmat_m, dmat_n),
     $   dmat_work(dmat_m, dmat_n)
      complex scmp_mat_in(scmp_mat_m, scmp_mat_n), 
     $   scmp_mat_inout(scmp_mat_m, scmp_mat_n), 
     $   scmp_mat_out(scmp_mat_m, scmp_mat_n),
     $   scmp_mat_work(scmp_mat_m, scmp_mat_n)
      double complex dcmp_mat_in(dcmp_mat_m, dcmp_mat_n), 
     $   dcmp_mat_inout(dcmp_mat_m, dcmp_mat_n), 
     $   dcmp_mat_out(dcmp_mat_m, dcmp_mat_n),
     $   dcmp_mat_work(dcmp_mat_m, dcmp_mat_n)
      character cmat_in(cmat_m, cmat_n), cmat_inout(cmat_m, cmat_n), 
     $   cmat_out(cmat_m, cmat_n), cmat_work(cmat_m, cmat_n)
C
      integer i,j
C
      int_inout = int_inout + 1
      int_out = int_in + 1
      int_work = 1
C
      float_inout = float_inout + 1.0
      float_out = float_in + 1.0
      float_work = 1.0
C
      double_inout = double_inout + 1.0
      double_out = double_in + 1.0
      double_work = 1.0
C
      scmp_inout = scmp_inout + (1.0,1.0)
      scmp_out = scmp_in + (1.0,1.0)
      scmp_work = (1.0,1.0)
C
      dcmp_inout = dcmp_inout + (1.0,1.0)
      dcmp_out = dcmp_in + (1.0,1.0)
      dcmp_work = (1.0,1.0)
C
      char_inout = char(ichar(char_inout) + 1)
      char_out = char(ichar(char_in) + 1)
      char_work = 'a'
C
      do 10 i=1,ivec_len
        ivec_inout(i) = ivec_inout(i) + 1
        ivec_out(i) = ivec_in(i) + 1
        ivec_work(i) = ivec_work(i) + 1
  10  continue
C
      do 20 i=1,fvec_len
        fvec_inout(i) = fvec_inout(i) + 1.0
        fvec_out(i) = fvec_in(i) + 1.0
        fvec_work(i) = fvec_work(i) + 1.0
  20  continue
C
      do 30 i=1,dvec_len
        dvec_inout(i) = dvec_inout(i) + 1.0
        dvec_out(i) = dvec_in(i) + 1.0
        dvec_work(i) = dvec_work(i) + 1.0
  30  continue
C
      do 35 i=1,scmp_vec_len
        scmp_vec_inout(i) = scmp_vec_inout(i) + (1.0,1.0)
        scmp_vec_out(i) = scmp_vec_in(i) + (1.0,1.0)
        scmp_vec_work(i) = scmp_vec_work(i) + (1.0,1.0)
  35  continue
C
      do 36 i=1,dcmp_vec_len
        dcmp_vec_inout(i) = dcmp_vec_inout(i) + (1.0,1.0)
        dcmp_vec_out(i) = dcmp_vec_in(i) + (1.0,1.0)
        dcmp_vec_work(i) = dcmp_vec_work(i) + (1.0,1.0)
  36  continue
C
      do 40 i=1,cvec_len
        cvec_inout(i) = char(ichar(cvec_inout(i)) + 1)
        cvec_out(i) = char(ichar(cvec_in(i)) + 1)
        cvec_work(i) = char(ichar(cvec_work(i)) + 1)
  40  continue
C
      do 60 i=1,imat_m
        do 50 j=1,imat_n
          imat_inout(i,j) = imat_inout(i,j) + 1
          imat_out(i,j) = imat_in(i,j) + 1
          imat_work(i,j) = imat_work(i,j) + 1
  50    continue
  60  continue
C
      do 80 i=1,fmat_m
        do 70 j=1,fmat_n
          fmat_inout(i,j) = fmat_inout(i,j) + 1.0
          fmat_out(i,j) = fmat_in(i,j) + 1.0
          fmat_work(i,j) = fmat_work(i,j) + 1.0
  70    continue
  80  continue
C
      do 100 i=1,dmat_m
        do 90 j=1,dmat_n
          dmat_inout(i,j) = dmat_inout(i,j) + 1.0
          dmat_out(i,j) = dmat_in(i,j) + 1.0
          dmat_work(i,j) = dmat_work(i,j) + 1.0
  90    continue
 100  continue
C
      do 102 i=1,scmp_mat_m
        do 101 j=1,scmp_mat_n
          scmp_mat_inout(i,j) = scmp_mat_inout(i,j) + (1.0,1.0)
          scmp_mat_out(i,j) = scmp_mat_in(i,j) + (1.0,1.0)
          scmp_mat_work(i,j) = scmp_mat_work(i,j) + (1.0,1.0)
 101    continue
 102  continue
C
      do 104 i=1,dcmp_mat_m
        do 103 j=1,dcmp_mat_n
          dcmp_mat_inout(i,j) = dcmp_mat_inout(i,j) + (1.0,1.0)
          dcmp_mat_out(i,j) = dcmp_mat_in(i,j) + (1.0,1.0)
          dcmp_mat_work(i,j) = dcmp_mat_work(i,j) + (1.0,1.0)
 103    continue
 104  continue
C
      do 120 i=1,cmat_m
        do 110 j=1,cmat_n
          cmat_inout(i,j) = char(ichar(cmat_inout(i,j)) + 1)
          cmat_out(i,j) = char(ichar(cmat_in(i,j)) + 1)
          cmat_work(i,j) = char(ichar(cmat_work(i,j)) + 1)
 110    continue
 120  continue
C
      return
      end
