/* 
 * @file
 *
 * This file contains various utility functions used for
 * the agent database.  Many of the functions in this file
 * were taken from the sqlite source, which is public
 * domain.  That is why they do not have an gs_ prefix.
 */
/* $Id: gs_storage_sqlite_util.c,v 1.14 2007/03/22 22:41:16 seymour Exp $ */
/* $UTK_Copyright: $ */

#include <assert.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>

#include "sqlite3.h"

/**
 * Determines if a string is a number of not.
 */

static int 
isNumber(const char *z, int *realnum)
{
  if( *z=='-' || *z=='+' ) z++;
  if( !isdigit(*z) ){
    return 0;
  }
  z++;
  if( realnum ) *realnum = 0;
  while( isdigit(*z) ){ z++; }
  if( *z=='.' ){
    z++;
    if( !isdigit(*z) ) return 0;
    while( isdigit(*z) ){ z++; }
    if( realnum ) *realnum = 1;
  }
  if( *z=='e' || *z=='E' ){
    z++;
    if( *z=='+' || *z=='-' ) z++;
    if( !isdigit(*z) ) return 0;
    while( isdigit(*z) ){ z++; }
    if( realnum ) *realnum = 1;
  }
  return *z==0;
}

int 
sqliteIsNumber(const char *c)
{
  return isNumber(c,0);
}
