#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include "grpc.h"

grpc_error_t 
grpc_dsi_close(DSI_FILE *dsi_file)
{
#ifdef DSI_IBP
  struct ibp_timer ls_timeout;
  struct ibp_capstatus ls_info;

  ls_timeout.ServerSync = 10;
  ls_timeout.ClientTimeout = 10;

  if(IBP_manage(dsi_file->dsi_specifics.ibp.cap->manageCap,
            &ls_timeout, IBP_DECR, IBP_READCAP, &ls_info) < 0)
    GRPC_RETURN(GRPC_OTHER_ERROR_CODE, GRPC_DSI_MANAGE_ERROR);

  GRPC_RETURN(GRPC_NO_ERROR, GRPC_NO_MINOR_ERROR);
#endif

  GRPC_RETURN(GRPC_OTHER_ERROR_CODE, GRPC_DSI_DISABLED);
}
