/**
 * Translate and copy the argvs from IDL to GridSolve C client.
 *
 * This is part of the IDL Client for GridSolve.
 **/
/* $Id: translate.h,v 1.7 2007/03/05 20:52:40 seymour Exp $ */
/* $UTK_Copyright: $ */

/* For debug use: */
void
  debug_print(char *),
  print_array(int, int, double *);

/* Truncate "()" from the function name if necessary */
int trunc_fname(char *);

/* The key transformation function */
int convert_idl(gs_problem_t *, IDL_VPTR *);

/* After each gridsolve function call, it will free the tmp-allocated 
 * storage and copy the output to IDL's VPTR whenever necessary.
 */
int postproc_argv_c(gs_problem_t *, IDL_VPTR *);

/***********  The following are internal routines  *********/

/* Macro for copying data from array a to array b, where b has type TYPEB */

#define COPY_A_TO_B(TYPEA, TYPEB, size, a, b)  {int ss = 0; \
TYPEA* ss_a = (TYPEA*) a; TYPEB* ss_b = (TYPEB*) b; \
for (ss = 0; ss < size; ss++) *((ss_b)++) = (TYPEB) *((ss_a)++);}

int
  assign_arg(gs_argument_t *, IDL_VPTR),
  analyze_arg_pass_mode(gs_argument_t *),
  copy_scalar_input(gs_argument_t *, IDL_VPTR),
  copy_ptr_input(gs_argument_t *, IDL_VPTR),
  check_ptr_inout(gs_argument_t *, IDL_VPTR),
  copy_ptr_output(gs_argument_t *, IDL_VPTR),
  translate_array_input (gs_argument_t *, IDL_VPTR),
  translate_string_input(gs_argument_t *, IDL_VPTR),
  translate_scalar_input(IDL_VPTR, void *, int),
  translate_array_output (gs_argument_t *, IDL_VPTR),
  is_input_upcasted(IDL_VPTR, int, int);
