function [varargout] = gridsolve_nb(varargin)
% sessionid = gridsolve_nb('send', 'service', inputargs)
% status = gridsolve_nb('probe', sessionid)
% status = gridsolve_nb('cancel', sessionid)
% [outputargs, ...] = gridsolve_nb('wait', sessionid)
% 
% Asynchronous, non-blocking call to the GridSolve network solver.
% Returns a sessionid which can be used by other calls to check on the
% service.  Use gs_info('service') to see the the arguments for the
% service.
%
% See also gs_wait, gs_probe, gs_cancel for details on probing,
% waiting, canceling.

mexindex = 0;
if (nargin < 2)
  fprintf('Error: Insufficient parameters\n');
else
  if (strcmp(varargin{1},'send')==1) 
    mexindex = 2;
  elseif (strcmp(varargin{1},'wait')==1) 
    mexindex = 3;
  elseif (strcmp(varargin{1},'probe')==1) 
    mexindex = 6;
  elseif (strcmp(varargin{1},'cancel')==1) 
    mexindex = 7;
  end
end
  
if (nargout > 0) 
  for i=1:nargout, varargout{i} = []; end
  [varargout{:}] = matlab_gs_lib(mexindex, varargin{2:size(varargin,2)});
else 
  matlab_gs_lib(mexindex, varargin{2:size(varargin,2)});
end
