function [varargout] = gs_call_async(varargin)
% sessionid = gs_call_async('service', inputargs, ...)
% 
% Asynchronous, non-blocking call to the GridSolve network solver.
% Returns a sessionid which can be used by other calls to check on the
% service.  Use gs_info('service') to see the the arguments for the
% service.
%
% See also gs_wait, gs_probe, gs_cancel

if (nargout~=1 | nargin<1),
    error('Usage: [request_id] = gs_call_async(''service_name'', ...) \n');
end

if (nargout>0),
  for i=1:nargout, varargout{i} = []; end
  [varargout{:}] = matlab_gs_lib(2, varargin{:});
else 
  matlab_gs_lib(2, varargin{:});
end


