function [varargout] = gs_probe_or(varargin)
% [status, sessionid] = gs_probe_or(sessionid_array)
% 
% Check on the status of an array of service requests that were
% previously submitted to the GridSolve network enabled solver.
% Return status can be
% GRPC_NO_ERROR                  0
% GRPC_INVALID_SESSION_ID        8
% GRPC_NONE_COMPLETED           13
% GRPC_OTHER_ERROR_CODE         14
%
% If there was no error (status=0) then the returned sessionid
% points to a completed service, whose results can be fetched using
% a gs_wait call.
%
% See also gs_call_async

if (nargout > 0) 
  for i=1:nargout, varargout{i} = []; end
  [varargout{:}] = matlab_gs_lib(10, varargin{:});
else 
  matlab_gs_lib(10, varargin{:});
end

