#include <oct.h>

#ifndef _GS_OCTAVE_H_
#define _GS_OCTAVE_H_

double *oct_GetPr(octave_value arg);
double *oct_GetPi(octave_value arg);
double *oct_GetSparsePr(octave_value arg);
double *oct_GetSparsePi(octave_value arg);
int *oct_GetSparseIr(octave_value arg);
int *oct_GetSparseJc(octave_value arg);

int convert_octave_arguments(gs_problem_t* pd, octave_value_list oct_args);
int convert_matrix(gs_argument_t *argp, octave_value_list octval, int i);
int convert_sparse_matrix(gs_problem_t *pd, gs_argument_t *argp, octave_value_list octval, int i);
int convert_vector(gs_argument_t *argp, octave_value_list octval, int i);
int convert_scalar(gs_argument_t *argp, octave_value_list octval, int i);
int convert_file_argument(gs_argument_t *argp, octave_value_list octval, int index);
int convert_packed_file_argument(gs_argument_t *argp, octave_value_list octval, int index);
int process_gs_out_arguments(gs_problem_t* pd);

int convert_output_objects(gs_problem_t* pd, octave_value_list& retvals);
int fill_matrix(gs_argument_t *argp, octave_value_list& retval);
int fill_sparse_matrix(gs_problem_t *pd, gs_argument_t *argp, octave_value_list& retval);
int fill_vector(gs_argument_t *argp, octave_value_list& retval);
int fill_scalar(gs_argument_t *argp, octave_value_list& retval);
int fill_file_argument(gs_argument_t *argp, octave_value_list& retval);
int fill_packed_file_argument(gs_argument_t *argp, octave_value_list& retval);

int verify_allocation(void *ptr);

int sparsematrix_octcsc_to_gscsr(
    int m, int n, int nnz, int datatype,
    double *a, double *ai, int *colind, int *rowptr,
    void *at, int *rowind, int *colptr);

#endif
