
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 14 "problem_idl_parser.y"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#ifdef WIN32 
#  include "portability.h"
#else
#  include <unistd.h>
#endif

#include "idl_parsing_defs.h"
#include "problem.h"
#include "utility.h"

typedef struct expr_s {
  double val;
  char *str;
  struct expr_s *next;
} expr_t;

#define YYDEBUG 1
#define YYERROR_VERBOSE 1
  
struct idl__buffer_state *idl__scan_string( const char *idl__str );
void idl__delete_buffer( struct idl__buffer_state * b );

/* Local function prototypes */

static expr_t * new_expr_node(double, char *);
static void free_expr_node(expr_t *);
static void free_expr_list(expr_t *);
static gs_argument_t *gs_new_arg(enum objecttype, char *, char *, enum inout,
  enum datatype, char *, char *, char *, char *, char *, gs_arg_enum_t *);
static char *gs_idl_complexity_expression(gs_problem_t *problem) ;
static int gs_idl_get_major(gs_problem_t *problem);
static double handle_intrinsic(char *, expr_t *);
static char * get_argument_string(expr_t *);
static int get_two_args(expr_t *, double *, double *);
static int get_one_arg(expr_t *, double *);

int idl_lex(void);
void yyerror(const char *);
int gs_copy_global_attributes(gs_problem_t *, gs_info_t *);

/* A global variable */
gs_problem_t *problemp = NULL;

extern int lineno;

/* AYK TODO; Check if there is some way to set first tok correctly */
#ifdef __INTERIX
int first_tok = 257; 
#else 
int first_tok = GSIDL_PARSE; 
#endif

icl_hash_t *symtab = NULL;
icl_list_t *var_list = NULL;

double expr_result;



/* Line 189 of yacc.c  */
#line 139 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     GSIDL_PARSE = 258,
     EXPR_EVAL_TOK = 259,
     RIGHT_OP = 260,
     LEFT_OP = 261,
     AND_OP = 262,
     OR_OP = 263,
     LE_OP = 264,
     GE_OP = 265,
     EQ_OP = 266,
     NE_OP = 267,
     ENUM_TOK = 268,
     IN_TOK = 269,
     OUT_TOK = 270,
     INOUT_TOK = 271,
     WORKSPACE = 272,
     VAROUT = 273,
     FUNCTION = 274,
     SUBROUTINE = 275,
     INT_TOK = 276,
     FLOAT_TOK = 277,
     DOUBLE_TOK = 278,
     CHAR_TOK = 279,
     SHORT_TOK = 280,
     LONG_TOK = 281,
     VOID_TOK = 282,
     SCOMPLEX = 283,
     DCOMPLEX = 284,
     FILE_TOK = 285,
     LANGUAGE = 286,
     MAJOR = 287,
     IDENTIFIER = 288,
     CONSTANT = 289,
     STRING_LITERAL = 290,
     INCLUDES = 291,
     COMPLEXITY = 292,
     PARALLEL = 293,
     CODE = 294,
     LIBS = 295
   };
#endif
/* Tokens.  */
#define GSIDL_PARSE 258
#define EXPR_EVAL_TOK 259
#define RIGHT_OP 260
#define LEFT_OP 261
#define AND_OP 262
#define OR_OP 263
#define LE_OP 264
#define GE_OP 265
#define EQ_OP 266
#define NE_OP 267
#define ENUM_TOK 268
#define IN_TOK 269
#define OUT_TOK 270
#define INOUT_TOK 271
#define WORKSPACE 272
#define VAROUT 273
#define FUNCTION 274
#define SUBROUTINE 275
#define INT_TOK 276
#define FLOAT_TOK 277
#define DOUBLE_TOK 278
#define CHAR_TOK 279
#define SHORT_TOK 280
#define LONG_TOK 281
#define VOID_TOK 282
#define SCOMPLEX 283
#define DCOMPLEX 284
#define FILE_TOK 285
#define LANGUAGE 286
#define MAJOR 287
#define IDENTIFIER 288
#define CONSTANT 289
#define STRING_LITERAL 290
#define INCLUDES 291
#define COMPLEXITY 292
#define PARALLEL 293
#define CODE 294
#define LIBS 295




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 79 "problem_idl_parser.y"

  char *strp;
  gs_argument_t *argp;
  gs_arg_enum_t *enump;
  gs_problem_t *problemp;
  gs_info_t *infop;
  enum inout inout;
  enum datatype datatype;
  int op;
  struct expr_s *expr;



/* Line 214 of yacc.c  */
#line 269 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 281 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  42
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   174

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  63
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  41
/* YYNRULES -- Number of rules.  */
#define YYNRULES  108
/* YYNRULES -- Number of states.  */
#define YYNSTATES  179

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   295

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    54,     2,     2,     2,    57,    58,     2,
      41,    42,    55,    51,    46,    52,     2,    56,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    62,     2,
      49,    45,    50,    61,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    43,     2,    44,    59,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    47,    60,    48,    53,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     7,    10,    12,    14,    16,    19,    21,
      29,    38,    44,    47,    49,    51,    52,    55,    57,    61,
      65,    67,    68,    86,    97,   105,   111,   116,   124,   126,
     128,   130,   132,   134,   136,   138,   139,   145,   146,   150,
     152,   154,   156,   158,   160,   162,   164,   166,   168,   170,
     172,   174,   176,   178,   180,   182,   184,   186,   188,   190,
     194,   196,   200,   205,   207,   211,   213,   216,   218,   220,
     222,   224,   226,   231,   233,   237,   241,   245,   247,   251,
     255,   257,   261,   265,   267,   271,   275,   279,   283,   285,
     289,   293,   295,   299,   301,   305,   307,   311,   313,   317,
     319,   323,   325,   331,   333,   335,   337,   339,   341
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      64,     0,    -1,     3,    71,    68,    -1,     4,    84,    -1,
      33,    -1,    34,    -1,    35,    -1,    68,    69,    -1,    69,
      -1,    70,    65,    41,    74,    42,    78,    71,    -1,    19,
      82,    43,    85,    44,    43,    85,    44,    -1,    19,    82,
      43,    85,    44,    -1,    19,    82,    -1,    20,    -1,    72,
      -1,    -1,    72,    73,    -1,    73,    -1,    83,    45,    67,
      -1,    74,    46,    75,    -1,    75,    -1,    -1,    77,    82,
      65,    43,    85,    44,    43,    85,    44,    47,    76,    46,
      76,    46,    76,    48,    78,    -1,    77,    82,    65,    43,
      85,    44,    43,    85,    44,    78,    -1,    77,    82,    65,
      43,    85,    44,    78,    -1,    77,    82,    65,    78,    79,
      -1,    77,    30,    65,    78,    -1,    77,    30,    65,    43,
      85,    44,    78,    -1,    65,    -1,    14,    -1,    16,    -1,
      15,    -1,    18,    -1,    17,    -1,    67,    -1,    -1,    13,
      45,    49,    80,    50,    -1,    -1,    80,    46,    81,    -1,
      81,    -1,    67,    -1,    21,    -1,    24,    -1,    22,    -1,
      28,    -1,    29,    -1,    23,    -1,    31,    -1,    32,    -1,
      40,    -1,    36,    -1,    37,    -1,    38,    -1,    39,    -1,
      65,    -1,   102,    -1,   102,    -1,    65,    -1,    66,    -1,
      41,   102,    42,    -1,    86,    -1,    65,    41,    42,    -1,
      65,    41,    88,    42,    -1,   102,    -1,    88,    46,   102,
      -1,    87,    -1,    90,    91,    -1,    51,    -1,    52,    -1,
      53,    -1,    54,    -1,    89,    -1,    41,   103,    42,    91,
      -1,    91,    -1,    92,    55,    91,    -1,    92,    56,    91,
      -1,    92,    57,    91,    -1,    92,    -1,    93,    51,    92,
      -1,    93,    52,    92,    -1,    93,    -1,    94,     6,    93,
      -1,    94,     5,    93,    -1,    94,    -1,    95,    49,    94,
      -1,    95,    50,    94,    -1,    95,     9,    94,    -1,    95,
      10,    94,    -1,    95,    -1,    96,    11,    95,    -1,    96,
      12,    95,    -1,    96,    -1,    97,    58,    96,    -1,    97,
      -1,    98,    59,    97,    -1,    98,    -1,    99,    60,    98,
      -1,    99,    -1,   100,     7,    99,    -1,   100,    -1,   101,
       8,   100,    -1,   101,    -1,   101,    61,   102,    62,   102,
      -1,    24,    -1,    25,    -1,    21,    -1,    26,    -1,    22,
      -1,    23,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   121,   121,   128,   135,   141,   147,   153,   163,   169,
     213,   220,   226,   231,   237,   242,   247,   257,   263,   279,
     289,   294,   299,   310,   318,   325,   331,   337,   346,   352,
     356,   360,   364,   368,   374,   379,   384,   389,   394,   404,
     410,   418,   422,   426,   430,   434,   438,   444,   448,   452,
     456,   460,   464,   468,   472,   478,   483,   490,   512,   523,
     534,   538,   548,   564,   568,   581,   585,   609,   613,   617,
     621,   628,   632,   664,   668,   680,   692,   707,   711,   723,
     738,   742,   754,   769,   773,   785,   797,   809,   824,   828,
     840,   855,   859,   874,   878,   893,   897,   912,   916,   931,
     935,   950,   954,   970,   974,   978,   982,   986,   990
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "GSIDL_PARSE", "EXPR_EVAL_TOK",
  "RIGHT_OP", "LEFT_OP", "AND_OP", "OR_OP", "LE_OP", "GE_OP", "EQ_OP",
  "NE_OP", "ENUM_TOK", "IN_TOK", "OUT_TOK", "INOUT_TOK", "WORKSPACE",
  "VAROUT", "FUNCTION", "SUBROUTINE", "INT_TOK", "FLOAT_TOK", "DOUBLE_TOK",
  "CHAR_TOK", "SHORT_TOK", "LONG_TOK", "VOID_TOK", "SCOMPLEX", "DCOMPLEX",
  "FILE_TOK", "LANGUAGE", "MAJOR", "IDENTIFIER", "CONSTANT",
  "STRING_LITERAL", "INCLUDES", "COMPLEXITY", "PARALLEL", "CODE", "LIBS",
  "'('", "')'", "'['", "']'", "'='", "','", "'{'", "'}'", "'<'", "'>'",
  "'+'", "'-'", "'~'", "'!'", "'*'", "'/'", "'%'", "'&'", "'^'", "'|'",
  "'?'", "':'", "$accept", "Start", "Identifier", "Constant",
  "StringLiteral", "Problemlist", "Problem", "ProbSpec",
  "OptionalInfolist", "Infolist", "Info", "Arglist", "Arg", "SpDim",
  "Inout", "Description", "EnumDecl", "EnumValList", "EnumVal", "Datatype",
  "Infotype", "DimEvaluated", "Dim", "primary_expression",
  "postfix_expression", "argument_expression_list", "unary_expression",
  "unary_operator", "cast_expression", "multiplicative_expression",
  "additive_expression", "shift_expression", "relational_expression",
  "equality_expression", "and_expression", "exclusive_or_expression",
  "inclusive_or_expression", "logical_and_expression",
  "logical_or_expression", "expression", "type_specifier", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    40,    41,    91,    93,    61,    44,   123,   125,    60,
      62,    43,    45,   126,    33,    42,    47,    37,    38,    94,
     124,    63,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    63,    64,    64,    65,    66,    67,    68,    68,    69,
      70,    70,    70,    70,    71,    71,    72,    72,    73,    74,
      74,    74,    75,    75,    75,    75,    75,    75,    76,    77,
      77,    77,    77,    77,    78,    78,    79,    79,    80,    80,
      81,    82,    82,    82,    82,    82,    82,    83,    83,    83,
      83,    83,    83,    83,    83,    84,    85,    86,    86,    86,
      87,    87,    87,    88,    88,    89,    89,    90,    90,    90,
      90,    91,    91,    92,    92,    92,    92,    93,    93,    93,
      94,    94,    94,    95,    95,    95,    95,    95,    96,    96,
      96,    97,    97,    98,    98,    99,    99,   100,   100,   101,
     101,   102,   102,   103,   103,   103,   103,   103,   103
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     2,     1,     1,     1,     2,     1,     7,
       8,     5,     2,     1,     1,     0,     2,     1,     3,     3,
       1,     0,    17,    10,     7,     5,     4,     7,     1,     1,
       1,     1,     1,     1,     1,     0,     5,     0,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     3,     4,     1,     3,     1,     2,     1,     1,     1,
       1,     1,     4,     1,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     3,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     5,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    15,     0,     0,    47,    48,     4,    50,    51,    52,
      53,    49,    54,     0,    14,    17,     0,     5,     0,    67,
      68,    69,    70,    57,    58,     3,    60,    65,    71,     0,
      73,    77,    80,    83,    88,    91,    93,    95,    97,    99,
     101,    55,     1,     0,    13,     2,     8,     0,    16,     0,
     105,   107,   108,   103,   104,   106,     0,     0,     0,    66,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    41,
      43,    46,    42,    44,    45,    12,     7,     0,     6,    18,
      59,     0,    61,     0,    63,    74,    75,    76,    78,    79,
      82,    81,    86,    87,    84,    85,    89,    90,    92,    94,
      96,    98,   100,     0,     0,    21,    72,    62,     0,     0,
       0,    56,    29,    31,    30,    33,    32,     0,    20,     0,
      64,   102,    11,    35,     0,     0,     0,     0,    34,    15,
      19,    35,    35,     0,     9,     0,    26,     0,    37,    10,
       0,     0,     0,    25,    35,    35,     0,    27,     0,    24,
       0,     0,    40,     0,    39,    35,     0,    36,     0,    23,
      38,    28,     0,     0,     0,     0,     0,    35,    22
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,    23,    24,   138,    45,    46,    47,    13,    14,
      15,   127,   128,   172,   129,   139,   153,   163,   164,    85,
      16,    25,   120,    26,    27,    93,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,   121,
      57
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -151
static const yytype_int16 yypact[] =
{
       2,    70,    46,    11,  -151,  -151,  -151,  -151,  -151,  -151,
    -151,  -151,  -151,    17,    70,  -151,    19,  -151,    18,  -151,
    -151,  -151,  -151,   -15,  -151,  -151,  -151,  -151,  -151,    46,
    -151,    20,    16,    48,    -2,    50,    -3,    22,    34,    75,
      -4,  -151,  -151,    67,  -151,    17,  -151,    80,  -151,    81,
    -151,  -151,  -151,  -151,  -151,  -151,    73,    83,    32,  -151,
      46,    46,    46,    46,    46,    46,    46,    46,    46,    46,
      46,    46,    46,    46,    46,    46,    46,    46,    46,  -151,
    -151,  -151,  -151,  -151,  -151,    74,  -151,    85,  -151,  -151,
    -151,    46,  -151,   -11,  -151,  -151,  -151,  -151,    20,    20,
      16,    16,    48,    48,    48,    48,    -2,    -2,    50,    -3,
      22,    34,    75,    65,    46,   125,  -151,  -151,    46,    46,
      87,  -151,  -151,  -151,  -151,  -151,  -151,     3,  -151,   100,
    -151,  -151,    89,    81,   125,    80,    80,    46,  -151,    70,
    -151,   -23,   -19,    92,  -151,    46,  -151,    46,   120,  -151,
      93,   104,   105,  -151,    81,   -14,   102,  -151,    46,  -151,
      81,   108,  -151,    10,  -151,   -25,    81,  -151,    80,  -151,
    -151,  -151,   103,    80,   107,    80,   106,    81,  -151
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -151,  -151,    -1,  -151,   -46,  -151,   110,  -151,    21,  -151,
     142,  -151,    23,  -150,  -151,  -127,  -151,  -151,    -8,    30,
    -151,  -151,  -128,  -151,  -151,  -151,  -151,  -151,   -28,    29,
      39,    77,    40,    88,    90,    91,    86,    94,  -151,     0,
    -151
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      12,    59,    41,    89,    77,     1,     2,    67,    68,   143,
      88,    42,    88,    12,   146,   148,    88,   150,    56,   151,
     145,    88,   168,   174,   147,   176,    58,   157,   159,   158,
     161,   117,    95,    96,    97,   118,    43,    44,   169,    50,
      51,    52,    53,    54,    55,   133,    87,    69,    70,   134,
     178,     6,    17,    65,    66,    73,   166,    78,    94,    18,
     167,    71,    72,   116,    49,     6,    17,    63,    64,    19,
      20,    21,    22,    18,    92,    60,    61,    62,   113,     6,
      17,    74,    76,    19,    20,    21,    22,    18,    79,    80,
      81,    82,    98,    99,    75,    83,    84,    19,    20,    21,
      22,     4,     5,     6,   100,   101,     7,     8,     9,    10,
      11,   106,   107,     6,   162,    90,    88,   114,   130,   131,
     162,    79,    80,    81,    82,    91,   115,   119,    83,    84,
     135,   132,   137,   152,   141,   142,   149,   154,    12,   122,
     123,   124,   125,   126,   102,   103,   104,   105,   155,   173,
     156,   160,   165,   175,   177,    86,    48,   140,   170,   136,
     144,   108,   111,     0,   109,     0,   110,   171,     0,     0,
       0,   112,   171,     0,   171
};

static const yytype_int16 yycheck[] =
{
       1,    29,     2,    49,     8,     3,     4,     9,    10,   137,
      35,     0,    35,    14,   141,   142,    35,   145,    18,   147,
      43,    35,    47,   173,    43,   175,    41,   154,   155,    43,
     158,    42,    60,    61,    62,    46,    19,    20,   165,    21,
      22,    23,    24,    25,    26,    42,    47,    49,    50,    46,
     177,    33,    34,     5,     6,    58,    46,    61,    58,    41,
      50,    11,    12,    91,    45,    33,    34,    51,    52,    51,
      52,    53,    54,    41,    42,    55,    56,    57,    78,    33,
      34,    59,     7,    51,    52,    53,    54,    41,    21,    22,
      23,    24,    63,    64,    60,    28,    29,    51,    52,    53,
      54,    31,    32,    33,    65,    66,    36,    37,    38,    39,
      40,    71,    72,    33,   160,    42,    35,    43,   118,   119,
     166,    21,    22,    23,    24,    42,    41,    62,    28,    29,
      30,    44,    43,    13,   135,   136,    44,    44,   139,    14,
      15,    16,    17,    18,    67,    68,    69,    70,    44,    46,
      45,    49,    44,    46,    48,    45,    14,   134,   166,   129,
     139,    73,    76,    -1,    74,    -1,    75,   168,    -1,    -1,
      -1,    77,   173,    -1,   175
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,    64,    31,    32,    33,    36,    37,    38,
      39,    40,    65,    71,    72,    73,    83,    34,    41,    51,
      52,    53,    54,    65,    66,    84,    86,    87,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,     0,    19,    20,    68,    69,    70,    73,    45,
      21,    22,    23,    24,    25,    26,   102,   103,    41,    91,
      55,    56,    57,    51,    52,     5,     6,     9,    10,    49,
      50,    11,    12,    58,    59,    60,     7,     8,    61,    21,
      22,    23,    24,    28,    29,    82,    69,    65,    35,    67,
      42,    42,    42,    88,   102,    91,    91,    91,    92,    92,
      93,    93,    94,    94,    94,    94,    95,    95,    96,    97,
      98,    99,   100,   102,    43,    41,    91,    42,    46,    62,
      85,   102,    14,    15,    16,    17,    18,    74,    75,    77,
     102,   102,    44,    42,    46,    30,    82,    43,    67,    78,
      75,    65,    65,    85,    71,    43,    78,    43,    78,    44,
      85,    85,    13,    79,    44,    44,    45,    78,    43,    78,
      49,    85,    67,    80,    81,    44,    46,    50,    47,    78,
      81,    65,    76,    46,    76,    46,    76,    48,    78
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 122 "problem_idl_parser.y"
    {
           /* set the global before finishing */
           problemp = (yyval.problemp) = (yyvsp[(3) - (3)].problemp);

           gs_copy_global_attributes(problemp, (yyvsp[(2) - (3)].infop));
         }
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 129 "problem_idl_parser.y"
    {
           expr_result = (yyvsp[(2) - (2)].expr)->val;
           free_expr_node((yyvsp[(2) - (2)].expr));
         }
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 136 "problem_idl_parser.y"
    {
              (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
            }
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 142 "problem_idl_parser.y"
    {
            (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
          }
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 148 "problem_idl_parser.y"
    {
                 (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
               }
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 154 "problem_idl_parser.y"
    {
                gs_problem_t *prob;

                /* skip to the end of the list and link the new entry */
                for(prob = (yyvsp[(1) - (2)].problemp); prob && prob->next; prob=prob->next)
                  /* spin */;
                prob->next = (yyvsp[(2) - (2)].problemp);
                (yyval.problemp) = (yyvsp[(1) - (2)].problemp);
              }
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 164 "problem_idl_parser.y"
    {
                (yyval.problemp) = (yyvsp[(1) - (1)].problemp);
              }
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 170 "problem_idl_parser.y"
    {
            gs_problem_t *prob;

            prob = (gs_problem_t *)calloc(1, sizeof(gs_problem_t));
            if(!prob) {
              ERRPRINTF("Could not allocate memory\n");
              exit(-1);
            }
            prob->name = (yyvsp[(2) - (7)].strp);
            prob->arglist = (yyvsp[(4) - (7)].argp);
            prob->description = (yyvsp[(6) - (7)].strp);
            prob->infolist = (yyvsp[(7) - (7)].infop);
            prob->work = NULL;
            prob->worksize = 0;
            prob->next = NULL;

            if((prob->major = gs_idl_get_major(prob)) < 0) {
              yyerror("Error: bad MAJOR specified.  Must be ROW or COLUMN.\n");
              exit(-1);
            }

            /* if there is a return value specified, then add a new argument
             * at the end of the calling sequence.
             */
            if((yyvsp[(1) - (7)].argp)) {
              gs_argument_t *a;

              /* skip to the end of the argument list */
              for(a = (yyvsp[(4) - (7)].argp); a && a->next; a=a->next)
                /* spin */;

              a->next = (yyvsp[(1) - (7)].argp);
              (yyvsp[(1) - (7)].argp)->next = NULL;

              prob->type = GS_FUNCTION;
            }
            else
              prob->type = GS_SUBROUTINE;

            (yyval.problemp) = prob;
          }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 214 "problem_idl_parser.y"
    {
             (yyval.argp) = gs_new_arg(GS_MATRIX, "__retval", "Return value", 
                     GS_OUT, (yyvsp[(2) - (8)].datatype), (yyvsp[(4) - (8)].strp), (yyvsp[(7) - (8)].strp), "0", "0", "0", NULL);
             free((yyvsp[(4) - (8)].strp));
             free((yyvsp[(7) - (8)].strp));
           }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 221 "problem_idl_parser.y"
    {
             (yyval.argp) = gs_new_arg(GS_VECTOR, "__retval", "Return value", 
                     GS_OUT, (yyvsp[(2) - (5)].datatype), (yyvsp[(4) - (5)].strp), "1", "0", "0", "0", NULL);
             free((yyvsp[(4) - (5)].strp));
           }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 227 "problem_idl_parser.y"
    {
             (yyval.argp) = gs_new_arg(GS_SCALAR, "__retval", "Return value", 
                     GS_OUT, (yyvsp[(2) - (2)].datatype), "1", "1", "0", "0", "0", NULL);
           }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 232 "problem_idl_parser.y"
    {
             (yyval.argp) = NULL;
           }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 238 "problem_idl_parser.y"
    {
                    (yyval.infop) = (yyvsp[(1) - (1)].infop);
                  }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 242 "problem_idl_parser.y"
    {
                    (yyval.infop) = NULL;
                  }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 248 "problem_idl_parser.y"
    {
             gs_info_t *infop;

             /* skip to the end of the list and link the new entry */
             for(infop = (yyvsp[(1) - (2)].infop); infop && infop->next; infop=infop->next)
               /* spin */;
             infop->next = (yyvsp[(2) - (2)].infop);
             (yyval.infop) = (yyvsp[(1) - (2)].infop);
           }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 258 "problem_idl_parser.y"
    {
             (yyval.infop) = (yyvsp[(1) - (1)].infop);
           }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 264 "problem_idl_parser.y"
    {
         gs_info_t *infop;

         infop = (gs_info_t *)malloc(sizeof(gs_info_t));
         if(!infop) {
           ERRPRINTF("Could not allocate memory\n");
           exit(-1);
         }
         infop->type = (yyvsp[(1) - (3)].strp);
         infop->value = (yyvsp[(3) - (3)].strp);
         infop->next = NULL;
         (yyval.infop) = infop; 
       }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 280 "problem_idl_parser.y"
    {
            gs_argument_t *argp;

            /* skip to the end of the list and link the new entry */
            for(argp = (yyvsp[(1) - (3)].argp); argp && argp->next; argp=argp->next)
              /* spin */;
            argp->next = (yyvsp[(3) - (3)].argp);
            (yyval.argp) = (yyvsp[(1) - (3)].argp);
          }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 290 "problem_idl_parser.y"
    {
            (yyval.argp) = (yyvsp[(1) - (1)].argp);
          }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 294 "problem_idl_parser.y"
    {
            (yyval.argp)=NULL;
          }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 300 "problem_idl_parser.y"
    {
        (yyval.argp) = gs_new_arg(GS_SPARSEMATRIX, (yyvsp[(3) - (17)].strp), (yyvsp[(17) - (17)].strp), (yyvsp[(1) - (17)].inout), (yyvsp[(2) - (17)].datatype), (yyvsp[(5) - (17)].strp), (yyvsp[(8) - (17)].strp), (yyvsp[(11) - (17)].strp), (yyvsp[(13) - (17)].strp), (yyvsp[(15) - (17)].strp), NULL);
        free((yyvsp[(3) - (17)].strp));
        free((yyvsp[(5) - (17)].strp));
        free((yyvsp[(8) - (17)].strp));
        free((yyvsp[(11) - (17)].strp));
        free((yyvsp[(13) - (17)].strp));
        free((yyvsp[(15) - (17)].strp));
        free((yyvsp[(17) - (17)].strp));
      }
    break;

  case 23:

/* Line 1455 of yacc.c  */
#line 311 "problem_idl_parser.y"
    {
        (yyval.argp) = gs_new_arg(GS_MATRIX, (yyvsp[(3) - (10)].strp), (yyvsp[(10) - (10)].strp), (yyvsp[(1) - (10)].inout), (yyvsp[(2) - (10)].datatype), (yyvsp[(5) - (10)].strp), (yyvsp[(8) - (10)].strp), "0", "0", "0", NULL);
        free((yyvsp[(3) - (10)].strp));
        free((yyvsp[(5) - (10)].strp));
        free((yyvsp[(8) - (10)].strp));
        free((yyvsp[(10) - (10)].strp));
      }
    break;

  case 24:

/* Line 1455 of yacc.c  */
#line 319 "problem_idl_parser.y"
    {
        (yyval.argp) = gs_new_arg(GS_VECTOR, (yyvsp[(3) - (7)].strp), (yyvsp[(7) - (7)].strp), (yyvsp[(1) - (7)].inout), (yyvsp[(2) - (7)].datatype), (yyvsp[(5) - (7)].strp), "1", "0", "0", "0", NULL);
        free((yyvsp[(3) - (7)].strp));
        free((yyvsp[(5) - (7)].strp));
        free((yyvsp[(7) - (7)].strp));
      }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 326 "problem_idl_parser.y"
    {
        (yyval.argp) = gs_new_arg(GS_SCALAR, (yyvsp[(3) - (5)].strp), (yyvsp[(4) - (5)].strp), (yyvsp[(1) - (5)].inout), (yyvsp[(2) - (5)].datatype), "1", "1", "0", "0", "0", (yyvsp[(5) - (5)].enump));
        free((yyvsp[(3) - (5)].strp));
        free((yyvsp[(4) - (5)].strp));
      }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 332 "problem_idl_parser.y"
    {
        (yyval.argp) = gs_new_arg(GS_FILE, (yyvsp[(3) - (4)].strp), (yyvsp[(4) - (4)].strp), (yyvsp[(1) - (4)].inout), GS_CHAR, "1", "1", "0", "0", "0", NULL);
        free((yyvsp[(3) - (4)].strp));
        free((yyvsp[(4) - (4)].strp));
      }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 338 "problem_idl_parser.y"
    {
        (yyval.argp) = gs_new_arg(GS_PACKEDFILE, (yyvsp[(3) - (7)].strp), (yyvsp[(7) - (7)].strp), (yyvsp[(1) - (7)].inout), GS_CHAR, (yyvsp[(5) - (7)].strp), "1", "0", "0", "0", NULL);
        free((yyvsp[(3) - (7)].strp));
        free((yyvsp[(5) - (7)].strp));
        free((yyvsp[(7) - (7)].strp));
      }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 347 "problem_idl_parser.y"
    {
         (yyval.strp) = (yyvsp[(1) - (1)].strp);
       }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 353 "problem_idl_parser.y"
    {
          (yyval.inout) = GS_IN;
        }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 357 "problem_idl_parser.y"
    {
          (yyval.inout) = GS_INOUT;
        }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 361 "problem_idl_parser.y"
    {
          (yyval.inout) = GS_OUT;
        }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 365 "problem_idl_parser.y"
    {
          (yyval.inout) = GS_VAROUT;
        }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 369 "problem_idl_parser.y"
    {
          (yyval.inout) = GS_WORKSPACE;
        }
    break;

  case 34:

/* Line 1455 of yacc.c  */
#line 375 "problem_idl_parser.y"
    {
                (yyval.strp) = (yyvsp[(1) - (1)].strp);
              }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 379 "problem_idl_parser.y"
    {
                (yyval.strp) = strdup("none");
              }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 385 "problem_idl_parser.y"
    {
            (yyval.enump) = (yyvsp[(4) - (5)].enump);
          }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 389 "problem_idl_parser.y"
    {
            (yyval.enump) = NULL;
          }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 395 "problem_idl_parser.y"
    {
            gs_arg_enum_t *argp;

            /* skip to the end of the list and link the new entry */
            for(argp = (yyvsp[(1) - (3)].enump); argp && argp->next; argp=argp->next)
              /* spin */;
            argp->next = (yyvsp[(3) - (3)].enump);
            (yyval.enump) = (yyvsp[(1) - (3)].enump);
          }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 405 "problem_idl_parser.y"
    {
            (yyval.enump) = (yyvsp[(1) - (1)].enump);
          }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 411 "problem_idl_parser.y"
    {
           (yyval.enump) = (gs_arg_enum_t *)malloc(sizeof(gs_arg_enum_t));
           (yyval.enump)->val = (yyvsp[(1) - (1)].strp);
           (yyval.enump)->next = NULL;
         }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 419 "problem_idl_parser.y"
    {
             (yyval.datatype) = GS_INT;
           }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 423 "problem_idl_parser.y"
    {
             (yyval.datatype) = GS_CHAR;
           }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 427 "problem_idl_parser.y"
    {
             (yyval.datatype) = GS_FLOAT;
           }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 431 "problem_idl_parser.y"
    {
             (yyval.datatype) = GS_SCOMPLEX;
           }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 435 "problem_idl_parser.y"
    {
             (yyval.datatype) = GS_DCOMPLEX;
           }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 439 "problem_idl_parser.y"
    {
             (yyval.datatype) = GS_DOUBLE;
           }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 445 "problem_idl_parser.y"
    {
             (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
           }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 449 "problem_idl_parser.y"
    {
             (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
           }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 453 "problem_idl_parser.y"
    {
             (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
           }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 457 "problem_idl_parser.y"
    {
             (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
           }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 461 "problem_idl_parser.y"
    {
             (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
           }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 465 "problem_idl_parser.y"
    {
             (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
           }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 469 "problem_idl_parser.y"
    {
             (yyval.strp) = strdup((yyvsp[(1) - (1)].strp));
           }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 473 "problem_idl_parser.y"
    {
             (yyval.strp) = (yyvsp[(1) - (1)].strp);
           }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 479 "problem_idl_parser.y"
    {
                (yyval.expr) = (yyvsp[(1) - (1)].expr);
              }
    break;

  case 56:

/* Line 1455 of yacc.c  */
#line 484 "problem_idl_parser.y"
    {
       (yyval.strp) = strdup((yyvsp[(1) - (1)].expr)->str);
       free_expr_node((yyvsp[(1) - (1)].expr));
     }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 491 "problem_idl_parser.y"
    {
            double val = 0.0;

            if(symtab) {
              void *ht;

              ht = icl_hash_find(symtab, (yyvsp[(1) - (1)].strp));

              if(!ht)
                ERRPRINTF("Unknown identifier: %s\n", (yyvsp[(1) - (1)].strp));
              else
                val = *((double *)ht);
            }

            if(var_list)
              if(!icl_list_search(var_list, (yyvsp[(1) - (1)].strp), 
                   (int (*)(void*, void*)) strcmp))
                icl_list_append(var_list, strdup((yyvsp[(1) - (1)].strp)));

            (yyval.expr)=new_expr_node(val, (yyvsp[(1) - (1)].strp));
          }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 513 "problem_idl_parser.y"
    {
            if((yyvsp[(1) - (1)].strp)[0] == '\'') {
              (yyval.expr)=new_expr_node((double)(yyvsp[(1) - (1)].strp)[1], (yyvsp[(1) - (1)].strp));
              if(strlen((yyvsp[(1) - (1)].strp)) > 3)
                ERRPRINTF("truncating multi-character literal (%s to %c)\n",
                  (yyvsp[(1) - (1)].strp), (yyvsp[(1) - (1)].strp)[1]);
            }
            else
              (yyval.expr)=new_expr_node(atof((yyvsp[(1) - (1)].strp)), (yyvsp[(1) - (1)].strp));
          }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 524 "problem_idl_parser.y"
    {
            char *s;

            s = dstring_sprintf("(%s)", (yyvsp[(2) - (3)].expr)->str);
            (yyval.expr)=new_expr_node((yyvsp[(2) - (3)].expr)->val, s);
            free_expr_node((yyvsp[(2) - (3)].expr));
          }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 535 "problem_idl_parser.y"
    {
              (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 539 "problem_idl_parser.y"
    {
            char *s;

            ERRPRINTF("Unsupported intrinsic: %s\n", (yyvsp[(1) - (3)].strp));

            s = dstring_sprintf("%s()", (yyvsp[(1) - (3)].strp));
            (yyval.expr)=new_expr_node(0.0, s);
            free((yyvsp[(1) - (3)].strp));
          }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 549 "problem_idl_parser.y"
    {
            double val;
            char *s, *astr;

            val = handle_intrinsic((yyvsp[(1) - (4)].strp), (yyvsp[(3) - (4)].expr));
            astr = get_argument_string((yyvsp[(3) - (4)].expr));
            s = dstring_sprintf("%s(%s)", (yyvsp[(1) - (4)].strp), astr);
            free(astr);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_list((yyvsp[(3) - (4)].expr));
            free((yyvsp[(1) - (4)].strp));
          }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 565 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 569 "problem_idl_parser.y"
    {
            expr_t *argp;

            /* skip to the end of the list and link the new entry */
            for(argp = (yyvsp[(1) - (3)].expr); argp && argp->next; argp=argp->next)
              /* spin */;
            argp->next = (yyvsp[(3) - (3)].expr);
            (yyval.expr) = (yyvsp[(1) - (3)].expr);
          }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 582 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 586 "problem_idl_parser.y"
    {
            double val;
            char *s;

            if(!strcmp((yyvsp[(1) - (2)].strp),"+"))
              val = (double) +(yyvsp[(2) - (2)].expr)->val;
            else if(!strcmp((yyvsp[(1) - (2)].strp),"-"))
              val = (double) -(yyvsp[(2) - (2)].expr)->val;
            else if(!strcmp((yyvsp[(1) - (2)].strp),"~"))
              val = (double) ~(int)(yyvsp[(2) - (2)].expr)->val;
            else if(!strcmp((yyvsp[(1) - (2)].strp),"!"))
              val = (double) !(yyvsp[(2) - (2)].expr)->val;
            else
              val = (double) (yyvsp[(2) - (2)].expr)->val;

            s = dstring_sprintf("%s%s", (yyvsp[(1) - (2)].strp), (yyvsp[(2) - (2)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free((yyvsp[(1) - (2)].strp));
            free_expr_node((yyvsp[(2) - (2)].expr));
          }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 610 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("+");
          }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 614 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("-");
          }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 618 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("~");
          }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 622 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("!");
          }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 629 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 72:

/* Line 1455 of yacc.c  */
#line 633 "problem_idl_parser.y"
    {
            /* these are delcared to suppress a bunch of purify
             * errors..  don't ask, i have no idea....
             */
            char gs_char[5] = {"char"}, gs_short[6] = {"short"},
              gs_int[4] = {"int"}, gs_long[5] = {"long"},
              gs_float[6] = {"float"};
            double val;
            char *s;

            if(!strcmp((yyvsp[(2) - (4)].strp), gs_char))
              val = (double) ((char)(yyvsp[(4) - (4)].expr)->val);
            else if(!strcmp((yyvsp[(2) - (4)].strp), gs_short))
              val = (double) ((short)(yyvsp[(4) - (4)].expr)->val);
            else if(!strcmp((yyvsp[(2) - (4)].strp), gs_int))
              val = (double) ((int)(yyvsp[(4) - (4)].expr)->val);
            else if(!strcmp((yyvsp[(2) - (4)].strp), gs_long))
              val = (double) ((long)(yyvsp[(4) - (4)].expr)->val);
            else if(!strcmp((yyvsp[(2) - (4)].strp), gs_float))
              val = (double) ((float)(yyvsp[(4) - (4)].expr)->val);
            else
              val = (yyvsp[(4) - (4)].expr)->val;

            s = dstring_sprintf("(%s)%s", (yyvsp[(2) - (4)].strp), (yyvsp[(4) - (4)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free((yyvsp[(2) - (4)].strp));
            free_expr_node((yyvsp[(4) - (4)].expr));
          }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 665 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 669 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val * (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s*%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 681 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val / (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s/%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 693 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((int)(yyvsp[(1) - (3)].expr)->val % (int)(yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s%%%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 708 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 712 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val + (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s+%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 79:

/* Line 1455 of yacc.c  */
#line 724 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val - (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s-%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 739 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 743 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((int)(yyvsp[(1) - (3)].expr)->val << (int)(yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s<<%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 755 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((int)(yyvsp[(1) - (3)].expr)->val >> (int)(yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s>>%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 770 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 774 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val < (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s<%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 786 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val > (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s>%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 798 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val <= (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s<=%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 810 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val >= (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s>=%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 825 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 829 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val == (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s==%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 841 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((yyvsp[(1) - (3)].expr)->val != (yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s!=%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 856 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 860 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((int)(yyvsp[(1) - (3)].expr)->val & (int)(yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s&%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 93:

/* Line 1455 of yacc.c  */
#line 875 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 879 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((int)(yyvsp[(1) - (3)].expr)->val ^ (int)(yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s^%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 894 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 898 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (double) ((int)(yyvsp[(1) - (3)].expr)->val | (int)(yyvsp[(3) - (3)].expr)->val);

            s = dstring_sprintf("%s|%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 913 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 917 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = ((int)(yyvsp[(1) - (3)].expr)->val && (int)(yyvsp[(3) - (3)].expr)->val) ? 1.0 : 0.0;

            s = dstring_sprintf("%s&&%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 932 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 936 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = ((int)(yyvsp[(1) - (3)].expr)->val || (int)(yyvsp[(3) - (3)].expr)->val) ? 1.0 : 0.0;

            s = dstring_sprintf("%s||%s", (yyvsp[(1) - (3)].expr)->str, (yyvsp[(3) - (3)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (3)].expr));
            free_expr_node((yyvsp[(3) - (3)].expr));
          }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 951 "problem_idl_parser.y"
    {
            (yyval.expr)=(yyvsp[(1) - (1)].expr);
          }
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 955 "problem_idl_parser.y"
    {
            double val;
            char *s;

            val = (int)(yyvsp[(1) - (5)].expr)->val ? (yyvsp[(3) - (5)].expr)->val : (yyvsp[(5) - (5)].expr)->val;

            s = dstring_sprintf("%s?%s:%s", (yyvsp[(1) - (5)].expr)->str, (yyvsp[(3) - (5)].expr)->str, (yyvsp[(5) - (5)].expr)->str);
            (yyval.expr)=new_expr_node(val, s);
            free_expr_node((yyvsp[(1) - (5)].expr));
            free_expr_node((yyvsp[(3) - (5)].expr));
            free_expr_node((yyvsp[(5) - (5)].expr));
          }
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 971 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("char");
          }
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 975 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("short");
          }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 979 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("int");
          }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 983 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("long");
          }
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 987 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("float");
          }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 991 "problem_idl_parser.y"
    {
            (yyval.strp)=strdup("double");
          }
    break;



/* Line 1455 of yacc.c  */
#line 2967 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 995 "problem_idl_parser.y"


/**
 * Standard YACC error reporting function.
 *
 * @param msg -- The message to be printed regarding this error.
 */

void 
yyerror(const char *msg) { 
  fprintf(stderr, "%d: %s\n", lineno, msg);
}

/**
 * Return a string representation of the problem complexity in terms
 * of the input parameters.
 *
 * If there is no specified complexity expression, the use the sum of
 * all the scalar input parameters. For example, matrixoperation(int
 * N, int M, double*A, double*B) would return a default complexity of
 * "N+M" if nothing else was specified in the problem description.
 *
 * @param problem -- The problem to examine for its complexity expression.
 *
 * @returns The complexity string.  Returns NULL on failure.
 */

static char *
gs_idl_complexity_expression(gs_problem_t *problem) 
{
  char *complexity = NULL;
  int maxlen=0;
  gs_argument_t *arg = NULL;

  DBGPRINTF("generating complexity expression \n");

  complexity = gs_problem_getinfo(problem, "COMPLEXITY", NULL);

  if(!complexity) {
    /* all scalar input or input/output arguments will be involved
     * in computing the complexity, so compute the length of the 
     * string accordingly.
     */
    for (maxlen=0,arg=problem->arglist; arg!=NULL; arg=arg->next) 
      if(((arg->inout == GS_IN) || (arg->inout == GS_INOUT)) && 
          (arg->objecttype == GS_SCALAR))
        maxlen += strlen(arg->name)+3;

    complexity = (char*)malloc(maxlen * sizeof(char));
    if(!complexity) {
      ERRPRINTF("Could not allocate space for complexity string.\n");
      return NULL;
    }

    complexity[0] = '\0';

    /* now simply sum up the scalar input or input/output arguments */
    for (arg=problem->arglist; arg!=NULL; arg=arg->next) 
      if(((arg->inout == GS_IN) || (arg->inout == GS_INOUT)) &&
          (arg->objecttype == GS_SCALAR))
      {
        strcat(complexity, arg->name);
        strcat(complexity, "+");
      }

    /* clobber the trailing '+' */
    if(complexity[strlen(complexity)-1] == '+')
      complexity[strlen(complexity)-1] = '\0';

    return(complexity);
  }
  else
    return(strdup(complexity));
}

/**
 * Determines whether this routine is implemented in row-major
 * or column-major.  If not specified by the user in the IDL, then
 * assume that routines implemented in C are row-major and 
 * routines implemented in Fortran are column-major.
 *
 * @param problem -- The problem struct representing the routine to be called.
 *
 * @returns Returns 114 ('r') for row-major or 99 ('c') for column-major.
 *    Returns -1 on failure.
 */

static int
gs_idl_get_major(gs_problem_t *problem)
{
  char *major, *language;

  if(!problem) return -1;

  language = gs_problem_getinfo(problem, "LANGUAGE", "C");
  major = gs_problem_getinfo(problem, "MAJOR", NULL);

  /* if major wasn't specified, use default of COLUMN for Fortran
   * and ROW for C.
   */
  if(!major)
    return strcmp(language,"C") ? 'c' : 'r';

  if(!strcmp(major, "ROW"))
    return 'r';
  else if(!strcmp(major, "COLUMN"))
    return 'c';

  return -1;
}

/**
 * Creates a new argument struct to hold information about the
 * return type of a function.
 *
 * @param otype -- The object type of the return value.
 * @param name -- The argument name.
 * @param desc -- The argument description.
 * @param io -- The in/out mode.
 * @param dtype -- The data type of the return value.
 * @param rowexp -- The expression for the number of rows.
 * @param colexp -- The expression for the number of columns.
 * @param nnzexp -- The expression for the number of nonzeroes.  applies to
 *    sparse matrices only.
 * @param indexp -- The name of the index vector.  applies to
 *    sparse matrices only.
 * @param ptrexp -- The name of the pointer array.  applies to
 *    sparse matrices only.
 * @param arg_enum -- the optional enum spec.  set to NULL if none.
 *
 * @returns Returns the new argument structure.
 */

static gs_argument_t *
gs_new_arg(enum objecttype otype, char *name, char *desc, enum inout io,
  enum datatype dtype, char *rowexp, char *colexp, char *nnzexp, char *indexp,
  char *ptrexp, gs_arg_enum_t *arg_enum)
{
  gs_argument_t *tmp;

  tmp = (gs_argument_t *)malloc(sizeof(gs_argument_t));
  if(!tmp) {
    ERRPRINTF("Could not allocate memory\n");
    exit(-1);
  }

  tmp->name = strdup(name);
  tmp->description = strdup(desc);
  tmp->arg_enum = arg_enum;
  tmp->rowexp = strdup(rowexp);
  tmp->colexp = strdup(colexp);
  tmp->sparse_attr.nnzexp = strdup(nnzexp);
  tmp->sparse_attr.indices = strdup(indexp);
  tmp->sparse_attr.pointer = strdup(ptrexp);

  if(!tmp->name || !tmp->description || !tmp->rowexp || !tmp->colexp
    || !tmp->sparse_attr.nnzexp || !tmp->sparse_attr.indices 
    || !tmp->sparse_attr.pointer) 
  {
    ERRPRINTF("uh, bad news.  no memory\n");
    exit(-1);
  }

  tmp->inout = io;
  tmp->datatype = dtype;
  tmp->objecttype = otype;
  tmp->rows = 1;
  tmp->cols = 1;
  tmp->sparse_attr.nnz = 1;
  tmp->data = NULL;
  tmp->prob = NULL;
  tmp->next = NULL;

  return tmp;
}

/**
 * Creates a new expression node.
 *
 * @param v -- numeric value of the sub-expression
 * @param s -- string representation of the sub-expression
 *
 * @returns pointer to the new node or NULL on failure.
 **/

static expr_t *
new_expr_node(double v, char *s)
{
  expr_t *nn;

  nn = (expr_t *) malloc(sizeof(expr_t));

  if(!nn) return NULL;

  nn->val = v;
  nn->str = s;
  nn->next = NULL;

  if(!nn->str) {
    free(nn);
    return NULL;
  }

  return nn;
}

/**
 * Frees a list of expression nodes.
 *
 * @param n -- the nodelist to be freed
 **/

static void
free_expr_list(expr_t *n)
{
  expr_t *tmp;

  tmp = n;

  while(tmp) {
    expr_t *next;

    next = tmp->next;
    free_expr_node(tmp);
    tmp = next;
  }
}

/**
 * Frees an expression node.
 *
 * @param n -- the nodelist to be freed
 **/

static void
free_expr_node(expr_t *n)
{
  if(!n) return;

  if(n->str) free(n->str);
  free(n);
}

/**
 * Evaluates the specified expression.
 *
 * @param s -- string containing the expression to be evaluated
 * @param result -- upon return, set to the value (double-precision)
 * @param tab -- hash table containing values for the variables
 *
 * @returns 0 on success, -1 on failure.
 **/

int
gs_expr_d(const char *s, double *result, icl_hash_t *tab)
{
  struct idl__buffer_state* buffer_state;
  char *yybuf;
  int err;

  first_tok = EXPR_EVAL_TOK;
  symtab = tab;

  yybuf = strdup(s);
  buffer_state = idl__scan_string(yybuf);
  err = idl_parse();
  free((void*)yybuf);
  idl__delete_buffer(buffer_state);

  *result = expr_result;
  symtab = NULL;

  return err != 0 ? -1 : 0;
}

/**
 * Evaluates the specified expression.
 *
 * @param s -- string containing the expression to be evaluated
 * @param result -- upon return, set to the value (integer)
 * @param tab -- hash table containing values for the variables
 *
 * @returns 0 on success, -1 on failure.
 **/

int
gs_expr_i(const char *s, int *result, icl_hash_t *tab)
{
  double r;
  int status;

  status = gs_expr_d(s,&r,tab);
  *result = (int)r;
  return status;
}

/**
 * Evaluates intrinsic functions supported in our expression
 * grammar.  This currently includes pow, sqrt, abs, exp, log, 
 * and log10.
 *
 * @param func -- the name of the function
 * @param args -- list of expression nodes representing the
 *   arguments to the function
 *
 * @returns the value of the computed function
 **/

static double
handle_intrinsic(char *func, expr_t *args)
{
  double val;

  if(!args || !func) return 0.0;

  if(!strcmp(func, "pow")) {
    double arg1, arg2;

    if(get_two_args(args, &arg1, &arg2) < 0) {
      ERRPRINTF("Wrong number of args for intrinsic %s\n", func);
      return 0.0;
    }

    val = pow(arg1, arg2);
  }
  else if(!strcmp(func, "min")) {
    double arg1, arg2;

    if(get_two_args(args, &arg1, &arg2) < 0) {
      ERRPRINTF("Wrong number of args for intrinsic %s\n", func);
      return 0.0;
    }

    val = arg1 < arg2 ? arg1 : arg2;
  }
  else if(!strcmp(func, "max")) {
    double arg1, arg2;

    if(get_two_args(args, &arg1, &arg2) < 0) {
      ERRPRINTF("Wrong number of args for intrinsic %s\n", func);
      return 0.0;
    }

    val = arg1 > arg2 ? arg1 : arg2;
  }
  else {
    double arg1;

    if(get_one_arg(args, &arg1) < 0) {
      ERRPRINTF("Wrong number of args for intrinsic %s\n", func);
      return 0.0;
    }

    if(!strcmp(func, "abs")) {
      val = arg1 < 0 ? -arg1 : arg1;
    }
    else if(!strcmp(func, "sqrt")) {
      val = sqrt(arg1);
    }
    else if(!strcmp(func, "exp")) {
      val = exp(arg1);
    }
    else if(!strcmp(func, "log")) {
      val = log(arg1);
    }
    else if(!strcmp(func, "log10")) {
      val = log10(arg1);
    }
    else {
      ERRPRINTF("Unsupported intrinsic: %s\n", func);
      val = 0.0;
    }
  }

  return val;
}

/**
 * Verifies that there's only one arg in the list and returns it.
 *
 * @param args -- the argument list
 * @param arg1 -- upon return, the value of the argument
 *
 * @returns 0 on success, -1 on failure.
 **/

static int
get_one_arg(expr_t *args, double *arg1)
{
  if(!args) return -1;

  *arg1 = args->val;

  if(args->next)
    return -1;

  return 0;
}

/**
 * Verifies that there are only two args in the list and returns them.
 *
 * @param args -- the argument list
 * @param arg1 -- upon return, the value of the first argument
 * @param arg2 -- upon return, the value of the second argument
 *
 * @returns 0 on success, -1 on failure.
 **/

static int
get_two_args(expr_t *args, double *arg1, double *arg2)
{
  if(!args) return -1;

  *arg1 = args->val;

  if(!args->next)
    return -1;

  *arg2 = args->next->val;

  if(args->next->next)
    return -1;

  return 0;
}

/**
 * Create the string representation of a call to an intrinsic 
 * function.
 *
 * @param args -- the list of args to the function
 * 
 * @returns the string representing the call, NULL on failure.
 **/

static char *
get_argument_string(expr_t *args)
{
  expr_t *tmp;
  char *rv;
  int len = 0;

  for(tmp=args;tmp;tmp=tmp->next)
    len += strlen(tmp->str) + 1;

  rv = (char *)malloc(len + 1);
  rv[0] = '\0';

  for(tmp=args;tmp;tmp=tmp->next) {
    strcat(rv, tmp->str);
    if(tmp->next != NULL)
      strcat(rv, ",");
  }

  return rv;
}

/**
 * Builds a linked list of the names of all the variables
 * used in the specified expression.
 *
 * @param expr -- the expression
 * @param list -- upon return, the list contains all the variable names
 *
 * @returns 0 on success, -1 on failure.
 **/

int
gs_get_var_list_from_expr(char *expr, icl_list_t *list)
{
  struct idl__buffer_state* buffer_state;
  char *yybuf;
  int err;

  first_tok = EXPR_EVAL_TOK;
  var_list = list;

  yybuf = strdup(expr);
  buffer_state = idl__scan_string(yybuf);
  err = idl_parse();
  free((void*)yybuf);
  idl__delete_buffer(buffer_state);

  var_list = NULL;

  return err != 0 ? -1 : 0;
}

/**
 * Copies global problem attributes to the problem structure before generating
 * the code.
 *
 * @param prob_list -- the list of problem structures that were parsed in this file
 * @param attr_list -- the list of attributes specified at the top of the file
 *
 * @return 0 on success, -1 on failure.
 */

int
gs_copy_global_attributes(gs_problem_t *prob_list, gs_info_t *attr_list)
{
  gs_problem_t *prob;
  gs_info_t *attr, *new_attr;

  for(prob = prob_list; prob; prob = prob->next) {
    for(attr = attr_list; attr; attr = attr->next) {
      if(!gs_problem_getinfo(prob, attr->type, NULL)) {
        /* if the problem doesn't already have this attribute, then copy it */

        new_attr = (gs_info_t *)malloc(sizeof(gs_info_t));

        if(!new_attr) {
          ERRPRINTF("malloc failed\n");
          exit(-1);
        }

        new_attr->type = strdup(attr->type);
        new_attr->value = strdup(attr->value);

        if(!new_attr->type || !new_attr->value) {
          ERRPRINTF("malloc failed\n");
          exit(-1);
        }

        new_attr->next = prob->infolist;
        prob->infolist = new_attr;
      }
    }

    /* if complexity wasn't specified, generate a default */
    if(gs_problem_getinfo(prob, "COMPLEXITY", NULL) == NULL) {
      new_attr = (gs_info_t *)malloc(sizeof(gs_info_t));
      if(!new_attr) {
        ERRPRINTF("Could not allocate memory\n");
        exit(-1);
      }
      new_attr->type = strdup("COMPLEXITY");
      new_attr->value = gs_idl_complexity_expression(prob);
      if(!new_attr->value) new_attr->value = strdup("1.0");

      if(!new_attr->type || !new_attr->value) {
        ERRPRINTF("malloc failed\n");
        exit(-1);
      }

      new_attr->next = prob->infolist;
      prob->infolist = new_attr;
    }
  }


  return 0;
}

