/* 
 * @file
 *
 * A small test program that dumps the problem data structure to
 * stdout after scanning and parsing the IDL file.  This simply checks
 * if the IDL file can be parsed.
 *
 */
/* $Id: problem_idl_test.c,v 1.10 2005/11/10 20:46:01 seymour Exp $ */
/* $UTK_Copyright: $ */


#include <stdlib.h>
#include <stdio.h>

#include "problem.h"
#include "utility.h"
#include "problem_idl_parser.h"

int
main(int argc, char *argv[])
{
  FILE *fin;
  int status;
  extern gs_problem_t *problemp;
  extern int idl_parse();
  extern FILE *idl_in;

  if(argc != 2) {
    ERRPRINTF("Usage: %s <problem_idl_file> \n", argv[0]);
    exit(-1);
  }

  if((fin = fopen(argv[1], "r")) == NULL) {
    ERRPRINTF("Could not open idl file: %s \n", argv[1]);
    exit(-1);
  }

  idl_in = fin;
  status = idl_parse();
  gs_problemlist_dump(problemp);
  fclose(fin);

  exit(status);
}
