#include <string.h>

#include "echo.h"
#include "proxylib.h"

int ns_errno;

void str_cli(FILE *, int);

int main(int argc, char **argv)
{
  int sockfd;
  PROXY_COMPONENTADDR servaddr;

  if (argc != 3) {
    fprintf(stderr, "usage: tcpcli <server component ID> <port>\n");
    exit(EXIT_FAILURE);
  }

  proxy_init("nse.cfg");

  proxy_str_to_cid(servaddr.ID, argv[1]);

  servaddr.port = htons(atoi(argv[2]));
  servaddr.IP = 0;
  servaddr.proxyIP = proxy_get_proxy_ip();
  servaddr.proxyPort = proxy_get_proxy_port();

  sockfd = proxy_socket(AF_INET, SOCK_STREAM, 0);

  if (proxy_connect(sockfd, &servaddr) < 0) {
    fprintf(stderr, "Error: could not connect.\n");
    exit(EXIT_FAILURE);
  }

  str_cli(stdin, sockfd);	/* do it all */

  exit(EXIT_SUCCESS);
}

void str_cli(FILE * fp, int sockfd)
{
  char sendline[MAXLINE], recvline[MAXLINE];

  while (fgets(sendline, MAXLINE, fp) != NULL) {

    Writen(sockfd, sendline, strlen(sendline));

    if (Readline(sockfd, recvline, MAXLINE) == 0) {
      fprintf(stderr, "str_cli: server terminated prematurely");
      return;
    }

    fputs(recvline, stdout);
  }
}
