#include "echo.h"

int ns_errno;

int main(int argc, char **argv)
{
  int i, maxi, maxfd, listenfd, connfd, sockfd;
  short port;
  int nready, client[FD_SETSIZE];
  ssize_t n;
  fd_set rset, allset;
  char line[MAXLINE];
  socklen_t clilen;
  struct sockaddr_in cliaddr, servaddr;

  if (argc == 2)
    port = atoi(argv[1]);
  else
    port = DEFAULT_PORT;

  listenfd = socket(AF_INET, SOCK_STREAM, 0);

  memset(&servaddr, 0x0, sizeof(servaddr));
  servaddr.sin_family = AF_INET;
  servaddr.sin_addr.s_addr = htonl(INADDR_ANY);
  servaddr.sin_port = htons(port);

  bind(listenfd, (struct sockaddr *) &servaddr, sizeof(servaddr));

  printf("Server listening on port %d\n", ntohs(servaddr.sin_port));

  listen(listenfd, 20);

  maxfd = listenfd;		/* initialize */
  maxi = -1;			/* index into client[] array */
  for (i = 0; i < FD_SETSIZE; i++)
    client[i] = -1;		/* -1 indicates available entry */
  FD_ZERO(&allset);
  FD_SET(listenfd, &allset);
  /* end fig01 */

  /* include fig02 */
  for (;;) {
    rset = allset;		/* structure assignment */
    nready = select(maxfd + 1, &rset, NULL, NULL, NULL);

    if (FD_ISSET(listenfd, &rset)) {	/* new client connection */
      clilen = sizeof(cliaddr);
      connfd = accept(listenfd, (struct sockaddr *) &cliaddr, &clilen);
#ifdef	NOTDEF
      printf("new client: %s, port %d\n",
	     Inet_ntop(AF_INET, &cliaddr.sin_addr, 4, NULL), ntohs(cliaddr.sin_port));
#endif

      for (i = 0; i < FD_SETSIZE; i++)
	if (client[i] < 0) {
	  client[i] = connfd;	/* save descriptor */
	  break;
	}
      if (i == FD_SETSIZE) {
	fprintf(stderr, "too many clients");
	close(connfd);
	continue;
      }

      FD_SET(connfd, &allset);	/* add new descriptor to set */
      if (connfd > maxfd)
	maxfd = connfd;		/* for select */
      if (i > maxi)
	maxi = i;		/* max index in client[] array */

      if (--nready <= 0)
	continue;		/* no more readable descriptors */
    }

    for (i = 0; i <= maxi; i++) {	/* check all clients for data */
      if ((sockfd = client[i]) < 0)
	continue;
      if (FD_ISSET(sockfd, &rset)) {
	if ((n = Readline(sockfd, line, MAXLINE)) == 0) {
	  /* 4connection closed by client */
	  close(sockfd);
	  FD_CLR(sockfd, &allset);
	  client[i] = -1;
	} else
	  Writen(sockfd, line, n);

	if (--nready <= 0)
	  break;		/* no more readable descriptors */
      }
    }
  }
}

/* end fig02 */
