; Determines whether two matrices are equal within a certain tolerance.
; The matrices should be equal size.
;
; Takes the following parameters:
;   a - first matrix
;   b - second matrix
;   rows - number of rows in the matrices
;   cols - number of columns in the matrices
;
; Returns 1 if they are equal, 0 if not.
;
; $Id: gs_mat_eq.pro,v 1.1 2007/03/05 17:45:44 seymour Exp $
; $UTK_Copyright: $
;

function gs_mat_eq, a, b, rows, cols
  for ix=0L, rows-1 do begin
    for iy=0L, cols-1 do begin
      if(gs_eq(a(iy,ix), b(iy,ix)) NE 1) then begin
        return, 0
      endif
    endfor
  endfor
  return, 1
end
