; Tests the various GridSolve return_* tests.  This tests whether function
; return values are handled properly.
;
; $Id: return_test.pro,v 1.1 2007/03/05 17:45:44 seymour Exp $ 
; $UTK_Copyright: $ 
;

pro return_test 
  on_error, 2
  nfail=0

;FUNCTION int return_int_scalar(IN int i)

  print, 'Testing return_int_scalar: int scalar -> int scalar, irv untyped'
  i=12
  status = gs_call('return_int_scalar', i, irv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(irv NE 13) then begin
    print, "Test 1 FAILURE"
    nfail++
  endif else begin
    print, "Test 1 SUCCESS"
  endelse

  print, 'Testing return_int_scalar: float scalar -> int scalar, irv untyped'
  f=12.3
  status = gs_call('return_int_scalar', f, irv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(irv NE 13) then begin
    print, "Test 2 FAILURE"
    nfail++
  endif else begin
    print, "Test 2 SUCCESS"
  endelse

  print, 'Testing return_int_scalar: double scalar -> int scalar, irv untyped'
  d=12.3d
  status = gs_call('return_int_scalar', d, irv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(irv NE 13) then begin
    print, "Test 3 FAILURE"
    nfail++
  endif else begin
    print, "Test 3 SUCCESS"
  endelse

  print, 'Testing return_int_scalar: int scalar -> int scalar, irv typed as int'
  irv = 0l
  i=12
  status = gs_call('return_int_scalar', i, irv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(irv NE 13) then begin
    print, "Test 4 FAILURE"
    nfail++
  endif else begin
    print, "Test 4 SUCCESS"
  endelse

;FUNCTION float return_float_scalar(IN float f)

  print, 'Testing return_float_scalar: int scalar -> float scalar, frv untyped'
  i=12
  status = gs_call('return_float_scalar', i, frv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(frv, 13.0) NE 1) then begin
    print, "Test 5 FAILURE"
    nfail++
  endif else begin
    print, "Test 5 SUCCESS"
  endelse

  print, 'Testing return_float_scalar: float scalar -> float scalar, frv untyped'
  f=12.3
  status = gs_call('return_float_scalar', f, frv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(frv, 13.3) NE 1) then begin
    print, "Test 6 FAILURE"
    nfail++
  endif else begin
    print, "Test 6 SUCCESS"
  endelse

  print, 'Testing return_float_scalar: double scalar -> float scalar, frv untyped'
  d=12.3d
  status = gs_call('return_float_scalar', d, frv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(frv, 13.3) NE 1) then begin
    print, "Test 7 FAILURE"
    nfail++
  endif else begin
    print, "Test 7 SUCCESS"
  endelse

  print, 'Testing return_float_scalar: double scalar -> float scalar, frv typed as float'
  frv=0.0
  d=12.3d
  status = gs_call('return_float_scalar', d, frv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(frv, 13.3) NE 1) then begin
    print, "Test 8 FAILURE"
    nfail++
  endif else begin
    print, "Test 8 SUCCESS"
  endelse

;FUNCTION double return_double_scalar(IN double d)

  print, 'Testing return_double_scalar: int scalar -> double scalar, drv untyped'
  i=12
  status = gs_call('return_double_scalar', i, drv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(drv, 13.0d) NE 1) then begin
    print, "Test 9 FAILURE"
    nfail++
  endif else begin
    print, "Test 9 SUCCESS"
  endelse

  print, 'Testing return_double_scalar: float scalar -> double scalar, drv untyped'
  f=12.3
  status = gs_call('return_double_scalar', f, drv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(drv, 13.3d) NE 1) then begin
    print, "Test 10 FAILURE"
    nfail++
  endif else begin
    print, "Test 10 SUCCESS"
  endelse

  print, 'Testing return_double_scalar: double scalar -> double scalar, drv untyped'
  d=12.3d
  status = gs_call('return_double_scalar', d, drv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(drv, 13.3d) NE 1) then begin
    print, "Test 11 FAILURE"
    nfail++
  endif else begin
    print, "Test 11 SUCCESS"
  endelse

  print, 'Testing return_double_scalar: double scalar -> double scalar, drv typed as double'
  drv=0.0
  d=12.3d
  status = gs_call('return_double_scalar', d, drv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(drv, 13.3d) NE 1) then begin
    print, "Test 12 FAILURE"
    nfail++
  endif else begin
    print, "Test 12 SUCCESS"
  endelse

;FUNCTION char return_char_scalar(IN char c)

  print, 'Testing return_char_scalar: char scalar -> char scalar, crv untyped'
  c = 'a'
  status = gs_call('return_char_scalar', c, crv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(crv NE 'b') then begin
    print, "Test 13 FAILURE"
    nfail++
  endif else begin
    print, "Test 13 SUCCESS"
  end

  print, 'Testing return_char_scalar: char scalar -> char scalar, crv typed as char'
  c = 'a'
  crv = ' '
  status = gs_call('return_char_scalar', c, crv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(crv NE 'b') then begin
    print, "Test 14 FAILURE"
    nfail++
  endif else begin
    print, "Test 14 SUCCESS"
  end

;FUNCTION scomplex return_scomplex_scalar(IN scomplex d)

  print, 'Testing return_scomplex_scalar: int scalar -> float complex scalar, scrv untyped'
  i=12
  status = gs_call('return_scomplex_scalar', i, scrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(scrv, complex(13.0, 1.0)) NE 1) then begin
    print, "Test 15 FAILURE"
    nfail++
  endif else begin
    print, "Test 15 SUCCESS"
  endelse

  print, 'Testing return_scomplex_scalar: float scalar -> float complex scalar, scrv untyped'
  f=12.3
  status = gs_call('return_scomplex_scalar', f, scrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(scrv, complex(13.3, 1.0)) NE 1) then begin
    print, "Test 16 FAILURE"
    nfail++
  endif else begin
    print, "Test 16 SUCCESS"
  endelse

  print, 'Testing return_scomplex_scalar: double scalar -> float complex scalar, scrv untyped'
  d=12.3d
  status = gs_call('return_scomplex_scalar', d, scrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(scrv, complex(13.3, 1.0)) NE 1) then begin
    print, "Test 17 FAILURE"
    nfail++
  endif else begin
    print, "Test 17 SUCCESS"
  endelse

  print, 'Testing return_scomplex_scalar: float complex scalar -> float complex scalar, scrv untyped'
  fc=complex(12.3,2.5)
  status = gs_call('return_scomplex_scalar', fc, scrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(scrv, complex(13.3, 3.5)) NE 1) then begin
    print, "Test 18 FAILURE"
    nfail++
  endif else begin
    print, "Test 18 SUCCESS"
  endelse

  print, 'Testing return_scomplex_scalar: double complex scalar -> float complex scalar, scrv untyped'
  dc=dcomplex(12.3d,2.5d)
  status = gs_call('return_scomplex_scalar', dc, scrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(scrv, complex(13.3, 3.5)) NE 1) then begin
    print, "Test 19 FAILURE"
    nfail++
  endif else begin
    print, "Test 19 SUCCESS"
  endelse

  print, 'Testing return_scomplex_scalar: double scalar -> float complex scalar, scrv typed as single complex'
  scrv=complex(0.0,0.0)
  d=12.3d
  status = gs_call('return_scomplex_scalar', d, scrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(scrv, complex(13.3, 1.0)) NE 1) then begin
    print, "Test 20 FAILURE"
    nfail++
  endif else begin
    print, "Test 20 SUCCESS"
  endelse

;FUNCTION dcomplex return_dcomplex_scalar(IN dcomplex d)

  print, 'Testing return_dcomplex_scalar: int scalar -> double complex scalar, dcrv untyped'
  i=12
  status = gs_call('return_dcomplex_scalar', i, dcrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(dcrv, dcomplex(13.0, 1.0)) NE 1) then begin
    print, "Test 21 FAILURE"
    nfail++
  endif else begin
    print, "Test 21 SUCCESS"
  endelse

  print, 'Testing return_dcomplex_scalar: float scalar -> double complex scalar, dcrv untyped'
  f=12.3
  status = gs_call('return_dcomplex_scalar', f, dcrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(dcrv, dcomplex(13.3, 1.0)) NE 1) then begin
    print, "Test 22 FAILURE"
    nfail++
  endif else begin
    print, "Test 22 SUCCESS"
  endelse

  print, 'Testing return_dcomplex_scalar: double scalar -> double complex scalar, dcrv untyped'
  d=12.3d
  status = gs_call('return_dcomplex_scalar', d, dcrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(dcrv, dcomplex(13.3, 1.0)) NE 1) then begin
    print, "Test 23 FAILURE"
    nfail++
  endif else begin
    print, "Test 23 SUCCESS"
  endelse

  print, 'Testing return_dcomplex_scalar: float complex scalar -> float complex scalar, scrv untyped'
  fc=complex(12.3,2.5)
  status = gs_call('return_dcomplex_scalar', fc, dcrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(dcrv, dcomplex(13.3, 3.5)) NE 1) then begin
    print, "Test 24 FAILURE"
    nfail++
  endif else begin
    print, "Test 24 SUCCESS"
  endelse

  print, 'Testing return_dcomplex_scalar: double complex scalar -> float complex scalar, dcrv untyped'
  dc=dcomplex(12.3d,2.5d)
  status = gs_call('return_dcomplex_scalar', dc, dcrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(dcrv, dcomplex(13.3, 3.5)) NE 1) then begin
    print, "Test 25 FAILURE"
    nfail++
  endif else begin
    print, "Test 25 SUCCESS"
  endelse

  print, 'Testing return_dcomplex_scalar: double scalar -> double complex scalar, dcrv typed as single complex'
  dcrv=dcomplex(0.0,0.0)
  d=12.3d
  status = gs_call('return_dcomplex_scalar', d, dcrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_eq(dcrv, dcomplex(13.3, 1.0)) NE 1) then begin
    print, "Test 26 FAILURE"
    nfail++
  endif else begin
    print, "Test 26 SUCCESS"
  endelse
  
;FUNCTION int [n] return_int_vector(IN int ivec[n], IN int n)

  print, 'Testing return_int_vector: int vector -> int vector'
  i=[12,13,14]
  irv=[0l,0l,0l]
  size = 3
  status = gs_call('return_int_vector', i, size, irv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_vec_eq(irv,[13,14,15],3) NE 1) then begin
    print, "Test 27 FAILURE"
    nfail++
  endif else begin
    print, "Test 27 SUCCESS"
  endelse

;FUNCTION float [n] return_float_vector(IN float fvec[n], IN int n)

  print, 'Testing return_float_vector: float vector -> float vector'
  f=[12.3,13.3,14.3]
  frv=[0.,0.,0.]
  size = 3
  status = gs_call('return_float_vector', f, size, frv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_vec_eq(frv,[13.3,14.3,15.3],3) NE 1) then begin
    print, "Test 28 FAILURE"
    nfail++
  endif else begin
    print, "Test 28 SUCCESS"
  endelse

;FUNCTION double [n] return_double_vector(IN double dvec[n], IN int n)

  print, 'Testing return_double_vector: double vector -> double vector'
  d=[12.3d,13.3d,14.3d]
  drv=[0.d,0.d,0.d]
  size = 3
  status = gs_call('return_double_vector', d, size, drv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_vec_eq(drv,[13.3d,14.3d,15.3d],3) NE 1) then begin
    print, "Test 29 FAILURE"
    nfail++
  endif else begin
    print, "Test 29 SUCCESS"
  endelse

;FUNCTION char [n] return_char_vector(IN char cvec[n], IN int n)

  print, 'Testing return_char_vector: char vector (string actually) -> char vector'
  c='abc'
  crv='xxx'
  size = 3
  status = gs_call('return_char_vector', c, size, crv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(crv ne 'bcd') then begin
    print, "Test 30 FAILURE"
    nfail++
  endif else begin
    print, "Test 30 SUCCESS"
  endelse

;FUNCTION scomplex [n] return_scomplex_vector(IN scomplex vec[n], IN int n)

  print, 'Testing return_scomplex_vector: float complex vector -> float complex vector'
  fc=[complex(12.3,2.5),complex(13.3,3.5),complex(14.3,4.5)]
  fcrv=[complex(0.0,0.0),complex(0.0,0.0),complex(0.0,0.0)]
  size = 3
  status = gs_call('return_scomplex_vector', fc, size, fcrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_vec_eq(fcrv,[complex(13.3,3.5),complex(14.3,4.5),complex(15.3,5.5)],3) NE 1) then begin
    print, "Test 31 FAILURE"
    nfail++
  endif else begin
    print, "Test 31 SUCCESS"
  endelse

;FUNCTION dcomplex [n] return_dcomplex_vector(IN dcomplex vec[n], IN int n)

  print, 'Testing return_dcomplex_vector: double complex vector -> double complex vector'
  dc=[dcomplex(12.3,2.5),dcomplex(13.3,3.5),dcomplex(14.3,4.5)]
  dcrv=[dcomplex(0.0,0.0),dcomplex(0.0,0.0),dcomplex(0.0,0.0)]
  size = 3
  status = gs_call('return_dcomplex_vector', dc, size, dcrv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_vec_eq(dcrv,[dcomplex(13.3,3.5),dcomplex(14.3,4.5),dcomplex(15.3,5.5)],3) NE 1) then begin
    print, "Test 32 FAILURE"
    nfail++
  endif else begin
    print, "Test 32 SUCCESS"
  endelse

;FUNCTION int [m][n] return_int_matrix(IN int imat[m][n], IN int m, IN int n)

  print, 'Testing return_int_matrix: int matrix -> int matrix'
  rows=3
  cols=2
  im = randomn(seed, cols, rows, /long)
  irm = randomn(seed, cols, rows, /long)
  im_corr = im + 1
  status = gs_call('return_int_matrix', im, rows, cols, irm)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_mat_eq(irm, im_corr, rows, cols) NE 1) then begin
    print, "Test 33 FAILURE"
    nfail++
  endif else begin
    print, "Test 33 SUCCESS"
  endelse

;FUNCTION float [m][n] return_float_matrix(IN float fmat[m][n], IN int m, IN int n)

  print, 'Testing return_float_matrix: float matrix -> float matrix'
  rows=3
  cols=2
  fm = randomn(seed, cols, rows)
  frm = randomn(seed, cols, rows)
  fm_corr = fm + 1
  status = gs_call('return_float_matrix', fm, rows, cols, frm)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_mat_eq(frm, fm_corr, rows, cols) NE 1) then begin
    print, "Test 34 FAILURE"
    nfail++
  endif else begin
    print, "Test 34 SUCCESS"
  endelse

;FUNCTION double [m][n] return_double_matrix(IN double dmat[m][n], IN int m, IN int n)

  print, 'Testing return_double_matrix: double matrix -> double matrix'
  rows=3
  cols=2
  dm = randomn(seed, cols, rows, /double)
  drm = randomn(seed, cols, rows, /double)
  dm_corr = dm + 1
  status = gs_call('return_double_matrix', dm, rows, cols, drm)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_mat_eq(drm, dm_corr, rows, cols) NE 1) then begin
    print, "Test 35 FAILURE"
    nfail++
  endif else begin
    print, "Test 35 SUCCESS"
  endelse

;FUNCTION scomplex [m][n] return_scomplex_matrix(IN scomplex mat[m][n], IN int m, IN int n)

  print, 'Testing return_scomplex_matrix: float complex matrix -> float complex matrix'
  rows=3
  cols=2
  scm = complex(randomn(seed, cols, rows), randomn(seed, cols, rows))
  scrm = complexarr(cols, rows)
  scm_corr = scm + complex(1.0, 1.0)
  status = gs_call('return_scomplex_matrix', scm, rows, cols, scrm)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_mat_eq(scrm, scm_corr, rows, cols) NE 1) then begin
    print, "Test 36 FAILURE"
    nfail++
  endif else begin
    print, "Test 36 SUCCESS"
  endelse

;FUNCTION dcomplex [m][n] return_dcomplex_matrix(IN dcomplex mat[m][n], IN int m, IN int n)

  print, 'Testing return_dcomplex_matrix: double complex matrix -> double complex matrix'
  rows=3
  cols=2
  dcm = dcomplex(randomn(seed, cols, rows, /double), randomn(seed, cols, rows, /double))
  dcrm = dcomplexarr(cols, rows)
  dcm_corr = dcm + dcomplex(1.0, 1.0)
  status = gs_call('return_dcomplex_matrix', dcm, rows, cols, dcrm)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  if(gs_mat_eq(dcrm, dcm_corr, rows, cols) NE 1) then begin
    print, "Test 37 FAILURE"
    nfail++
  endif else begin
    print, "Test 37 SUCCESS"
  endelse

;FUNCTION char [m][n] return_char_matrix(IN char cmat[m][n], IN int m, IN int n)

  print, 'Testing return_char_matrix: char matrix -> char matrix'
  rows=3
  cols=2
  cmat = ['ab','cd','ef']
  crv = ['mn','op','qr']
  ccat = ['bcdefg']
  status = gs_call('return_char_matrix', cmat, rows, cols, crv)
  if(status NE 0) then print, "GridRPC Error: ", gs_error_string(status)
  s=crv(0)+crv(1)+crv(2)
  if(s NE ccat) then begin
    print, "Test 38 FAILURE"
    nfail++
  endif else begin
    print, "Test 38 SUCCESS"
  endelse

; end of tests

  print, '----------------------'

  if(nfail NE 0) then begin
     print, nfail, " tests failed!"
  endif else begin
     print, "All tests succeeded."
  endelse

end
