/**
 * @file
 *
 * This program tests the fault tolerant GridRPC call, which is an
 * extension to the standard GridRPC API.  The fault tolerant call
 * will transparently resubmit a failed job to another server.
 *
 */
/* $Id: ft_test.c,v 1.5 2005/11/10 20:46:04 seymour Exp $ */
/* $UTK_Copyright: $ */

#include <stdio.h>
#include <stdlib.h>

#include "grpc.h"
#include "totaltest.h"

int
main(int argc, char *argv[])
{
  grpc_function_handle_t handle;
  int val, status;

  if(grpc_initialize(NULL) != GRPC_NO_ERROR) {
    grpc_perror("grpc_initialize");
    die(EXIT_FAILURE);
  }

  if(grpc_function_handle_default(&handle, "gs_abort") != GRPC_NO_ERROR) {
    fprintf(stderr,"Error creating function handle\n");
    die(EXIT_FAILURE);
  }

  val = -1;
  status = grpc_call(&handle, &val);

  if(status != GRPC_NO_ERROR) {
    printf("GRPC error status  = %d\n", status);
    grpc_perror("grpc_call");
    die(status);
  }

  printf("\nCall completed.\n"); 

  grpc_function_handle_destruct(&handle);

  printf("Finalizing...\n");

  grpc_finalize();

  printf("Done.\n");

  die(EXIT_SUCCESS);
}
