/********************************************************************/
/*                           gs_seq_test.c                          */
/*      the test file for the GridSolve sequencing mechanism        */
/*                       Yinan Li, 05/17/2007                       */
/********************************************************************/


#include "gs_sequence.h"


void print_int_vec(int *vec, int n) {
	int i;

	for (i = 0; i < n; i++) {
		printf("%d ", vec[i]);
	}
}


int main() {
    int *ivec, *ovec, *ovec2, *ovec3, *ovec4, *ovec5;
    int n = 10;
    int i;
    grpc_error_t status;
    

    ivec = (int *) malloc(sizeof(int) * n);
    ovec = (int *) malloc(sizeof(int) * n);
    ovec2 = (int *) malloc(sizeof(int) * n);
	ovec3 = (int *) malloc(sizeof(int) * n);
	ovec4 = (int *) malloc(sizeof(int) * n);
	ovec5 = (int *) malloc(sizeof(int) * n);
    if (!ivec || !ovec || !ovec2 || !ovec3 || !ovec4 || !ovec5) {
        perror("malloc");
        exit(1);
    }

	srand(time(0));
    printf("\ninput vector:\n");
    for (i = 0; i < n; i++) {
        ovec5[i] = ovec4[i] = ovec3[i] = ovec2[i] = ovec[i] = ivec[i] = 
		(int) ((float) n * ((float) rand() / (float) RAND_MAX));
        printf("%d ", ivec[i]);
    }
    printf("\n\n");

    /* initialize the GridRPC system */
    status = grpc_initialize(NULL);
    if (status != GRPC_NO_ERROR && status != GRPC_ALREADY_INITIALIZED) {
        fprintf(stderr, "%s\n", grpc_error_string(status));
        exit(1);
    }

    /* the sequence */
    grpc_sequence_begin(OPTIMISTIC_MODE);
    grpc_submit("return_int_vector",ivec,n,ovec);
	grpc_submit("vpass_int", ovec, n);
	grpc_submit("iqsort", ovec, n);
	grpc_submit("int_vector_add5",n,ovec,ovec2);
    grpc_sequence_end(0);
	
    printf("\noutput vector 1:\n");
	print_int_vec(ovec, n);
    printf("\n\n");

    printf("output vector 2:\n");
	print_int_vec(ovec2, n);  
    printf("\n\n");

	printf("output vector 3:\n");
	print_int_vec(ovec3, n);
	printf("\n\n");
	
    printf("output vector 4:\n");
	print_int_vec(ovec4, n);
	printf("\n\n");

	printf("output vector 5:\n");
	print_int_vec(ovec5, n);
	printf("\n\n");

	printf("Done.\n");
	
    /* finalize and done */
    grpc_finalize();
  return 0;
}























    


