/**
 * @file
 *
 * This tests the passing of sparse matrices.
 *
 */
/* $Id: sparsetest.c,v 1.10 2008/10/27 19:04:45 seymour Exp $ */
/* $UTK_Copyright: $ */

#include <stdio.h>
#include <stdlib.h>

#include "grpc.h"
#include "totaltest.h"

int
validate_sparse_matrices(int, int *, int *, double *, int, int *, int *,
  double *, int, int *, int *, double *, int, int *, int *, float *,
  int, int *, int *, float *, int, int *, int *, float *, int, int *, int *,
  int *, int, int *, int *, int *, int, int *, int *, int *, int, int *, 
  int *, char *, int, int *, int *, char *, int, int *, int *, char *,
  int, int);

int
main()
{
  grpc_function_handle_t __handle;
  grpc_error_t __status;
  gs_sparse_dup_t *spm;
  double *dmat_i, *dmat_io, *dmat_o;
  float *fmat_i, *fmat_io, *fmat_o;
  int *imat_i, *imat_io, *imat_o;
  char *cmat_i, *cmat_io, *cmat_o;
  int dnnzi, dnnzio, dnnzo;
  int fnnzi, fnnzio, fnnzo;
  int innzi, innzio, innzo;
  int cnnzi, cnnzio, cnnzo;
  int *dindi, *dindio, *dindo;
  int *findi, *findio, *findo;
  int *iindi, *iindio, *iindo;
  int *cindi, *cindio, *cindo;
  int *dptri, *dptrio, *dptro;
  int *fptri, *fptrio, *fptro;
  int *iptri, *iptrio, *iptro;
  int *cptri, *cptrio, *cptro;
  int i, k, l; 

  k = 10;
  l = 10;

  /* initialize sparse matrix dmat_i */
  if((dnnzi = gs_gen_sparse_mat_double(k, k, 2*k, &dmat_i, &dindi, &dptri)) < 0) {
    fprintf(stderr,"Error creating sparse matrix\n");
    die(EXIT_FAILURE);
  }

  spm = gs_dup_sparse_mat(dnnzi, k, sizeof(*dmat_i), (void *)dmat_i, dindi, dptri);

  if(!spm) {
    fprintf(stderr,"Could not dup sparse matrix\n");
    die(EXIT_FAILURE);
  }

  dmat_io = spm->m;
  dindio = spm->ind;
  dptrio = spm->ptr;

  dnnzio = dnnzi;

  spm = gs_dup_sparse_mat(dnnzi, k, sizeof(*dmat_i), (void *)dmat_i, dindi, dptri);

  if(!spm) {
    fprintf(stderr,"Could not dup sparse matrix\n");
    die(EXIT_FAILURE);
  }

  dmat_o = spm->m;
  dindo = spm->ind;
  dptro = spm->ptr;

  dnnzo = dnnzi;

  for(i=0;i<dnnzio;i++)
    dmat_io[i] = (double) i + 100.0;

  /* initialize sparse matrix fmat_i */
  if((fnnzi = gs_gen_sparse_mat_float(k, k, 2*k, &fmat_i, &findi, &fptri)) < 0) {
    fprintf(stderr,"Error creating sparse matrix\n");
    die(EXIT_FAILURE);
  }

  spm = gs_dup_sparse_mat(fnnzi, k, sizeof(*fmat_i), (void *)fmat_i, findi, fptri);

  if(!spm) {
    fprintf(stderr,"Could not dup sparse matrix\n");
    die(EXIT_FAILURE);
  }

  fmat_io = spm->m;
  findio = spm->ind;
  fptrio = spm->ptr;

  fnnzio = fnnzi;

  spm = gs_dup_sparse_mat(fnnzi, k, sizeof(*fmat_i), (void *)fmat_i, findi, fptri);

  if(!spm) {
    fprintf(stderr,"Could not dup sparse matrix\n");
    die(EXIT_FAILURE);
  }

  fmat_o = spm->m;
  findo = spm->ind;
  fptro = spm->ptr;

  fnnzo = fnnzi;

  for(i=0;i<fnnzio;i++)
    fmat_io[i] = (float) i + 100.0;

  /* initialize sparse matrix imat_i */
  if((innzi = gs_gen_sparse_mat_int(k, k, 2*k, &imat_i, &iindi, &iptri)) < 0) {
    fprintf(stderr,"Error creating sparse matrix\n");
    die(EXIT_FAILURE);
  }

  spm = gs_dup_sparse_mat(innzi, k, sizeof(*imat_i), (void *)imat_i, iindi, iptri);

  if(!spm) {
    fprintf(stderr,"Could not dup sparse matrix\n");
    die(EXIT_FAILURE);
  }

  imat_io = spm->m;
  iindio = spm->ind;
  iptrio = spm->ptr;

  innzio = innzi;

  spm = gs_dup_sparse_mat(innzi, k, sizeof(*imat_i), (void *)imat_i, iindi, iptri);

  if(!spm) {
    fprintf(stderr,"Could not dup sparse matrix\n");
    die(EXIT_FAILURE);
  }

  imat_o = spm->m;
  iindo = spm->ind;
  iptro = spm->ptr;

  innzo = innzi;

  for(i=0;i<innzio;i++)
    imat_io[i] = i + 100;

  /* initialize sparse matrix cmat_i */
  if((cnnzi = gs_gen_sparse_mat_char(k, k, 2*k, &cmat_i, &cindi, &cptri)) < 0) {
    fprintf(stderr,"Error creating sparse matrix\n");
    die(EXIT_FAILURE);
  }

  spm = gs_dup_sparse_mat(cnnzi, k, sizeof(*cmat_i), (void *)cmat_i, cindi, cptri);

  if(!spm) {
    fprintf(stderr,"Could not dup sparse matrix\n");
    die(EXIT_FAILURE);
  }

  cmat_io = spm->m;
  cindio = spm->ind;
  cptrio = spm->ptr;

  cnnzio = cnnzi;

  spm = gs_dup_sparse_mat(cnnzi, k, sizeof(*cmat_i), (void *)cmat_i, cindi, cptri);

  if(!spm) {
    fprintf(stderr,"Could not dup sparse matrix\n");
    die(EXIT_FAILURE);
  }

  cmat_o = spm->m;
  cindo = spm->ind;
  cptro = spm->ptr;

  cnnzo = cnnzi;

  for(i=0;i<cnnzio;i++)
    cmat_io[i] = i % 26 + 'A';

  if(grpc_initialize(NULL) != GRPC_NO_ERROR) {
    grpc_perror("grpc_initialize");
    die(EXIT_FAILURE);
  }

  if(grpc_function_handle_default(&__handle, "sparsetest") != GRPC_NO_ERROR) {
    fprintf(stderr,"Error creating function handle\n");
    die(EXIT_FAILURE);
  }

  __status = grpc_call(&__handle, dnnzi, dindi, dptri, dmat_i, dnnzio, dindio,
      dptrio, dmat_io, dnnzo, dindo, dptro, dmat_o, fnnzi, findi, fptri,
      fmat_i, fnnzio, findio, fptrio, fmat_io, fnnzo, findo, fptro, fmat_o, 
      innzi, iindi, iptri, imat_i, innzio, iindio, iptrio, imat_io, innzo,
      iindo, iptro, imat_o, cnnzi, cindi, cptri, cmat_i, cnnzio, cindio,
      cptrio, cmat_io, cnnzo, cindo, cptro, cmat_o, k, l);

  if(__status != GRPC_NO_ERROR) {
    fprintf(stderr,"GRPC error __status  = %d\n", __status);
    grpc_perror("grpc_call");
    die(__status);
  }

  printf("Call succeeded, verifying results...\n");

  if(validate_sparse_matrices(dnnzi, dindi, dptri, dmat_i, dnnzio, dindio, 
       dptrio, dmat_io, dnnzo, dindo, dptro, dmat_o, fnnzi, findi, fptri, 
       fmat_i, fnnzio, findio, fptrio, fmat_io, fnnzo, findo, fptro, 
       fmat_o, innzi, iindi, iptri, imat_i, innzio, iindio, iptrio, 
       imat_io, innzo, iindo, iptro, imat_o, cnnzi, cindi, cptri, 
       cmat_i, cnnzio, cindio, cptrio, cmat_io, cnnzo, cindo, cptro, 
       cmat_o, k, l) < 0) 
  {
    fprintf(stderr,"Incorrect results.\n");
    die(EXIT_FAILURE);
  }

  grpc_function_handle_destruct(&__handle);

  printf("Test: sparse_double_test\n");
  if(grpc_function_handle_default(&__handle, "sparse_double_matrix_test") != GRPC_NO_ERROR) {
    fprintf(stderr,"Error creating function handle\n");
    die(EXIT_FAILURE);
  }
  __status = grpc_call(&__handle, dnnzi, dindi, dptri, dmat_i, dnnzo, dindo, dptro, dmat_o, k, l);
  if(__status != GRPC_NO_ERROR) {
    fprintf(stderr,"GRPC error __status  = %d\n", __status);
    grpc_perror("grpc_call");
    die(__status);
  }
  printf("Call succeeded, verifying results...\n");
  if(validate_sparse_matrices(dnnzi, dindi, dptri, dmat_i, dnnzio, dindio, 
       dptrio, dmat_io, dnnzo, dindo, dptro, dmat_o, fnnzi, findi, fptri, 
       fmat_i, fnnzio, findio, fptrio, fmat_io, fnnzo, findo, fptro, 
       fmat_o, innzi, iindi, iptri, imat_i, innzio, iindio, iptrio, 
       imat_io, innzo, iindo, iptro, imat_o, cnnzi, cindi, cptri, 
       cmat_i, cnnzio, cindio, cptrio, cmat_io, cnnzo, cindo, cptro, 
       cmat_o, k, l) < 0) 
  {
    fprintf(stderr,"Incorrect results.\n");
    die(EXIT_FAILURE);
  }

  grpc_function_handle_destruct(&__handle);

  grpc_finalize();
  die(EXIT_SUCCESS);
}

int
validate_sparse_matrices(int dnnzi, int *dindi, int *dptri,
  double *dmat_i,
  int dnnzio, int *dindio, int *dptrio,
  double *dmat_io,  
  int dnnzo, int *dindo, int *dptro,
  double *dmat_o,  
  
  int fnnzi, int *findi, int *fptri,
  float *fmat_i, 
  int fnnzio, int *findio, int *fptrio,
  float *fmat_io, 
  int fnnzo, int *findo, int *fptro,
  float *fmat_o, 
  
  int innzi, int *iindi, int *iptri,
  int *imat_i,
  int innzio, int *iindio, int *iptrio,
  int *imat_io,
  int innzo, int *iindo, int *iptro,
  int *imat_o,
  
  int cnnzi, int *cindi, int *cptri,
  char *cmat_i,
  int cnnzio, int *cindio, int *cptrio,
  char *cmat_io,
  int cnnzo, int *cindo, int *cptro,
  char *cmat_o,

  int k, int l)
{
  int i, saw_failure;

  saw_failure = 0;

  for(i=0;i<dnnzio;i++)
    if(GS_NE(dmat_io[i], (double) i + 101.0)) {
      fprintf(stderr, "double Input/output sparse matrix incorrect %g != %g\n",
        dmat_io[i], (double) i + 101.0);
      saw_failure = 1;
    }

  for(i=0;i<MIN(dnnzo, dnnzi);i++)
    if(GS_NE(dmat_o[i], dmat_i[i] + 1.0)) {
      fprintf(stderr, "double Output sparse matrix value incorrect %g != %g\n",
        dmat_o[i], dmat_i[i] + 1.0);
      saw_failure = 1;
    }

  for(i=0;i<fnnzio;i++)
    if(GS_NE(fmat_io[i], (float) i + 101.0)) {
      fprintf(stderr, "float Input/output sparse matrix incorrect %g != %g\n",
        fmat_io[i], (float) i + 101.0);
      saw_failure = 1;
    }

  for(i=0;i<MIN(fnnzo, fnnzi);i++)
    if(GS_NE(fmat_o[i], fmat_i[i] + 1.0)) {
      fprintf(stderr, "float Output sparse matrix value incorrect %g != %g\n",
        fmat_o[i], fmat_i[i] + 1.0);
      saw_failure = 1;
    }

  for(i=0;i<innzio;i++)
    if(imat_io[i] != i + 101) {
      fprintf(stderr, "int Input/output sparse matrix incorrect %d != %d\n",
        imat_io[i], i + 101);
      saw_failure = 1;
    }

  for(i=0;i<MIN(innzo, innzi);i++)
    if(imat_o[i] != imat_i[i] + 1) {
      fprintf(stderr, "int Output sparse matrix value incorrect %d != %d\n",
        imat_o[i], imat_i[i] + 1);
      saw_failure = 1;
    }

  for(i=0;i<cnnzio;i++)
    if(cmat_io[i] != i % 26 + 'B') {
      fprintf(stderr, "char Input/output sparse matrix incorrect %d != %d\n",
        cmat_io[i], i % 26 + 'B');
      saw_failure = 1;
    }

  for(i=0;i<MIN(cnnzo, cnnzi);i++)
    if(cmat_o[i] != cmat_i[i] + 1) {
      fprintf(stderr, "char Output sparse matrix value incorrect %c != %c\n",
        cmat_o[i], cmat_i[i] + 1);
      saw_failure = 1;
    }

  return saw_failure ? -1 : 0;
}
