/**
 * @file
 *
 * This code fragment is included in totaltest_init.c, which is
 * included in tests that call 'ctotal' or 'ftotal'.  It allocates
 * space and assigns initial values to all the various parameters
 * needed by ctotal/ftotal.
 *
 */
/* $Id: totaltest_arg_init.c,v 1.6 2006/01/30 17:57:57 yarkhan Exp $ */
/* $UTK_Copyright: $ */

  imat_in    = (int *)malloc(MAT_M * MAT_N * sizeof(int));
  imat_inout = (int *)malloc(MAT_M * MAT_N * sizeof(int));
  imat_out   = (int *)malloc(MAT_M * MAT_N * sizeof(int));

  fmat_in    = (float *)malloc(MAT_M * MAT_N * sizeof(float));
  fmat_inout = (float *)malloc(MAT_M * MAT_N * sizeof(float));
  fmat_out   = (float *)malloc(MAT_M * MAT_N * sizeof(float));

  dmat_in    = (double *)malloc(MAT_M * MAT_N * sizeof(double));
  dmat_inout = (double *)malloc(MAT_M * MAT_N * sizeof(double));
  dmat_out   = (double *)malloc(MAT_M * MAT_N * sizeof(double));

  scmp_mat_in    = (gs_scomplex *)malloc(MAT_M * MAT_N * sizeof(gs_scomplex));
  scmp_mat_inout = (gs_scomplex *)malloc(MAT_M * MAT_N * sizeof(gs_scomplex));
  scmp_mat_out   = (gs_scomplex *)malloc(MAT_M * MAT_N * sizeof(gs_scomplex));

  dcmp_mat_in    = (gs_dcomplex *)malloc(MAT_M * MAT_N * sizeof(gs_dcomplex));
  dcmp_mat_inout = (gs_dcomplex *)malloc(MAT_M * MAT_N * sizeof(gs_dcomplex));
  dcmp_mat_out   = (gs_dcomplex *)malloc(MAT_M * MAT_N * sizeof(gs_dcomplex));

  cmat_in    = (char *)malloc(MAT_M * MAT_N * sizeof(char));
  cmat_inout = (char *)malloc(MAT_M * MAT_N * sizeof(char));
  cmat_out   = (char *)malloc(MAT_M * MAT_N * sizeof(char));

  if( !imat_in     || !imat_inout     || !imat_out ||
      !fmat_in     || !fmat_inout     || !fmat_out ||
      !dmat_in     || !dmat_inout     || !dmat_out ||
      !scmp_mat_in || !scmp_mat_inout || !scmp_mat_out ||
      !dcmp_mat_in || !dcmp_mat_inout || !dcmp_mat_out ||
      !cmat_in     || !cmat_inout     || !cmat_out)
  {
    fprintf(stderr,"Could not allocate matrix.\n");
    die(EXIT_FAILURE);
  }

  int_in = 8080;
  int_inout = int_in + 100;

  float_in = (float)1.32;
  float_inout = float_in + (float)100.0;

  double_in = 6.66;
  double_inout = double_in + 100.0;

  scmp_in.r = (float)1.32;
  scmp_in.i = 2.0;

  scmp_inout.r = scmp_in.r + (float)100.0;
  scmp_inout.i = scmp_in.i + (float)100.0;

  dcmp_in.r = 6.66;
  dcmp_in.i = 2.0;

  dcmp_inout.r = dcmp_in.r + 100.0;
  dcmp_inout.i = dcmp_in.i + 100.0;

  char_in = 'a';
  char_inout = char_in + ('i'-'a');

  for(i=0;i<IVEC_SIZE;i++) {
    ivec_in[i] = i;
    ivec_inout[i] = 100+i;
  }

  for(i=0;i<FVEC_SIZE;i++) {
    fvec_in[i] = (float)i;
    fvec_inout[i] = (float)(100+i);
  }

  for(i=0;i<DVEC_SIZE;i++) {
    dvec_in[i] = (double)i;
    dvec_inout[i] = (double)(100+i);
  }

  for(i=0;i<SCMP_VEC_SIZE;i++) {
    scmp_vec_in[i].r = (float)i;
    scmp_vec_in[i].i = (float)(10+i);

    scmp_vec_inout[i].r = (float)(100+i);
    scmp_vec_inout[i].i = (float)(10+i);
  }

  for(i=0;i<DCMP_VEC_SIZE;i++) {
    dcmp_vec_in[i].r = (double)i;
    dcmp_vec_in[i].i = (double)(10+i);

    dcmp_vec_inout[i].r = (double)(100+i);
    dcmp_vec_inout[i].i = (double)(10+i);
  }

  for(i=0;i<CVEC_SIZE;i++) {
    cvec_in[i] = 'a'+i;
    cvec_inout[i] = 'i'+i;
  }

  for(i=0;i<MAT_M;i++) {
    for(j=0;j<MAT_N;j++) {
      imat_in[i*MAT_N+j] = i*MAT_N+j;
      imat_inout[i*MAT_N+j] = 100+(i*MAT_N+j);

      fmat_in[i*MAT_N+j] = (float)(i*MAT_N+j);
      fmat_inout[i*MAT_N+j] = (float)(100+(i*MAT_N+j));

      dmat_in[i*MAT_N+j] = (double)(i*MAT_N+j);
      dmat_inout[i*MAT_N+j] = (double)(100+(i*MAT_N+j));

      scmp_mat_in[i*MAT_N+j].r = (float)(i*MAT_N+j);
      scmp_mat_in[i*MAT_N+j].i = (float)(10 + i*MAT_N+j);
      scmp_mat_inout[i*MAT_N+j].r = (float)(100+(i*MAT_N+j));
      scmp_mat_inout[i*MAT_N+j].i = (float)(10+(i*MAT_N+j));

      dcmp_mat_in[i*MAT_N+j].r = (double)(i*MAT_N+j);
      dcmp_mat_in[i*MAT_N+j].i = (double)(10 + i*MAT_N+j);
      dcmp_mat_inout[i*MAT_N+j].r = (double)(100+(i*MAT_N+j));
      dcmp_mat_inout[i*MAT_N+j].i = (double)(10+(i*MAT_N+j));

      cmat_in[i*MAT_N+j] = 'a'+i*MAT_N+j;
      cmat_inout[i*MAT_N+j] = 'i'+(i*MAT_N+j);
    }
  }
