/**
 * @file
 *
 * This code fragment is included in after the GridRPC call in tests that
 * call 'ctotal' or 'ftotal'.  It prints the results and verifies that the
 * values are correct.
 *
 */
/* $Id: totaltest_results.c,v 1.10 2005/11/10 20:46:06 seymour Exp $ */
/* $UTK_Copyright: $ */

  printf("int_in = %d\n", int_in);
  printf("int_inout = %d\n", int_inout);
  printf("int_out = %d\n", int_out);

  printf("float_in = %f\n", float_in);
  printf("float_inout = %f\n", float_inout);
  printf("float_out = %f\n", float_out);

  printf("double_in = %g\n", double_in);
  printf("double_inout = %g\n", double_inout);
  printf("double_out = %g\n", double_out);

  printf("scmp_in = %g+%gi\n", scmp_in.r, scmp_in.i);
  printf("scmp_inout = %g+%gi\n", scmp_inout.r, scmp_inout.i);
  printf("scmp_out = %g+%gi\n", scmp_out.r, scmp_out.i);

  printf("dcmp_in = %g+%gi\n", dcmp_in.r, dcmp_in.i);
  printf("dcmp_inout = %g+%gi\n", dcmp_inout.r, dcmp_inout.i);
  printf("dcmp_out = %g+%gi\n", dcmp_out.r, dcmp_out.i);

  printf("char_in = %c\n", char_in);
  printf("char_inout = %c\n", char_inout);
  printf("char_out = %c\n", char_out);

  print_ivec("ivec_in", ivec_in, IVEC_SIZE);
  print_ivec("ivec_inout", ivec_inout, IVEC_SIZE);
  print_ivec("ivec_out", ivec_out, IVEC_SIZE);

  print_fvec("fvec_in", fvec_in, FVEC_SIZE);
  print_fvec("fvec_inout", fvec_inout, FVEC_SIZE);
  print_fvec("fvec_out", fvec_out, FVEC_SIZE);

  print_dvec("dvec_in", dvec_in, DVEC_SIZE);
  print_dvec("dvec_inout", dvec_inout, DVEC_SIZE);
  print_dvec("dvec_out", dvec_out, DVEC_SIZE);

  print_scmp_vec("scmp_vec_in", scmp_vec_in, SCMP_VEC_SIZE);
  print_scmp_vec("scmp_vec_inout", scmp_vec_inout, SCMP_VEC_SIZE);
  print_scmp_vec("scmp_vec_out", scmp_vec_out, SCMP_VEC_SIZE);

  print_dcmp_vec("dcmp_vec_in", dcmp_vec_in, DCMP_VEC_SIZE);
  print_dcmp_vec("dcmp_vec_inout", dcmp_vec_inout, DCMP_VEC_SIZE);
  print_dcmp_vec("dcmp_vec_out", dcmp_vec_out, DCMP_VEC_SIZE);

  print_cvec("cvec_in", cvec_in, CVEC_SIZE);
  print_cvec("cvec_inout", cvec_inout, CVEC_SIZE);
  print_cvec("cvec_out", cvec_out, CVEC_SIZE);

  print_imat("imat_in", imat_in, MAT_M, MAT_N);
  print_imat("imat_inout", imat_inout, MAT_M, MAT_N);
  print_imat("imat_out", imat_out, MAT_M, MAT_N);

  print_fmat("fmat_in", fmat_in, MAT_M, MAT_N);
  print_fmat("fmat_inout", fmat_inout, MAT_M, MAT_N);
  print_fmat("fmat_out", fmat_out, MAT_M, MAT_N);

  print_dmat("dmat_in", dmat_in, MAT_M, MAT_N);
  print_dmat("dmat_inout", dmat_inout, MAT_M, MAT_N);
  print_dmat("dmat_out", dmat_out, MAT_M, MAT_N);

  print_scmp_mat("scmp_mat_in", scmp_mat_in, MAT_M, MAT_N);
  print_scmp_mat("scmp_mat_inout", scmp_mat_inout, MAT_M, MAT_N);
  print_scmp_mat("scmp_mat_out", scmp_mat_out, MAT_M, MAT_N);

  print_dcmp_mat("dcmp_mat_in", dcmp_mat_in, MAT_M, MAT_N);
  print_dcmp_mat("dcmp_mat_inout", dcmp_mat_inout, MAT_M, MAT_N);
  print_dcmp_mat("dcmp_mat_out", dcmp_mat_out, MAT_M, MAT_N);

  print_cmat("cmat_in", cmat_in, MAT_M, MAT_N);
  print_cmat("cmat_inout", cmat_inout, MAT_M, MAT_N);
  print_cmat("cmat_out", cmat_out, MAT_M, MAT_N);

  {
    int __saw_failure = 0;

    if(int_in != int_inout - 101) {
      printf("Integer scalar in/out incorrect %d != %d\n", 
          int_in, int_inout - 101);
      __saw_failure = 1;
    }

    if(int_in != int_out - 1) {
      printf("Integer scalar output arg incorrect %d != %d\n",
          int_in, int_out - 1);
      __saw_failure = 1;
    }

    if(GS_NE(float_in, float_inout - 101.0)) {
      printf("Single precision scalar in/out incorrect %g != %g\n",
          float_in, float_inout - 101.0);
      __saw_failure = 1;
    }

    if(GS_NE(float_in, float_out - 1.0)) {
      printf("Single precision scalar output arg incorrect %g != %g\n",
          float_in, float_out - 1.0);
      __saw_failure = 1;
    }

    if(GS_NE(double_in, double_inout - 101.0)) {
      printf("Double precision scalar in/out incorrect %g != %g\n",
          double_in, double_inout - 101.0);
      __saw_failure = 1;
    }

    if(GS_NE(double_in, double_out - 1.0)) {
      printf("Double precision scalar output arg incorrect %g != %g\n",
          double_in, double_out - 1.0);
      __saw_failure = 1;
    }

    if(GS_NE(scmp_in.r, scmp_inout.r - 101.0)) {
      printf("scomplex (real part) scalar in/out incorrect %g != %g\n",
          scmp_in.r, scmp_inout.r - 101.0);
      __saw_failure = 1;
    }

    if(GS_NE(scmp_in.i, scmp_inout.i - 101.0)) {
      printf("scomplex (imag part) scalar in/out incorrect %g != %g\n",
          scmp_in.i, scmp_inout.i - 101.0);
      __saw_failure = 1;
    }

    if(GS_NE(scmp_in.r, scmp_out.r - 1.0)) {
      printf("scomplex (real part) scalar output arg incorrect %g != %g\n",
          scmp_in.r, scmp_out.r - 1.0);
      __saw_failure = 1;
    }

    if(GS_NE(scmp_in.i, scmp_out.i - 1.0)) {
      printf("scomplex (imag part) scalar output arg incorrect %g != %g\n",
          scmp_in.i, scmp_out.i - 1.0);
      __saw_failure = 1;
    }

    if(GS_NE(dcmp_in.r, dcmp_inout.r - 101.0)) {
      printf("dcomplex (real part) scalar in/out incorrect %g != %g\n",
          dcmp_in.r, dcmp_inout.r - 101.0);
      __saw_failure = 1;
    } 

    if(GS_NE(dcmp_in.i, dcmp_inout.i - 101.0)) {
      printf("dcomplex (imag part) scalar in/out incorrect %g != %g\n",
          dcmp_in.i, dcmp_inout.i - 101.0);
      __saw_failure = 1;
    }

    if(GS_NE(dcmp_in.r, dcmp_out.r - 1.0)) {
      printf("scomplex (real part) scalar output arg incorrect %g != %g\n",
          dcmp_in.r, dcmp_out.r - 1.0);
      __saw_failure = 1;
    }

    if(GS_NE(dcmp_in.i, dcmp_out.i - 1.0)) {
      printf("scomplex (imag part) scalar output arg incorrect %g != %g\n",
          dcmp_in.i, dcmp_out.i - 1.0);
      __saw_failure = 1;
    }

    if(char_in != char_inout - ('j'-'a')) {
      printf("Character scalar in/out incorrect %c != %c\n",
          char_in, char_inout - 101);
      __saw_failure = 1;
    }

    if(char_in != char_out - 1) {
      printf("Character scalar output arg incorrect %c != %c\n",
          char_in, char_out - 1);
      __saw_failure = 1;
    }

    for(i=0;i<IVEC_SIZE;i++) {
      if(ivec_in[i] != ivec_inout[i] - 101) {
        printf("Integer vector in/out incorrect %d != %d\n", 
            ivec_in[i], ivec_inout[i] - 101);
        __saw_failure = 1;
        break;
      }
      if(ivec_in[i] != ivec_out[i] - 1) {
        printf("Integer vector output arg incorrect %d != %d\n",
            ivec_in[i], ivec_out[i] - 1);
        __saw_failure = 1;
        break;
      }
    }

    for(i=0;i<FVEC_SIZE;i++) {
      if(GS_NE(fvec_in[i], fvec_inout[i] - 101.0)) {
        printf("Single-precision vector in/out incorrect %g != %g\n",
            fvec_in[i], fvec_inout[i] - 101.0);
        __saw_failure = 1;
        break;
      }
      if(GS_NE(fvec_in[i], fvec_out[i] - 1.0)) {
        printf("Single-precision vector output arg incorrect %g != %g\n",
            fvec_in[i], fvec_out[i] - 1.0);
        __saw_failure = 1;
        break;
      }
    }

    for(i=0;i<DVEC_SIZE;i++) {
      if(GS_NE(dvec_in[i], dvec_inout[i] - 101.0)) {
        printf("Double-precision vector in/out incorrect %g != %g\n",
            dvec_in[i], dvec_inout[i] - 101.0);
        __saw_failure = 1;
        break;
      }
      if(GS_NE(dvec_in[i], dvec_out[i] - 1.0)) {
        printf("Double-precision vector output arg incorrect %g != %g\n",
            dvec_in[i], dvec_out[i] - 1.0);
        __saw_failure = 1;
        break;
      }
    }

    for(i=0;i<SCMP_VEC_SIZE;i++) {
      if(GS_NE(scmp_vec_in[i].r, scmp_vec_inout[i].r - 101.0)) {
        printf("scomplex vector (real part) in/out incorrect %g != %g\n",
            scmp_vec_in[i].r, scmp_vec_inout[i].r - 101.0);
        __saw_failure = 1;
        break;
      }
      if(GS_NE(scmp_vec_in[i].i, scmp_vec_inout[i].i - 1.0)) {
        printf("scomplex vector (imag part) in/out incorrect %g != %g\n",
            scmp_vec_in[i].i, scmp_vec_inout[i].i - 101.0);
        __saw_failure = 1;
        break;
      }
      if(GS_NE(scmp_vec_in[i].r, scmp_vec_out[i].r - 1.0)) {
        printf("scomplex vector (real part) output arg incorrect %g != %g\n",
            scmp_vec_in[i].r, scmp_vec_out[i].r - 1.0);
        __saw_failure = 1;
        break;
      }
      if(GS_NE(scmp_vec_in[i].i, scmp_vec_out[i].i - 1.0)) {
        printf("scomplex vector (imag part) output arg incorrect %g != %g\n",
            scmp_vec_in[i].i, scmp_vec_out[i].i - 1.0);
        __saw_failure = 1;
        break;
      }
    }

    for(i=0;i<DCMP_VEC_SIZE;i++) {
      if(GS_NE(dcmp_vec_in[i].r, dcmp_vec_inout[i].r - 101.0)) {
        printf("dcomplex vector (real part) in/out incorrect %g != %g\n",
            dcmp_vec_in[i].r, dcmp_vec_inout[i].r - 101.0);
        __saw_failure = 1;
        break;
      }
      if(GS_NE(dcmp_vec_in[i].i, dcmp_vec_inout[i].i - 1.0)) {
        printf("dcomplex vector (imag part) in/out incorrect %g != %g\n",
            dcmp_vec_in[i].i, dcmp_vec_inout[i].i - 101.0);
        __saw_failure = 1;
        break;
      }
      if(GS_NE(dcmp_vec_in[i].r, dcmp_vec_out[i].r - 1.0)) {
        printf("dcomplex vector (real part) output arg incorrect %g != %g\n",
            dcmp_vec_in[i].r, dcmp_vec_out[i].r - 1.0);
        __saw_failure = 1;
        break;
      }
      if(GS_NE(dcmp_vec_in[i].i, dcmp_vec_out[i].i - 1.0)) {
        printf("dcomplex vector (imag part) output arg incorrect %g != %g\n",
            dcmp_vec_in[i].i, dcmp_vec_out[i].i - 1.0);
        __saw_failure = 1;
        break;
      }
    }

    for(i=0;i<CVEC_SIZE;i++) {
      if(cvec_in[i] != cvec_inout[i] - ('j'-'a')) {
        printf("Character vector in/out incorrect %c != %c\n",
            cvec_in[i], cvec_inout[i] - ('j'-'a'));
        __saw_failure = 1;
        break;
      }
      if(cvec_in[i] != cvec_out[i] - 1) {
        printf("Character vector output arg incorrect %c != %c\n",
            cvec_in[i], cvec_out[i] - 1);
        __saw_failure = 1;
        break;
      }
    }

    for(i=0;i<MAT_M;i++) {
      for(j=0;j<MAT_N;j++) {
        if(imat_in[i*MAT_N+j] != imat_inout[i*MAT_N+j] - 101) {
          printf("Integer matrix in/out incorrect %d != %d\n",
              imat_in[i*MAT_N+j], imat_inout[i*MAT_N+j] - 101);
          __saw_failure = 1;
          break;
        }
        if(imat_in[i*MAT_N+j] != imat_out[i*MAT_N+j] - 1) {
          printf("Integer matrix output arg incorrect %d != %d\n",
              imat_in[i*MAT_N+j], imat_out[i*MAT_N+j] - 1);
          __saw_failure = 1;
          break;
        }

        if(GS_NE(fmat_in[i*MAT_N+j], fmat_inout[i*MAT_N+j] - 101.0)) {
          printf("Single-precision matrix in/out incorrect %g != %g\n",
              fmat_in[i*MAT_N+j], fmat_inout[i*MAT_N+j] - 101.0);
          __saw_failure = 1;
          break;
        }
        if(GS_NE(fmat_in[i*MAT_N+j], fmat_out[i*MAT_N+j] - 1.0)) {
          printf("Single-precision matrix output arg incorrect %g != %g\n",
              fmat_in[i*MAT_N+j], fmat_out[i*MAT_N+j] - 1.0);
          __saw_failure = 1;
          break;
        }

        if(GS_NE(dmat_in[i*MAT_N+j], dmat_inout[i*MAT_N+j] - 101.0)) {
          printf("Double-precision matrix in/out incorrect %g != %g\n",
              dmat_in[i*MAT_N+j], dmat_inout[i*MAT_N+j] - 101.0);
          __saw_failure = 1;
          break;
        }
        if(GS_NE(dmat_in[i*MAT_N+j], dmat_out[i*MAT_N+j] - 1.0)) {
          printf("Double-precision matrix output arg incorrect %g != %g\n",
              dmat_in[i*MAT_N+j], dmat_out[i*MAT_N+j] - 1.0);
          __saw_failure = 1;
          break;
        }

        if(GS_NE(scmp_mat_in[i*MAT_N+j].r, scmp_mat_inout[i*MAT_N+j].r - 101.0)) {
          printf("scomplex matrix (real part) in/out incorrect %g != %g\n",
              scmp_mat_in[i*MAT_N+j].r, scmp_mat_inout[i*MAT_N+j].r - 101.0);
          __saw_failure = 1;
          break;
        }
        if(GS_NE(scmp_mat_in[i*MAT_N+j].i, scmp_mat_inout[i*MAT_N+j].i - 1.0)) {
          printf("scomplex matrix (imag part) in/out incorrect %g != %g\n",
              scmp_mat_in[i*MAT_N+j].i, scmp_mat_inout[i*MAT_N+j].i - 101.0);
          __saw_failure = 1;
          break;
        }
        if(GS_NE(scmp_mat_in[i*MAT_N+j].r, scmp_mat_out[i*MAT_N+j].r - 1.0)) {
          printf("scomplex matrix (real part) output arg incorrect %g != %g\n",
              scmp_mat_in[i*MAT_N+j].r, scmp_mat_out[i*MAT_N+j].r - 1.0);
          __saw_failure = 1;
          break;
        }
        if(GS_NE(scmp_mat_in[i*MAT_N+j].i, scmp_mat_out[i*MAT_N+j].i - 1.0)) {
          printf("scomplex matrix (imag part) output arg incorrect %g != %g\n",
              scmp_mat_in[i*MAT_N+j].i, scmp_mat_out[i*MAT_N+j].i - 1.0);
          __saw_failure = 1;
          break;
        }

        if(GS_NE(dcmp_mat_in[i*MAT_N+j].r, dcmp_mat_inout[i*MAT_N+j].r - 101.0)) {
          printf("dcomplex matrix (real part) in/out incorrect %g != %g\n",
              dcmp_mat_in[i*MAT_N+j].r, dcmp_mat_inout[i*MAT_N+j].r - 101.0);
          __saw_failure = 1;
          break;
        }
        if(GS_NE(dcmp_mat_in[i*MAT_N+j].i, dcmp_mat_inout[i*MAT_N+j].i - 1.0)) {
          printf("dcomplex matrix (imag part) in/out incorrect %g != %g\n",
              dcmp_mat_in[i*MAT_N+j].i, dcmp_mat_inout[i*MAT_N+j].i - 101.0);
          __saw_failure = 1;
          break;
        }
        if(GS_NE(dcmp_mat_in[i*MAT_N+j].r, dcmp_mat_out[i*MAT_N+j].r - 1.0)) {
          printf("dcomplex matrix (real part) output arg incorrect %g != %g\n",
              dcmp_mat_in[i*MAT_N+j].r, dcmp_mat_out[i*MAT_N+j].r - 1.0);
          __saw_failure = 1;
          break;
        }
        if(GS_NE(dcmp_mat_in[i*MAT_N+j].i, dcmp_mat_out[i*MAT_N+j].i - 1.0)) {
          printf("dcomplex matrix (imag part) output arg incorrect %g != %g\n",
              dcmp_mat_in[i*MAT_N+j].i, dcmp_mat_out[i*MAT_N+j].i - 1.0);
          __saw_failure = 1;
          break;
        }

        if(cmat_in[i*MAT_N+j] != cmat_inout[i*MAT_N+j] - ('j'-'a')) {
          printf("Character matrix in/out incorrect %c != %c\n",
              cmat_in[i*MAT_N+j], cmat_inout[i*MAT_N+j] - ('j'-'a'));
          __saw_failure = 1;
          break;
        }
        if(cmat_in[i*MAT_N+j] != cmat_out[i*MAT_N+j] - 1) {
          printf("Character matrix output arg incorrect %c != %c\n",
              cmat_in[i*MAT_N+j], cmat_out[i*MAT_N+j] - 1);
          __saw_failure = 1;
          break;
        }
      }
    }

    if(__saw_failure)
      die(EXIT_FAILURE);
  }

  free(imat_in);
  free(imat_inout);
  free(imat_out);

  free(fmat_in);
  free(fmat_inout);
  free(fmat_out);

  free(dmat_in);
  free(dmat_inout);
  free(dmat_out);

  free(cmat_in);
  free(cmat_inout);
  free(cmat_out);
