fprintf(2, '------------- \n')
fprintf(2, 'GridSolve Demo \n')
fprintf(2, 'This demo will run through a few simple examples. \n')
fprintf(2, 'It shows the capability of sending service requests. \n')
fprintf(2, 'to a remote server. \n')
fprintf(2, '\n')
fprintf(2, 'You need to enter the size of problems you want to run. \n')
fprintf(2, '\n')

m = input(['Enter the size (m) of the matrix and vector to be ' ...
           'used [200] :']);
fprintf(2,'\n')
if (size(m,1) == 0)
  m = 200;
end

fprintf(2, 'Generating a %dx%d matrix and a %dx1 vector locally....\n',m,m,m)
a = rand(m);
b = rand(m,1);

fprintf(2, '---------------------------------- \n\n')
fprintf(2, 'SOLVE A SYSTEM OF EQUATIONS USING GridSolve \n')
fprintf(2, 'About to call \n ')
fprintf(2, '[x,y,z,info]=gs_call(''dgesv'',m,1,a,m,b,m); \n\n')
tic
[x,y,z,info]=gs_call('dgesv',m,1,a,m,b,m);
toc
[e] = gs_get_last_error;
if (e ~= 0)
  fprintf(2,'%s\n',gs_error_string(e))
else
  r=norm(a*z-b)/(norm(a)*norm(z)*m*eps);
  if ( info~= 0 | r > 50.0 )
    fprintf(2, '** DGESV Failure ** with r=%f', r)
  else
    fprintf(2, '** DGESV Passed Tests **\n')
  end
end
fprintf(2, '\tCompleted\n')
fprintf(2, '\n')


fprintf(2, '---------------------------------- \n\n')
fprintf(2, 'COMPUTE SOME EIGENVALUES AND VECTORS USING GridSolve,\n')
fprintf(2, 'About to call \n ')
fprintf(2, '[ a ,wr ,wi ,vr ,info  ] = gs_call (''dgeev'', ''N'', ''V'', m, a, m, m, m, 4*m) \n');
tic
[ a, wr ,wi ,vl, vr ,info  ] = gs_call ('dgeev', 'N', 'V', m, a, m, 1, m, 4*m);
toc
w = wr + i *wi;
if (max(eig(a) - w) < eps+eps*i),
  fprintf(2, '** DGEEV Passed Test **\n')
else
  fprintf(2, '** DGEEV Failed Test **\n')  
end  
fprintf(2, '\tCompleted\n')
fprintf(2, '\n')

