fprintf(2, '------------- \n')
fprintf(2, 'GridSolve DEMO \n')
fprintf(2, 'This demo will run through several non-blocking \n')
fprintf(2, 'calls to GridSolve using the LAPACK routine DGESV.\n')
fprintf(2, 'In this demo, the number of rhs vectors varies\n')
fprintf(2, 'from 2 to 5\n')
fprintf(2, '\n');

m = input(['Enter the size (m) of the matrix [500] :']);
fprintf(2,'\n')
if (size(m,1) == 0)
  m = 500;
end

result = [ 'failed'; 'passed' ];
eps = 1e-10;

n1 = m;
a1 = rand(n1);
b1 = rand(n1,2);
n2 = m;
a2 = rand(n2);
b2 = rand(n2,3);
n3 = m;
a3 = rand(n3);
b3 = rand(n3,4);
n4 = m;
a4 = rand(n4);
b4 = rand(n4,5);

lda = m;
ldb = m;

fprintf(2, '\n** Send the non-blocking requests for "DGESV"\n\n')
fprintf(' [rr1]=gridsolve_nb(''send'',''dgesv'',m,2,a1,b1,ldb); \n')
[rr1]=gridsolve_nb('send','dgesv',m,2,a1,lda,b1,ldb);
fprintf(' [rr2]=gridsolve_nb(''send'',''dgesv'',m,3,a2,lda,b2,ldb); \n')
[rr2]=gridsolve_nb('send','dgesv',m,3,a2,lda,b2,ldb);
fprintf(' [rr1]=gridsolve_nb(''send'',''dgesv'',m,4,a3,lda,b3,ldb); \n')
[rr3]=gridsolve_nb('send','dgesv',m,4,a3,lda,b3,ldb);
fprintf(' [rr1]=gridsolve_nb(''send'',''dgesv'',m,5,a4,lda,b4,ldb); \n')
[rr4]=gridsolve_nb('send','dgesv',m,5,a4,lda,b4,ldb);


fprintf(2, '\n** Probing for results ... **\n')
fprintf(' while status1 < 0, [status1]=gridsolve_nb(''probe'',rr1); end \n');
[status1]=gridsolve_nb('probe',rr1);
while status1 < 0,
    [status1]=gridsolve_nb('probe',rr1);
end
fprintf(' [aa1, ipiv1, x1, info]=gridsolve_nb(''wait'',rr1); \n');
[aa1, ipiv1, x1, info]=gridsolve_nb('wait',rr1);
fprintf(' Checked result: %s \n', result((max(max(a1*x1 - b1))<eps)+1, :) );

fprintf(2, '\n** Probing for results ... **\n')
fprintf(' while status2 < 0, [status2]=gridsolve_nb(''probe'',rr2); end \n');
[status2]=gridsolve_nb('probe',rr2);
while status2 < 0,
    [status2]=gridsolve_nb('probe',rr2);
end
fprintf(' [aa2, ipiv2, x2, info]=gridsolve_nb(''wait'',rr2); \n');
[aa2, ipiv2, x2, info]=gridsolve_nb('wait',rr2);
fprintf(' Checked result: %s \n', result((max(max(a2*x2 - b2))<eps)+1, :) );


fprintf(2, '\n** Probing for results ... **\n')
fprintf(' while status3 < 0, [status3]=gridsolve_nb(''probe'',rr3); end \n');
[status3]=gridsolve_nb('probe',rr3);
while status3 < 0,
    [status3]=gridsolve_nb('probe',rr3);
end
fprintf(' [aa3, ipiv3, x3, info]=gridsolve_nb(''wait'',rr3); \n');
[aa3, ipiv3, x3, info]=gridsolve_nb('wait',rr3);
fprintf(' Checked result: %s \n', result((max(max(a3*x3 - b3))<eps)+1, :) );

fprintf(2, '\n** Probing for results ... **\n')
fprintf(' while status4 < 0, [status4]=gridsolve_nb(''probe'',rr4); end \n');
[status4]=gridsolve_nb('probe',rr4);
while status4 < 0,
    [status4]=gridsolve_nb('probe',rr4);
end
fprintf(' [aa4, ipiv4, x4, info]=gridsolve_nb(''wait'',rr4); \n');
[aa4, ipiv4, x4, info]=gridsolve_nb('wait',rr4);
fprintf(' Checked result: %s \n', result((max(max(a4*x4 - b4))<eps)+1, :) );

fprintf(2, '\n');
