fprintf(2, '------------- \n')
fprintf(2, 'GridSolve DEMO \n')
fprintf(2, 'This demo will run a SuperLU sparse matrix example. \n')
fprintf(2, 'Here''s what the matrix looks like. \n')
clear

result = [ 'failed'; 'passed' ];
eps = 1e-10;

[A,rhs]=generate(4);
figure(1), spy(A)
% fprintf(2, 'Hit return to continue. \n'); pause
pause(3);

[m,n]=size(A);
fprintf(2, 'Matrix A is [%d,%d] with %d non-zeros \n', m,n,nnz(A));
fprintf(2, '[ x ] = gs_call (''dgssv_superlu'', nnz(A), A, m, n, rhs)\n');
[ x ] = gs_call ('dgssv_superlu', nnz(A), A, m, n, rhs);
[e] = gs_get_last_error;
if (e ~= 0)
  fprintf(2,'%s\n',gs_error_string(e))
else
  r=norm(full(A*x-rhs))/(norm(full(A))*norm(full(x))*eps);
  if ( r > 50.0 )
    fprintf(2, '** SuperLU Failure **')
    r
  else
    fprintf(2, '** SuperLU Passed Tests **\n')
  end
end



