fprintf(2, '------------- \n')
fprintf(2, 'GridSolve DEMO \n')
fprintf(2, 'This demo will run through several non-blocking \n')
fprintf(2, 'calls to GridSolve using the LAPACK routine DGEEV.\n')
fprintf(2, '\n');

m = input(['Enter the size (m) of the matrix to be used [800] :']);
if (size(m,1) == 0)
  m = 100;
end

numcalls = input(['Enter number of asynchronous calls to be made [20] :']);
if (size(numcalls,1) == 0)
  numcalls = 20;
end

eps = 10;

fprintf(2, 'Submit requests for eigenvalues and vectors using GridSolve\n');
for iter=1:numcalls, 
  fprintf(2, 'a = rand(m); data{%d}=a\n', iter);
  a = rand(m)*100;
  data{iter} = a;
  fprintf(2, 'sid{%d} = gridsolve_nb (''dgeev'', ''N'', ''V'', m, a1, m, 1, m, 4*m)\n', iter);
  sid{iter} = gridsolve_nb ('send', 'dgeev', 'N', 'V', m, a, m, 1, m, 4*m);
end

fprintf(2, '\n');
fprintf(2, 'Wait for results\n');
for iter=1:numcalls, 
  fprintf(2, '[ a, wr ,wi ,vl, vr ,info  ] = gridsolve_nb(''wait'',sid{%d}) \n', iter);
  [ a, wr ,wi ,vl, vr ,info ] = gridsolve_nb('wait', sid{iter});
  % fprintf('Checking results...\n');
  %  w = wr + i *wi;
  %  if (max(real(eig(data{iter})) - real(w)) < eps),
  e = gridsolve_err();
  if (e ~= 0),
    fprintf(2, 'DGEEV failed %s', gs_error_string(e));
  else
    fprintf(2, 'DGEEV completed\n');
  end  

end;

fprintf(2, '\n');



