fprintf(2, '------------- \n')
fprintf(2, 'GridSolve DEMO \n')
fprintf(2, 'This demo will run the SuperLU sparse matrix examples. \n')
fprintf(2, 'Here''s what the matrix looks like. \n')

clear
[A,rhs]=generate(9);
A=[A,0*A;0*A,A];
rhs=[rhs;rhs];
[m,n]=size(A);
figure(1), spy(A) 
% pause; fprintf(2, 'Hit return to continue. \n')
pause(3);

[m,n]=size(A);
fprintf(2, 'Matrix A is [%d,%d] with %d non-zeros \n', m,n,nnz(A));
fprintf(2, '[ x ] = gs_call (''dgssv_superlu'', nnz(A), A, m, n, rhs)\n');
[ x ] = gs_call ('dgssv_superlu', nnz(A), A, m, n, rhs);

[e] = gs_get_last_error;
if (e ~= 0)
  fprintf(2,'%s\n',gs_error_string(e))
else
  fprintf(2, '** SuperLU Completed .. verifying results **\n')  
  % r=norm(full(A*x-rhs))/(norm(full(A))*norm(full(x))*eps);
  r = max(A*x-rhs);
  if ( r > 10.0 )
    fprintf(2, '** SuperLU Failure **')
    r
  else
    fprintf(2, '** SuperLU Passed Tests **\n')
  end
end
