function varargout = myquad(varargin)
% MYQUAD Application M-file for myquad.fig
%    FIG = MYQUAD launch myquad GUI.
%    MYQUAD('callback_name', ...) invoke the named callback.

% Last Modified by GUIDE v2.0 08-Jan-2002 13:28:09

if nargin == 0  % LAUNCH GUI
    
    fig = openfig(mfilename,'reuse');
    
    % Generate a structure of handles to pass to callbacks, and store it. 
    handles = guihandles(fig);
    guidata(fig, handles);
    
    if nargout > 0
        varargout{1} = fig;
    end
    
elseif ischar(varargin{1}) % INVOKE NAMED SUBFUNCTION OR CALLBACK
    
    try
        [varargout{1:nargout}] = feval(varargin{:}); % FEVAL switchyard
    catch
        disp(lasterr);
    end
    
end


%| ABOUT CALLBACKS:
%| GUIDE automatically appends subfunction prototypes to this file, and 
%| sets objects' callback properties to call them through the FEVAL 
%| switchyard above. This comment describes that mechanism.
%|
%| Each callback subfunction declaration has the following form:
%| <SUBFUNCTION_NAME>(H, EVENTDATA, HANDLES, VARARGIN)
%|
%| The subfunction name is composed using the object's Tag and the 
%| callback type separated by '_', e.g. 'slider2_Callback',
%| 'figure1_CloseRequestFcn', 'axis1_ButtondownFcn'.
%|
%| H is the callback object's handle (obtained using GCBO).
%|
%| EVENTDATA is empty, but reserved for future use.
%|
%| HANDLES is a structure containing handles of components in GUI using
%| tags as fieldnames, e.g. handles.figure1, handles.slider2. This
%| structure is created at GUI startup using GUIHANDLES and stored in
%| the figure's application data using GUIDATA. A copy of the structure
%| is passed to each callback.  You can store additional information in
%| this structure at GUI startup, and you can change the structure
%| during callbacks.  Call guidata(h, handles) after changing your
%| copy to replace the stored original so that subsequent callbacks see
%| the updates. Type "help guihandles" and "help guidata" for more
%| information.
%|
%| VARARGIN contains any extra arguments you have passed to the
%| callback. Specify the extra arguments by editing the callback
%| property in the inspector. By default, GUIDE sets the property to:
%| <MFILENAME>('<SUBFUNCTION_NAME>', gcbo, [], guidata(gcbo))
%| Add any extra arguments after the last argument, before the final
%| closing parenthesis.
%-------------------------------------------------------


%--------------------------------------------------------
function popupmenu1_Callback(h,eventdate,handles,varargin)

%---------------------------------------------------------
function edit3_Callback(h,eventdate,handles,varargin)
string1= get(h,'String');


%---------------------------------------------------------
function edit4_Callback(h,eventdate,handles,varargin)




%---------------------------------------------------------
function edit5_Callback(h,eventdate,handles,varargin)




%---------------------------------------------------------
function edit6_Callback(h,eventdate,handles,varargin)

% --------------------------------------------------------------------
function varargout = pushbutton6_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.pushbutton6.
delete(gcf);

string2=get(handles.edit3,'string');
if ~isa(string2,'function_handle') & ~isa(string2,'inline') & exist(string2)~=2
    f = inline(string2);
end

x1=str2double(get(handles.edit4,'string'));
x2=str2double(get(handles.edit5,'string'));
stp=str2double(get(handles.edit6,'string'));
xx=x1:abs(x2-x1)/100000:x2;
yy=feval(f,xx);


val = get(handles.popupmenu1,'value');
switch val
  case 1
    zoom = 4;
  case 2
    zoom = 3;
  case 3
    zoom = 2;
  case 4
    zoom = 1;
  case 5
    zoom = 1/2;
  case 6
    zoom = 1.0/3.0;
  case 7
    zoom = 1.0/4.0;
end


rang = x2-x1;
colormap jet(256);
plot(xx,yy)
set(gcf,'DoubleBuffer','on')
drawnow 
refresh;
hold on


if (mod(rang,stp)== 0)
    x=x1:stp:x2;
    y=feval(f,x);
    num = rang/stp;
    flag=1;
else
    x=x1:stp:x2;
    num = ceil(rang/stp); 
    x(num+1)=x2;
    y=feval(f,x);
    flag =2;
end

request = zeros(num,1);


%if (flag==1)
%  h=axes('XLim',[x1 x2],'YLim',[min(feval(f,x)) max(feval(f,x))],...'position',[0.05 0.05 0.9 0.9],'visible','off');
a = 0;  % total area
for i=1:num
    request(i)=gridsolve_nb('send','area',y(i),y(i+1),stp);
    if (gridsolve_err~=0)
        m = gridsolve_errmsg(gridsolve_err);
        fprintf('Error: %d: %s \n', gridsolve_err, m);
        return;
    end
end

finish = 0;
count = num;
while (1==1)
    if (finish == 1)
        return;
    end
    for i=1:count
        e = gridsolve_nb('probe',request(i));
        if (e == 0),                  % GRPC_NO_ERROR
            a=a+gridsolve_nb('wait',request(i));
            area([x(i),x(i+1)],[feval(f,x(i)),feval(f,x(i+1))]);
            colormap summer
            drawnow
            refresh;
            for j=i:count-1
                request(i)=request(i+1);
            end
            count = count-1;
            if (count == 0 )
                finish = 1;
                t=strcat('Total area is ','******', num2str(a),' *****');
                title(t);
                if(zoom ~= 1)
                    camzoom(zoom);               
                end
                plot(xx,yy)
            end
        elseif (e ~= 11)           % anything but GRPC_NOT_COMPLETED
            m = gridsolve_errmsg(e);
            return;
        end
        
    end    
    
end %%%%%%%%% for while
return;

%end  %%%%%%%%%% if flag == 1


%if flag == 2

%end
% --------------------------------------------------------------------
function varargout = pushbutton7_Callback(h, eventdata, handles, varargin)
% Stub for Callback of the uicontrol handles.pushbutton7.
set(handles.edit3,'String','sqrt(x).*sin(100*x)');
set(handles.edit4,'String','0');
set(handles.edit5,'String','0.5');
set(handles.edit6,'String','0.01');
set(handles.popupmenu1,'value',4);
delete(gcf);

%-----------------------------------------------------------
function varargout = pushbutton8_Callback(h, eventdata, handles, varargin)
pos_size = get(handles.figure1,'Position');
dlg_pos = [pos_size(1)+pos_size(3)/5 pos_size(2)+pos_size(4)/5];
%Removed old yes/no modal dialog box
%user_response = myquadmodaldlg(dlg_pos);
%switch user_response
%  case {'no','cancel'}
%    return
%  case 'yes'
    % Prepare to close GUI application figure
    %                  .
    %                  .
    %                  .
    delete(handles.figure1);
    delete(gcf);
%end


