/**
 * @file
 *
 * This test uses every data type and object type in a blocking 
 * NetSolve call.  The program is invoked as:
 *   c_totaltest [criteria_file]
 * where criteria_file is an optional filename containing the
 * criteria to be sent to the agent.
 */
/* $Id: c_totaltest.c,v 1.8 2006/01/30 17:36:30 yarkhan Exp $ */
/* $UTK_Copyright: $ */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include<stdio.h>
#include<stdlib.h>
#ifdef HAVE_VALUES_H
#include<values.h>
#else
#ifdef HAVE_LIMITS_H
#include <limits.h>
#endif
#ifdef HAVE_FLOAT_H
#include <float.h>
#define MAXDOUBLE DBL_MAX
#endif
#endif
#include<sys/time.h>
#include "netsolve.h"
#include "netsolveclient.h"

#include "totaltest.h"

#include "totaltest_common.c"

int 
main(int argc, char** argv)
{
  int status;
#include "totaltest_arg_decl.c"

  netslmajor("col");

  if(argc == 2)
    netslset_criteria_file(argv[1]);

#include "totaltest_arg_init.c"

  status = netsl("ctotal()", TOTALTEST_ARGLIST);

  if(status < 0) {
    netslerr(status);
    die(EXIT_FAILURE);
  }

#include "totaltest_results.c"

  die(EXIT_SUCCESS);
}
