/**
 * @file
 *
 * This test uses every data type and object type in a non-blocking 
 * NetSolve call.  
 */
/* $Id: c_totaltest_async.c,v 1.7 2006/01/30 17:36:41 yarkhan Exp $ */
/* $UTK_Copyright: $ */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include<stdio.h>
#include<stdlib.h>
#ifdef HAVE_VALUES_H
#include<values.h>
#else
#ifdef HAVE_LIMITS_H
#include <limits.h>
#endif
#ifdef HAVE_FLOAT_H
#include <float.h>
#define MAXDOUBLE DBL_MAX
#endif
#endif
#include<sys/time.h>
#include<unistd.h>
#include "netsolve.h"
#include "netsolveclient.h"

#include "totaltest.h"

#include "totaltest_common.c"

int 
main(int argc, char** argv)
{
  int request, status;
#include "totaltest_arg_decl.c"

  netslmajor("col");

#include "totaltest_arg_init.c"

  status = netslnb("ctotal()", TOTALTEST_ARGLIST);

  if(status < 0) {
    netslerr(status);
    die(EXIT_FAILURE);
  }

  request = status;
  if (request >= 0)
  {
    status = netslpr(request);
    fprintf(stderr,".");
    while(status == NetSolveNotReady)
    {
      sleep(1);
      fprintf(stderr,".");
      fflush(stderr);
      status = netslpr(request);
    }
    fprintf(stderr,"\n");
    if (status == NetSolveOK)
    {
      status = netslwt(request);
    }
  }

  fflush(stdout);
  if(status != NetSolveOK) {
    netslerr(status);
    die(EXIT_FAILURE);
  }

#include "totaltest_results.c"

  die(EXIT_SUCCESS);
}
