#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include "netsolveclient.h"
#include "totaltest.h"

int main(int argc, char *argv[]) {
  double *in_vec, *in_vec1, *out_vec;
  DSI_OBJECT *dvec, *dvec1;
  DSI_FILE *dsi_file;
  int i, count;
  char *host;

  if(argc == 2)
    host = argv[1];
  else
    host = "localhost";

  dsi_file = ns_dsi_open(host, O_CREAT|O_RDWR , 644 , 30000, GS_DSI_IBP);
  if(dsi_file == NULL) {
    fprintf(stderr, "Error opening DSI file.\n");
    die(EXIT_FAILURE);
  }

  in_vec = (double*)malloc(sizeof(double)*10);
  in_vec1 = (double*)malloc(sizeof(double)*10);
  out_vec = (double*)malloc(sizeof(double)*10);

  for(i=0; i<10; i++) {
    in_vec[i] = (double)i;
    in_vec1[i] = (double)(2*i);
    out_vec[i] = 0.0;
  }

  dvec = ns_dsi_write_vector(dsi_file, in_vec, 10, GS_DOUBLE);
  if(dvec == NULL) {
    fprintf(stderr, "Error writing in_vec to DSI file.\n");
    die(EXIT_FAILURE);
  }

  dvec1 = ns_dsi_write_vector(dsi_file, in_vec1, 10, GS_DOUBLE);
  if(dvec1 == NULL) {
    fprintf(stderr, "Error writing in_vec1 to DSI file.\n");
    die(EXIT_FAILURE);
  }

  count = ns_dsi_read_vector(dvec1, out_vec, 10, GS_DOUBLE);
  if(count < 0) {
    fprintf(stderr, "Error reading dvec1 from DSI file.\n");
    die(EXIT_FAILURE);
  }
  else {
    printf("count: %d\n", count);
    for(i=0; i<10; i++)
      printf("%f ", out_vec[i]);
    printf("\n");
  }

  count = ns_dsi_read_vector(dvec, out_vec, 10, GS_DOUBLE);
  if(count < 0) {
    fprintf(stderr, "Error reading dvec from DSI file.\n");
    die(EXIT_FAILURE);
  }
  else {
    printf("count: %d\n", count);
    for(i=0; i<10; i++)
      printf("%f ", out_vec[i]);
    printf("\n");
  }

  ns_dsi_close(dsi_file);

  exit(EXIT_SUCCESS);
}
