#include <math.h>

#define GS_NE(x,y) (fabs((x)-(y)) > 0.1)
#define GS_EQ(x,y) (fabs((x)-(y)) < 0.1)

#define die(x) \
   { printf("Result: %s\n", (x) == EXIT_SUCCESS ? "Success" : "Failure"); \
     exit(x); }

#define IVEC_SIZE      3
#define FVEC_SIZE      3
#define DVEC_SIZE      3
#define SCMP_VEC_SIZE  3
#define DCMP_VEC_SIZE  3
#define CVEC_SIZE      3

#define MAT_M 2
#define MAT_N 3

char
  * parse_totaltest_cmdline(int, char *[]);

int 
  print_ivec(char *, int *, int),
  print_fvec(char *, float *, int),
  print_dvec(char *, double *, int),
  print_scmp_vec(char *, gs_scomplex *, int),
  print_dcmp_vec(char *, gs_dcomplex *, int),
  print_cvec(char *, char *, int),
  print_imat(char *, int *, int, int),
  print_dmat(char *, double *, int, int),
  print_scmp_mat(char *, gs_scomplex *, int, int),
  print_dcmp_mat(char *, gs_dcomplex *, int, int),
  print_fmat(char *, float *, int, int),
  print_cmat(char *, char *, int, int);

#define TOTALTEST_ARGLIST int_in, &int_inout, &int_out, \
    float_in, &float_inout, &float_out, \
    double_in, &double_inout, &double_out, \
    scmp_in, &scmp_inout, &scmp_out, \
    dcmp_in, &dcmp_inout, &dcmp_out, \
    char_in, &char_inout, &char_out, \
    ivec_in, ivec_inout, ivec_out, IVEC_SIZE, \
    fvec_in, fvec_inout, fvec_out, FVEC_SIZE, \
    dvec_in, dvec_inout, dvec_out, DVEC_SIZE, \
    scmp_vec_in, scmp_vec_inout, scmp_vec_out, SCMP_VEC_SIZE, \
    dcmp_vec_in, dcmp_vec_inout, dcmp_vec_out, DCMP_VEC_SIZE, \
    cvec_in, cvec_inout, cvec_out, CVEC_SIZE, \
    imat_in, imat_inout, imat_out, MAT_M, MAT_N, \
    fmat_in, fmat_inout, fmat_out, MAT_M, MAT_N, \
    dmat_in, dmat_inout, dmat_out, MAT_M, MAT_N, \
    scmp_mat_in, scmp_mat_inout, scmp_mat_out, MAT_M, MAT_N, \
    dcmp_mat_in, dcmp_mat_inout, dcmp_mat_out, MAT_M, MAT_N, \
    cmat_in, cmat_inout, cmat_out, MAT_M, MAT_N
