/**
 * @file
 *
 * This program will ask the agent to terminate.  The usage is:
 *    GS_killagent <agent name>
 *
 */
/* $Id: gs_kill_agent.c,v 1.22 2008/09/25 15:47:19 seymour Exp $ */
/* $UTK_Copyright: $ */

#include "utility.h"

#include <stdlib.h>
#include <string.h>

#include "comm_data.h"
#include "comm_basics.h"
#include "general.h"
#include "server.h"
#include "gs_tools.h"

/**
 * Entry point for GS_killagent.
 *
 * @param argc -- arg count
 * @param argv -- array of command line args
 *
 * @returns EXIT_SUCCESS on success, EXIT_FAILURE on error.
 */

int
main(int argc, char **argv)
{
  int agentport;

  if(argc < 2) {
    fprintf(stderr,"Usage: GS_killagent <agent name>\n");
    exit(EXIT_FAILURE);
  }

  agentport = getenv_int("GRIDSOLVE_AGENT_PORT", GRIDSOLVE_AGENT_PORT_DEFAULT);

  gs_kill_agent(argv[1], agentport);

  exit(EXIT_SUCCESS);
}
