/**
 * @file
 *
 * A replacement for the version of __eprintf in libgcc.a if libgcc.a
 * is missing.  This may be needed to prevent some errors in linking
 * Solaris cc with standard gcc. In this code, this is needed with sqlite
 * is compiled with gcc, then the rest of the code is compiled with
 * Solaris cc.
 */
/* $Id: eprintf.c,v 1.4 2006/05/12 18:18:19 yarkhan Exp $ */
/* $UTK_Copyright: $ */

#include <stdio.h>
#include <stdlib.h>

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#ifndef HAVE___EPRINTF

/**
 * Print to stderr and abort.
 *
 * @param fmt -- print format specifier (as with printf)
 * @param expr -- string to print
 * @param line -- line number
 * @param file -- file name
 *
 */

void __eprintf (const char *fmt, const char *expr, int line, const char *file)
{
  fprintf (stderr, fmt, expr, line, file);
  fflush (stderr);

  abort ();
}

#endif /* HAVE___EPRINTF */
