/**
 * @file
 *
 * This file contains code to get a user's login name.
 *
 */
/* $Id: get_login_name.c,v 1.8 2007/03/26 15:40:53 seymour Exp $ */
/* $UTK_Copyright: $ */

#include <stdlib.h>
#include <stdio.h>

#include "portability.h"

/**
 * Get the user's login name.
 *
 * @returns newly allocated string containing the user's login name.
 *    NULL on failure.
 */

char *gs_get_login_name() {
  char *name;

  if((name = getenv("LOGNAME")))
    return strdup(name);

  if((name = getenv("USER")))
    return strdup(name);

#ifdef HAVE_GETPWUID
# ifdef HAVE_GETEUID
  if((name = ((struct passwd *)getpwuid(geteuid()))->pw_name))
    return strdup(name);
# endif
#endif

#ifdef HAVE_GETLOGIN
  if((name = getlogin()))
    return strdup(name);
#endif

  return strdup("unknown");
}
