#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

#include "utility.h"

/* Check for an integer in an environment variable, returning the
   integer value or a provided default value */

int 
getenv_int(char* name, int defval)
{
  char *envstr = NULL;
  long int longval = -1;
  char *endptr;
  extern int errno;

  if (name == NULL) return defval;

  /* Env variable does not exist */
  if ((envstr = getenv(name)) == NULL) return defval;

  /* Convert to long, checking for errors */
  longval = strtol(envstr, &endptr, 10);
  if ((errno == ERANGE) || (longval==0 && endptr==envstr))
    return defval;

  return (int)longval;
}
