<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
  <html>
  <title>GridSolve Server Information</title>
  <body style="font-family:Arial,helvetica,sans-serif;font-size:12pt;
        background-color:#EEEEEE">
    <h2>GridSolve Server Information</h2>

    <a href="problemlist?">Service list</a>
    <br/>
    <a href="status?">Server list</a>
    <p/>

    <xsl:for-each select="server_information/server_list/server">
    <xsl:sort select="hostname"/>
      <xsl:variable name="cid" select="normalize-space(componentid)"/>
      <div style="background-color:lightsteelblue;color:white;padding:4px">
        <span style="font-weight:bold;color:white">
        <xsl:value-of select="hostname"/></span>
      </div>

      <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
        Component Identifier: <xsl:value-of select="componentid"/>
      </div>

      <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
        Address: <xsl:value-of select="ipaddress"/>:<xsl:value-of select="port"/>
      </div>

      <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
         Proxy Address: <xsl:value-of select="proxyip"/>:
         <xsl:value-of select="proxyport"/>
      </div>

      <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
         Arch: <xsl:value-of select="arch"/>
      </div>

      <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
         Data format: <xsl:value-of select="data_format"/>
      </div>

      <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
         Kflop/s: <xsl:value-of select="kflops"/>
      </div>

      <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
         Workload: <xsl:value-of select="workload"/>
      </div>

      <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
         Number of services: <xsl:value-of select="nproblems"/>
      </div>

      <div style="margin-left:20px;margin-bottom:1em;font-size:10pt">
         Reporting to agent: <xsl:value-of select="agenthost"/>:
         <xsl:value-of select="agentport"/>
      </div>
    </xsl:for-each>

    Services provided by this server:
    <xsl:for-each select="server_information/problem_list/problem">
    <xsl:sort select="@name"/>
      <xsl:variable name="pname" select="normalize-space(@name)"/>
      <div style="margin-left:20px;margin-bottom:1em;font-size:10pt">
        <a href="probleminfo?{$pname}">
        <xsl:value-of select="@name"/></a> --
        <xsl:value-of select="@description"/>
      </div>
    </xsl:for-each>
  </body>
  </html>
</xsl:template>
</xsl:stylesheet>
