<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
  <html>
  <title>
    <xsl:if test="system_status/problem_list/problem">
      GridSolve Service List
    </xsl:if>
    <xsl:if test="system_status/server_list/server">
      GridSolve System Status
    </xsl:if>
  </title>
  <head>
  <script>
    function toggle( targetId ){
      if (document.getElementById){
        target = document.getElementById( targetId );
        if (target.style.display == "none"){
          target.style.display = "";
        } else {
          target.style.display = "none";
        }
      }
    }
  </script>
  </head>

  <body style="font-family:Arial,helvetica,sans-serif;font-size:12pt;
        background-color:#EEEEEE">
    <h2>GridSolve System Status</h2>

    <xsl:for-each select="system_status/agent_stats">
       Agent: 
       <xsl:value-of select="agent_name"/>:<xsl:value-of select="agent_port"/>
       <br/>
    </xsl:for-each>

    <xsl:for-each select="system_status/agent_stats/agent_uptime">
       Uptime:
       <xsl:call-template name="show_uptime_num">
          <xsl:with-param name="label">day</xsl:with-param>
          <xsl:with-param name="num"><xsl:value-of select="days"/></xsl:with-param>
       </xsl:call-template>
       <xsl:call-template name="show_uptime_num">
          <xsl:with-param name="label">hour</xsl:with-param>
          <xsl:with-param name="num"><xsl:value-of select="hours"/></xsl:with-param>
       </xsl:call-template>
       <xsl:call-template name="show_uptime_num">
          <xsl:with-param name="label">minute</xsl:with-param>
          <xsl:with-param name="num"><xsl:value-of select="minutes"/></xsl:with-param>
       </xsl:call-template>
       <xsl:call-template name="show_uptime_num">
          <xsl:with-param name="label">second</xsl:with-param>
          <xsl:with-param name="num"><xsl:value-of select="seconds"/></xsl:with-param>
       </xsl:call-template>
    </xsl:for-each>
    <br/>
 
    <xsl:if test="system_status/server_list/server">
      <a href="problemlist?">Service list</a>
      <h3>Servers:</h3>
    </xsl:if>
    <xsl:for-each select="system_status/server_list/server">
    <xsl:sort select="hostname"/>
      <xsl:variable name="cid" select="normalize-space(componentid)"/>
      <div style="background-color:lightsteelblue;color:white;padding:4px;margin-bottom:0.3em">
        <span style="font-weight:bold;color:white">

        <a href="#" 
           STYLE="text-decoration: none"
           onclick='javascript:toggle("{$cid}-desc");return false;' 
           title="Show Description" 
           onmouseover='window.status="Show Description";return true;' 
           onmouseout='window.status="";return true;'>
           <small>[+] </small>
        </a>
        <xsl:value-of select="hostname"/>
        <noscript>
          <a href="serverinfo?{$cid}">
            [details]
          </a>
        </noscript>
        </span>
      </div>

      <div style="display:none" id="{$cid}-desc">

        <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
          Component Identifier: <xsl:value-of select="componentid"/>
        </div>

        <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
          Address: <xsl:value-of select="ipaddress"/>:<xsl:value-of select="port"/>
          <xsl:if test="proxyport != 0">
            <span style="font-style:italic">
              (Proxy Address: <xsl:value-of select="proxyip"/>:
                 <xsl:value-of select="proxyport"/>)
            </span>
          </xsl:if>
        </div>

        <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
           Arch: <xsl:value-of select="arch"/>
        </div>

        <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
           Data format: <xsl:value-of select="data_format"/>
        </div>

        <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
           Kflop/s: <xsl:value-of select="kflops"/>
        </div>

        <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
           Workload: <xsl:value-of select="workload"/>
        </div>

        <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
           Number of services: <xsl:value-of select="nproblems"/>
        </div>

        <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
           Reporting to agent: <xsl:value-of select="agenthost"/>:
           <xsl:value-of select="agentport"/>
        </div>

        <div style="margin-left:20px;margin-bottom:1em;font-size:10pt">
           <a href="serverinfo?{$cid}">More details about this server</a>
        </div>
      </div>
    </xsl:for-each>

    <xsl:if test="system_status/problem_list/problem">
      <a href="status?">Server list</a>
      <h3>Services:</h3>
    </xsl:if>
    <xsl:for-each select="system_status/problem_list/problem">
    <xsl:sort select="@name"/>
      <xsl:variable name="pname" select="normalize-space(@name)"/>
      <div style="background-color:lightsteelblue;color:white;padding:4px;margin-bottom:0.3em">
        <span style="font-weight:bold;color:white">

        <a href="#" 
           STYLE="text-decoration: none"
           onclick='javascript:toggle("{$pname}-desc");return false;' 
           title="Show Description" 
           onmouseover='window.status="Show Description";return true;' 
           onmouseout='window.status="";return true;'>
           <small>[+] </small>
        </a>
        <xsl:value-of select="@name"/>
        </span>
      </div>

      <div style="display:none" id="{$pname}-desc">

        <div style="margin-left:20px;margin-bottom:0em;font-size:10pt">
          <xsl:value-of select="@description"/>
        </div>

        <div style="margin-left:20px;margin-bottom:1em;font-size:10pt">
           <a href="probleminfo?{$pname}">More details about this service</a>
        </div>

      </div>

    </xsl:for-each>

  </body>
  </html>
</xsl:template>

<xsl:template name="show_uptime_num">
  <xsl:param name="label"/>
  <xsl:param name="num"/>
  <xsl:choose>
    <xsl:when test="$num &gt; 1">
      <xsl:value-of select="$num"/><xsl:text> </xsl:text> 
      <xsl:value-of select="$label"/><xsl:text>s </xsl:text>
    </xsl:when>
    <xsl:when test="$num &gt; 0">
      <xsl:value-of select="$num"/><xsl:text> </xsl:text> 
      <xsl:value-of select="$label"/><xsl:text> </xsl:text>
    </xsl:when>
  </xsl:choose>
</xsl:template>

</xsl:stylesheet>
